import java.awt.*;
import java.io.*;
import java.applet.*;
import java.net.*;
import java.awt.event.*;
import javax.swing.*;
public class PipeLine extends JApplet implements Runnable,KeyListener,MouseListener{
    Thread t;
    SCanvasPipeLine sc;
    int action=5;
    Image field1;
    Image field2;
    Image field3;
    Image pipe;
    Image pump;
    Image fob;
    int buildx;
    int buildy;
    boolean bu;
    MediaTracker tracker;
    static JApplet app;
//    boolean running=true;
    private static final long serialVersionUID = -945357493753234036L;
    public void init(){
        app=this;
//        super("Astro Solutions PipeLine Defender");
//System.out.println("running");
        sc=new SCanvasPipeLine(this);
//System.out.println("running2");
        setLayout(null);
        setSize(400,440);
        add(sc);
        sc.setBounds(0,40,400,400);
        field1=PipeLine.getImage("field1.gif");
        field2=PipeLine.getImage("field2.gif");
        field3=PipeLine.getImage("field3.gif");
        pipe=PipeLine.getImage("pipe.gif");
        pump=PipeLine.getImage("pump.gif");
        fob=PipeLine.getImage("fob.gif");
        tracker=new MediaTracker(this);
        tracker.addImage(field1,0);
        tracker.addImage(field2,0);
        tracker.addImage(field3,0);
        tracker.addImage(pipe,0);
        tracker.addImage(pump,0);
        tracker.addImage(fob,0);
        try{
           tracker.waitForID(0);
        }
        catch(Exception me){
        }
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        addMouseListener(this);
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(100);
                if(bu){
                    bu=false;
                    sc.build(buildx,buildy);
                }
                if(action!=5){
                    sc.roll(action);
                    action=5;
                }
            }
            catch(Exception e){};
        }
    }
    public static void main(String[]args){
        new PipeLine();
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        process(e);
    }
    public void keyReleased(KeyEvent e){
    }
    public void mousePressed(MouseEvent me) {
        requestFocus();
        mprocess(me);
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
    }
    public void mprocess(MouseEvent evt){
            if(evt.getX()>360){
                action=0;
            }
            else if(evt.getX()<40){
                action=1;
            }
            else if(evt.getY()>400){
                action=2;
            }
            else if(evt.getY()<80){
                action=3;
            }
            if(evt.getX()<360&&evt.getX()>40&&evt.getY()>80&&evt.getY()<400){
                buildx=evt.getX();
                buildy=evt.getY();
                bu=true;
            }
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
        if(key==27||key==KeyEvent.VK_ESCAPE){
            sc.running=false;
            remove(sc);
            sc=new SCanvasPipeLine(this);
            add(sc);
            sc.setBounds(0,40,400,400);
        }
    }
}
class SCanvasPipeLine extends JPanel implements Runnable{
    Thread t;
    ImFramePipeLine im;
    Graphics h;
    Image img;
    int[][]field=new int[100][100];
    int[][]sfield=new int[50][50];
    int xpos=800;
    int ypos=800;
    int action=5;
    PipeLine pl;
    int buildx;
    int buildy;
    boolean bu;
    Fob[]fob;
    Kugel[]kug;
    int bars;
    boolean berp=true;
    long base=System.currentTimeMillis();
    boolean logo=true;
    boolean running=true;
    private static final long serialVersionUID = -5420818333936776087L;
    public SCanvasPipeLine(PipeLine pl){
        setSize(400,400);
        this.pl=pl;
        im=new ImFramePipeLine();
        img=im.img;
        h=img.getGraphics();
        t=new Thread(this);
        fob=new Fob[400];
        kug=new Kugel[2000];
        for(int i=0;i<300;i++){
            int exo=(int)(Math.random()*2000);
            int eyo=(int)(Math.random()*2000);
            double xpi=(int)(Math.random()*Math.PI*2);
            double xb=Math.sin(xpi)*1;
            double yb=Math.cos(xpi)*1;
            fob[i]=new Fob(exo,eyo,xb,yb);
        }
        for(int i=0;i<50;i++){
            for(int j=0;j<50;j++){
                int s=(int)(Math.random()*10);
                if(s==0)sfield[i][j]=3;
                else if(s>3)sfield[i][j]=2;
                else sfield[i][j]=1;
            }
        }
        sfield[24][24]=0;
        sfield[24][25]=0;
        sfield[25][24]=0;
        sfield[25][25]=0;
        for(int i=0;i<100;i++){
            for(int j=0;j<100;j++){
                int fieldo=sfield[i/2][j/2];
                if(fieldo==0)field[i][j]=1;
                else if(fieldo==3){
                    int w=(int)(Math.random()*10);
                    if(w<5)field[i][j]=3;
                }
                else if(fieldo==2){
                    int w2=(int)(Math.random()*10);
                    if(w2<2)field[i][j]=3;
                }
                else field[i][j]=0;
            }
        }
        sfield[24][24]=6;
        sfield[24][25]=6;
        sfield[25][24]=6;
        sfield[25][25]=6;
        t.start();
    }
    public synchronized void build(int buildx,int buildy){
        this.buildx=buildx;
        this.buildy=buildy-40;
        bu=true;
    }
    public synchronized void roll(int action){
        this.action=action;
    }
    public synchronized void runcontent(){
//System.out.println("getb");
                bars+=getBarrel(field,new int[100][100]);
                if(bu){
                    int bx=xpos+buildx;
                    int by=ypos+buildy;
                    int xpo=bx/20;
                    int ypo=by/20;
                    if(field[xpo][ypo]==0){
                        field[xpo][ypo]=1;
                    }
                    if(field[xpo][ypo]==3){
                        field[xpo][ypo]=2;
                    }
                    bu=false;
                }
                if(action==0&&xpos>=1600)action=5;
                if(action==1&&xpos<=0)action=5;
                if(action==2&&ypos>=1600)action=5;
                if(action==3&&ypos<=0)action=5;
                if(action!=5){
                    if(action==0)xpos+=40;
                    else if(action==1)xpos-=40;
                    else if(action==2)ypos+=40;
                    else if(action==3)ypos-=40;
                    action=5;
                }
//System.out.println("repa");
                logo=false;
    }
    public void run(){
        while(berp&&running){
            try{
                Thread.sleep(100);
                runcontent();
                repaint();
            }
            catch(Exception e){};
        }
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        if(logo)return;
        h.setColor(Color.white);
        h.fillRect(0,0,400,440);
        int anfx=(xpos/40)*40;
        int anfy=(ypos/40)*40;
        int endx=anfx+400;
        int endy=anfy+400;
        int cx=anfx/40;
        int cy=anfy/40;
//System.out.println("1");
        for(int i=anfx;i<endx;i+=40){
            cy=anfy/40;
            for(int j=anfy;j<endy;j+=40){
                h.setColor(Color.blue);
                if(sfield[cx][cy]==1)h.drawImage(pl.field1,i-anfx,j-anfy,this);
                else if(sfield[cx][cy]==2)h.drawImage(pl.field2,i-anfx,j-anfy,this);
                else if(sfield[cx][cy]==3)h.drawImage(pl.field3,i-anfx,j-anfy,this);
                else if(sfield[cx][cy]==6)h.fillRect(i-anfx,j-anfy,40,40);
                cy++;
            }
            cx++;
        }
        cx=anfx/20;
        cy=anfy/20;
//System.out.println("2");
        for(int i=anfx;i<endx;i+=20){
            cy=anfy/20;
            for(int j=anfy;j<endy;j+=20){
                if(field[cx][cy]==1)h.drawImage(pl.pipe,i-anfx,j-anfy,this);
                if(field[cx][cy]==2)h.drawImage(pl.pump,i-anfx,j-anfy,this);
                cy++;
            }
            cx++;
        }
//System.out.println("3");
        for(int i=0;i<300;i++){
            fob[i].x+=fob[i].xdrift;
            fob[i].y+=fob[i].ydrift;
        }
//System.out.println("4");
        for(int i=0;i<300;i++){
            if(fob[i].x<0)fob[i].xdrift=-fob[i].xdrift;
            if(fob[i].x>2000)fob[i].xdrift=-fob[i].xdrift;
            if(fob[i].y<0)fob[i].ydrift=-fob[i].ydrift;
            if(fob[i].y>2000)fob[i].ydrift=-fob[i].ydrift;
            fob[i].x+=fob[i].xdrift;
            fob[i].y+=fob[i].ydrift;
        }
//System.out.println("5");
        for(int i=0;i<300;i++){
            if(Math.random()*100<6){
                int jo=0;
                while(kug[jo]!=null&&jo<2000){
                    jo++;
                }
                if(jo<2000){
                    kug[jo]=new Kugel(fob[i].x,fob[i].y,fob[i].xdrift*6,fob[i].ydrift*6);
                }
            }
        }
//System.out.println("6");
        for(int i=0;i<2000;i++){
            if(kug[i]!=null){
                kug[i].x+=kug[i].xdrift;
                kug[i].y+=kug[i].ydrift;
                if(kug[i].x>=2000||kug[i].x<=0||kug[i].y<=0||kug[i].y>=2000){
                    kug[i]=null;
                }
                else kug[i].dum--;
                if(kug[i]!=null&&kug[i].dum<=0){
                    int xi=((int)kug[i].x)/20;
                    int yi=((int)kug[i].y)/20;
                    if(field[xi][yi]==1||field[xi][yi]==2)field[xi][yi]=0;
                    kug[i]=null;
                }
            }
        }
//System.out.println("7");
        for(int i=0;i<300;i++){
            int xpe=(int)fob[i].x-xpos;
            int ype=(int)fob[i].y-ypos;
            h.drawImage(pl.fob,xpe-10,ype-10,this);
        }
        h.setColor(Color.blue);
//System.out.println("8");
        for(int i=0;i<2000;i++){
            if(kug[i]!=null){
                int xpw=(int)kug[i].x-xpos;
                int ypw=(int)kug[i].y-ypos;
                int dice=kug[i].dum;
                h.fillOval(xpw-dice/2,ypw-dice/2,dice,dice);
            }
        }
//System.out.println("9");
        h.setColor(Color.white);
        h.fillRect(10,30,100,17);
        h.setColor(Color.black);
        h.drawString("Barrels: "+bars,10,40);
        long cur=System.currentTimeMillis();
        int diff=(int)((cur-base)/1000);
        h.setColor(Color.white);
        h.fillRect(10,60,100,17);
        h.setColor(Color.black);
        h.drawString("Time: "+(1000-diff),10,70);
        if((1000-diff)<0)berp=false;
        g.drawImage(img,0,0,this);
//        paint(g);
//System.out.println("10");
    }
    public int getBarrel(int[][]field,int[][]threes){
        boolean[][]trace=new boolean[100][100];
        Queue q=new Queue();
        Quelem a1=new Quelem(48,48,null);
        Quelem a2=new Quelem(48,49,null);
        Quelem a3=new Quelem(48,50,null);
        Quelem a4=new Quelem(48,51,null);
        Quelem a5=new Quelem(51,48,null);
        Quelem a6=new Quelem(51,49,null);
        Quelem a7=new Quelem(51,50,null);
        Quelem a8=new Quelem(51,51,null);
        Quelem a9=new Quelem(49,48,null);
        Quelem a10=new Quelem(50,48,null);
        Quelem a11=new Quelem(49,51,null);
        Quelem a12=new Quelem(50,51,null);
        q.addQ(a1);
        q.addQ(a2);
        q.addQ(a3);
        q.addQ(a4);
        q.addQ(a5);
        q.addQ(a6);
        q.addQ(a7);
        q.addQ(a8);
        q.addQ(a9);
        q.addQ(a10);
        q.addQ(a11);
        q.addQ(a12);
        Quelem tar=null;
        while(!q.isEmpty()){
            Quelem qw=q.getQ();
            if(qw.x-1>=0&&qw.x+1<100&&qw.y-1>=0&&qw.y+1<100&&threes[qw.x][qw.y]<3){
                if(field[qw.x][qw.y]==2&&threes[qw.x][qw.y]==0){
                    tar=qw;
                    q.flush();
                }
                else{
                    if(!trace[qw.x-1][qw.y]&&(field[qw.x-1][qw.y]==1||field[qw.x-1][qw.y]==2)){
                        q.addQ(new Quelem(qw.x-1,qw.y,qw));
                        trace[qw.x-1][qw.y]=true;
                    }
                    if(!trace[qw.x+1][qw.y]&&(field[qw.x+1][qw.y]==1||field[qw.x+1][qw.y]==2)){
                        q.addQ(new Quelem(qw.x+1,qw.y,qw));
                        trace[qw.x+1][qw.y]=true;
                    }
                    if(!trace[qw.x][qw.y-1]&&(field[qw.x][qw.y-1]==1||field[qw.x][qw.y-1]==2)){
                        q.addQ(new Quelem(qw.x,qw.y-1,qw));
                        trace[qw.x][qw.y-1]=true;
                    }
                    if(!trace[qw.x][qw.y+1]&&(field[qw.x][qw.y+1]==1||field[qw.x][qw.y+1]==2)){
                        q.addQ(new Quelem(qw.x,qw.y+1,qw));
                        trace[qw.x][qw.y+1]=true;
                    }
                }
            }
        }
        if(tar!=null){
            while(tar!=null){
                threes[tar.x][tar.y]++;
                tar=tar.fore;
            }
            return 1+getBarrel(field,threes);
        }
        return 0;
    }
}
class Queue{
    Quelem first;
    Quelem last;
    public boolean isEmpty(){
        return (first==null);
    }
    public void flush(){
        first=null;
    }
    public void addQ(Quelem q){
        if(first==null){
            first=q;
            last=q;
        }
        else{
            last.next=q;
            last=last.next;
        }
    }
    public Quelem getQ(){
        Quelem ret=first;
        first=first.next;
        return ret;
    }
}
class Quelem{
    Quelem next;
    Quelem fore;
    int x;
    int y;
    public Quelem(int x,int y,Quelem fore){
        this.x=x;
        this.y=y;
        this.fore=fore;
    }
}
class ImFramePipeLine extends JFrame{
    Image img;
    private static final long serialVersionUID = -2195374714983748007L;
    public ImFramePipeLine(){
        pack();
        img=createImage(600,600);
    }
}
class Fob{
    double x;
    double y;
    double xdrift;
    double ydrift;
    public Fob(double x,double y,double xdrift,double ydrift){
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
    }
}
class Kugel{
    double x;
    double y;
    double xdrift;
    double ydrift;
    int dum;
    public Kugel(double x,double y,double xdrift,double ydrift){
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        dum=16;
    }
}
