import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
public class Race42 extends JApplet implements KeyListener{
    SCanvasRace42 sc;
    KeyboardMapperAppletSwing km=null;
    static Image background;
    static Image flyer1;
    static Image flyer2;
    static Image stone;
    static Image img;
    MediaTracker tracker;
    static JApplet app;
    static Race42 race;
    private static final long serialVersionUID = -3609938947018604452L;
    public void init(){
        app=this;
        race=this;
        setSize(400,440);
        ImFrameRace42 imf=new ImFrameRace42();
        img=imf.img;
        background=Race42.getImage("background.gif");
        flyer1=Race42.getImage("flyer1.gif");
        flyer2=Race42.getImage("flyer2.gif");
        stone=Race42.getImage("stone.gif");
        tracker=new MediaTracker(this);
        tracker.addImage(background,0);
        tracker.addImage(flyer1,0);
        tracker.addImage(flyer2,0);
        tracker.addImage(stone,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception me){
        }
        sc=new SCanvasRace42();
        add(sc);
        sc.setBounds(0,40,400,400);
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public static void main(String[]args){
        new Race42();
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(sc!=null){
            sc.process(this,e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
        if(km!=null&&km.applyb){
            key=km.getKeyCode(key);
        }
//System.out.println("key: "+key);
            if(key==38){
                sc.y1minus();
            }
            if(key==37){
                sc.x1minus();
            }
            if(key==40){
                sc.y1plus();
            }
            if(key==39){
                sc.x1plus();
            }
            if(key==83){
                sc.y2minus();
            }
            if(key==89){
                sc.x2minus();
            }
            if(key==88){
                sc.y2plus();
            }
            if(key==67){
                sc.x2plus();
            }
            if(key==32||key==27||key==KeyEvent.VK_ESCAPE){
                sc.newstart();
            }
            if(false&&(key==27||key==KeyEvent.VK_ESCAPE)){
                remove(sc);
                sc.running=false;
                sc=new SCanvasRace42();
                add(sc);
                sc.setBounds(0,40,400,400);
            }
    }
}
class SCanvasRace42 extends JPanel implements Runnable{
    Thread t;
    Graphics h;
    int p1x=150;
    int p2x=150;
    int p1y=100;
    int p2y=100;
    int x1drift=0;
    int y1drift=0;
    int x2drift=0;
    int y2drift=0;
    int wait1=0;
    int wait2=0;
    int[][]stones=new int[200][10];
    boolean running=true;
    private static final long serialVersionUID = 1903196034583730549L;
    public SCanvasRace42(){
        t=new Thread(this);
        h=Race42.img.getGraphics();
        for(int i=0;i<200;i++){
            for(int j=0;j<10;j++){
                if(((int)(Math.random()*10)==0)){
                    stones[i][j]=1;
                }
            }
        }
        t.start();
    }
    public void newstart(){
        t=new Thread(this);
        for(int i=0;i<200;i++){
            for(int j=0;j<10;j++){
                if(((int)(Math.random()*10)==0)){
                    stones[i][j]=1;
                }
                else{
                    stones[i][j]=0;
                }
            }
        }
        p1x=150;
        p2x=150;
        p1y=100;
        p2y=100;
        x1drift=0;
        y1drift=0;
        x2drift=0;
        y2drift=0;
        wait1=0;
        wait2=0;
        running=true;
//        t.start();
    }
    public void x1plus(){
        if(x1drift<=8)x1drift++;
    }
    public void x2plus(){
        if(x2drift<=8)x2drift++;
    }
    public void y1plus(){
        if(y1drift<=8)y1drift++;
    }
    public void y2plus(){
        if(y2drift<=8)y2drift++;
    }
    public void x1minus(){
        if(x1drift>=-8)x1drift--;
    }
    public void x2minus(){
        if(x2drift>=-8)x2drift--;
    }
    public void y1minus(){
        if(y1drift>=-8)y1drift--;
    }
    public void y2minus(){
        if(y2drift>=-8)y2drift--;
    }
    public synchronized void process(Race42 ra,KeyEvent e){
        ra.process(e);
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.white);
        h.fillRect(-p1x+150-400,0,400,200);
        h.fillRect(-p2x+150-400,200,400,200);
        h.fillRect(-p1x+150-400+4000,0,400,200);
        h.fillRect(-p2x+150-400+4000,200,400,200);
        h.drawImage(Race42.background,-p1x+0,0,this);
        h.drawImage(Race42.background,-p2x+0,200,this);
        for(int i=0;i<200;i++){
            for(int j=0;j<10;j++){
                if(stones[i][j]==1){
                    h.drawImage(Race42.stone,-p1x+i*20,j*20,this);
                    h.drawImage(Race42.stone,-p2x+i*20,200+j*20,this);
                    if(p1x+150>=i*20&&p1x+150<(i+1)*20&&p1y>=j*20&&p1y<=(j+1)*20){
                        wait1=50;
                        stones[i][j]=0;
                    }
                    if(p2x+150>=i*20&&p2x+150<(i+1)*20&&p2y>=j*20&&p2y<=(j+1)*20){
                        wait2=50;
                        stones[i][j]=0;
                    }
                }
            }
        }
        if(p1y>200){
            wait1=100;
            y1drift=0;
            p1y=200;
        }
        if(p2y>200){
            wait2=100;
            y2drift=0;
            p2y=200;
        }
        if(p1y<0){
            wait1=100;
            y1drift=0;
            p1y=0;
        }
        if(p2y<0){
            wait2=100;
            y2drift=0;
            p2y=0;
        }
        h.drawImage(Race42.flyer1,140+(p1x-p2x),190+p1y,this);
        h.drawImage(Race42.flyer1,140,p1y-10,this);
        h.drawImage(Race42.flyer2,140+(p2x-p1x),p2y-10,this);
        h.drawImage(Race42.flyer2,140,p2y+190,this);
        h.setColor(Color.black);
        if(wait1==0){
            p1x=p1x+x1drift;
            p1y=p1y+y1drift;
        }
        else{
            wait1--;
            h.drawString("Zeitstrafe: "+wait1,10,10);
        }
        if(wait2==0){
            p2x=p2x+x2drift;
            p2y=p2y+y2drift;
        }
        else{
            wait2--;
            h.drawString("Zeitstrafe: "+wait2,10,210);
        }
        if(p1x+150>4000){
            h.drawString("Player 1 won",10,50);
            running=false;
        }
        if(p2x+150>4000){
            h.drawString("Player 2 won",10,250);
            running=false;
        }
        g.drawImage(Race42.img,0,0,this);
//        paint(g);
    }
    public void run(){
        setVisible(false);
        Race42.race.km=new KeyboardMapperAppletSwing(Race42.race);
        Race42.race.add(Race42.race.km);
        Race42.race.km.setBounds(0,40,400,400);
        Race42.race.km.setVisible(true);
        while(!Race42.race.km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        setVisible(true);
        while(true){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){};
            if(running){
                repaint();
            }
        }
    }
}
class ImFrameRace42 extends JFrame{
    Image img;
    private static final long serialVersionUID = -5978993501548875638L;
    public ImFrameRace42(){
        pack();
        img=createImage(4000,400);
    }
}
class KeyboardMapperAppletSwing extends JPanel implements ActionListener,KeyListener,MouseListener{
    JLabel info;
    ListBox l;
    JButton remove;
    JButton addspecial;
    JButton apply;
    JButton cancel;
    JButton dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    JApplet applet;
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    private static final long serialVersionUID = 5772434866526097156L;
    public KeyboardMapperAppletSwing(JApplet applet){
        setSize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new JLabel("");
        l=new ListBox();
        remove=new JButton("remove");
        addspecial=new JButton("add special key");
        apply=new JButton("apply");
        cancel=new JButton("cancel");
        dontapply=new JButton("don't apply");
        add(info);
        add(l);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.setBounds(10,10,380,27);
        l.setBounds(10,40,380,170);
        remove.setBounds(10,250,80,27);
        addspecial.setBounds(10,280,380,27);
        apply.setBounds(10,310,80,27);
        cancel.setBounds(210,310,80,27);
        dontapply.setBounds(10,340,160,27);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
        remove.addActionListener(this);
        addspecial.addActionListener(this);
        apply.addActionListener(this);
        cancel.addActionListener(this);
        dontapply.addActionListener(this);
        addKeyListener(this);
        addMouseListener(this);
        info.setOpaque(true);
        info.setBackground(Color.white);
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public synchronized void mousePressed(MouseEvent me) {
        requestFocus();
        l.click(me.getX()-10,me.getY()-40);
        l.repaint();
    }
    public synchronized void mouseReleased(MouseEvent e) {
    }
    public synchronized void mouseExited(MouseEvent e) {
    }
    public synchronized void mouseEntered(MouseEvent e) {
    }
    public synchronized void mouseClicked(MouseEvent e) {
    }
    public int getKeyCode(int a){
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(alias[i]==a){
                return key[i];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.reset();
        int n=key.length;
        for(int i=0;i<n;i++){
            l.addElement("special key "+alias[i]+" alias for "+key[i]);
        }
        l.repaint();
    }
    public void loadfirst(){
        try{
            FileInputStream fis=new FileInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
        }
    }
    public void load(String filename){
        try{
            FileInputStream fis=new FileInputStream(filename);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                kmt.addspecial(inp,inp2);
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            int n=alias.length;
            for(int i=0;i<n;i++){
                l.addElement("special key "+alias[i]+" alias for "+key[i]);
            }
            l.repaint();
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public synchronized void keyPressed(KeyEvent e){
        requestFocus();
        int ekey=e.getKeyCode();
        if(kstatus==1){
            aliasx=ekey;
            kstatus=2;
            info.setText("type key");
        }
        else if(kstatus==2){
            int keyx=ekey;
            kstatus=0;
            info.setText("special key added");
            info.setBackground(Color.white);
            kmt.addspecial(""+aliasx,""+keyx);
            l.addElement("special key "+aliasx+" alias for "+keyx);
            l.repaint();
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==remove){
            int ind=l.getSelectedIndex();
            if(ind!=-1){
                l.removeElementAt(ind);
                kmt.remove(ind);
                l.repaint();
            }
        }
        if(evt.getSource()==addspecial){
            info.setText("type alias");
            kstatus=1;
            info.setBackground(Color.yellow);
            requestFocus();
        }
        if(evt.getSource()==apply){
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            applyb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==cancel){
            restorekmt();
            cancelb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==dontapply){
            applyb=false;
            info.setText("KeyboardMapper isn't applied");
        }
    }
}
class KeyMapperTable{
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new int[0];
        key=new int[0];
        special=new boolean[0];
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        int[]aliasb=new int[n+1];
        int[]keyb=new int[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        try{
            aliasb[n]=new Integer(a).intValue();
            keyb[n]=new Integer(b).intValue();
        }
        catch(Exception exc){
        }
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            int[]aliasb=new int[n-1];
            int[]keyb=new int[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
class ListBox extends JPanel{
    String[]thestrings=new String[0];
    GetImgKeyboardMapper gikm;
    Image img;
    int uppest=0;
    int n=0;
    int ind=-1;
    private static final long serialVersionUID = -457533304480165971L;
    public ListBox(){
        setLayout(null);
        gikm=new GetImgKeyboardMapper();
        img=gikm.img;
        repaint();
    }
    public synchronized void reset(){
        thestrings=new String[0];
        n=0;
        uppest=0;
        ind=-1;
    }
    public synchronized void setListData(String[]str){
        thestrings=str;
        n=thestrings.length;
    }
    public synchronized void addElement(String s){
        String[]thestrings2=new String[n+1];
        for(int i=0;i<n;i++){
            thestrings2[i]=thestrings[i];
        }
        thestrings2[n]=s;
        n=n+1;
        thestrings=thestrings2;
        uppest=n-8;
        if(uppest<0){
            uppest=0;
        }
    }
    public synchronized void removeElementAt(int ind2){
        int n=thestrings.length;
        if(n>0){
            if(ind==ind2){
                ind=-1;
            }
            else if(ind>ind2){
                ind=ind-1;
            }
            String[]thestrings2=new String[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind2){
                }
                else{
                    thestrings2[ib]=thestrings[i];
                    ib=ib+1;
                }
            }
            thestrings=thestrings2;
            this.n=n-1;
            if(uppest+8>=n){
                uppest=uppest-1;
                if(uppest<0){
                    uppest=0;
                }
            }
        }
    }
    public synchronized int getSelectedIndex(){
        return ind;
    }
    public synchronized void click(int x,int y){
        if(x>=10&&x<370&&y>=5&&y<5+16){
            uppest=uppest-1;
            if(uppest<0){
                uppest=0;
            }
        }
        if(x>=10&&x<370&&y>=5+9*16&&y<5+9*16+16){
            uppest=uppest+1;
            if(uppest+8>n){
                uppest=uppest-1;
            }
        }
        if(x>=10&&x<370&&y>=5+16&&y<5+8*16+16){
            int ind2=(y-5-16)/16+uppest;
            if(ind2>=0&&ind2<n){
                ind=ind2;
            }
        }
    }
    public synchronized void paint(Graphics g){
        Graphics h=img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,380,170);
        h.setColor(Color.black);
        for(int i=0;i<10;i++){
            h.setColor(Color.black);
            if(ind==uppest+i-1&&ind!=-1&&i!=0&&i!=9){
                h.setColor(Color.green);
            }
            h.drawRect(10,5+i*16,360,15);
        }
        h.setColor(Color.black);
        if(uppest==0){
            h.setColor(Color.red);
        }
        h.drawString("UP",12,5+14);
        h.setColor(Color.black);
        if(uppest+8>=n){
            h.setColor(Color.red);
        }
        h.drawString("DOWN",12,5+9*16+14);
        h.setColor(Color.black);
        for(int i=0;i<8;i++){
            h.setColor(Color.black);
            if(ind==uppest+i&&ind!=-1){
                h.setColor(Color.green);
            }
            int theindex=uppest+i;
            if(theindex<n){
                h.drawString(thestrings[theindex],12,5+16+i*16+14);
            }
        }
        g.drawImage(img,0,0,this);
    }
}
class GetImgKeyboardMapper extends JFrame{
    Image img;
    private static final long serialVersionUID = -8478639040178665797L;
    public GetImgKeyboardMapper(){
        pack();
        img=createImage(380,170);
    }
}
