import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import javax.swing.*;
import java.awt.event.*;
public class AstroReversi extends JApplet implements Runnable,ActionListener,KeyListener,MouseListener{
    JButton starttwo;
    JButton revcomp;
    JTextField info;
    JButton startserver;
    JTextField ip;
    JButton startclient;
    boolean starttwob=false;
    boolean startrevcomp=false;
    boolean startclientb=false;
    boolean startserverb=false;
    Thread t;
    boolean running=true;
    static JApplet app;
    static AstroReversi app2;
    JPanel p1;
    AstroReversi2 asr;
    AstroReversiComp asrc;
    private static final long serialVersionUID = 7833369366942115072L;
    public void init(){
        app=this;
        app2=this;
        setSize(640,480);
        setLayout(null);
        starttwo=new JButton("start two players");
        revcomp=new JButton("play against computer");
        info=new JTextField("your ip: 127.0.0.1");
        startserver=new JButton("start server");
        ip=new JTextField("127.0.0.1");
        startclient=new JButton("log into game");
        p1=new JPanel();
        p1.setLayout(null);
        add(p1);
        p1.setBounds(0,0,400,400);
        p1.add(starttwo);
        p1.add(revcomp);
        add(info);
        add(startserver);
        add(ip);
        add(startclient);
        info.setVisible(false);
        startserver.setVisible(false);
        ip.setVisible(false);
        startclient.setVisible(false);
        info.setBounds(10,100,380,27);
        startserver.setBounds(10,130,380,27);
        ip.setBounds(10,160,380,27);
        startclient.setBounds(10,190,380,27);
        starttwo.setBounds(10,40,380,27);
        revcomp.setBounds(10,70,380,27);
        starttwo.addActionListener(this);
        revcomp.addActionListener(this);
        startserver.addActionListener(this);
        startclient.addActionListener(this);
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        addMouseListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
//            Socket soc=new Socket("www.google.de",80);
//            info.setText("your ip: "+soc.getLocalAddress().getHostAddress());
        }
        catch(Exception except){
        }
        while(running){
            try{
                Thread.sleep(100);
                if(starttwob){
                    starttwob=false;
                    asr=new AstroReversi2();
                    p1.setVisible(false);
                    add(asr);
                    asr.setBounds(0,0,640,480);
                }
                if(startrevcomp){
                    startrevcomp=false;
                    p1.setVisible(false);
                    asrc=new AstroReversiComp();
                    add(asrc);
                    asrc.setBounds(0,0,640,480);
                }
                if(false&&startserverb){
                    startserverb=false;
                    new AstroReversiServer();
                    info.setText("wait for second player");
                }
                if(false&&startclientb){
                    startclientb=false;
                    new AstroReversiClient(ip.getText());
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public static void main(String[]args){
        new AstroReversi();
    }
    public void actionPerformed(ActionEvent evt){
            if(evt.getSource()==starttwo){
                starttwob=true;
            }
            if(evt.getSource()==revcomp){
                startrevcomp=true;
            }
            if(evt.getSource()==startserver){
                startserverb=true;
            }
            if(evt.getSource()==startclient){
                startclientb=true;
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(asr!=null){
            asr.process(e);
        }
        if(asrc!=null){
            asrc.process(e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void mousePressed(MouseEvent e) {
        requestFocus();
        if(asr!=null){
            asr.mprocess(e);
        }
        if(asrc!=null){
            asrc.mprocess(e);
        }
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
    }
}
class ReversiBrett{
    int[][]values=new int[30][20];
    int max=0;
    public ReversiBrett(){
    }
    public ReversiBrett cloneo(){
        ReversiBrett ret=new ReversiBrett();
        for(int i=0;i<30;i++){
            for(int j=0;j<20;j++){
                ret.values[i][j]=values[i][j];
            }
        }
        return ret;
    }
    public boolean moveok(ReversiBrett old,int x1,int y1,int x2,int y2){
        if(x1<0||x1>=30||y1<0||y1>=20||x2<0||x2>=30||y2<0||y2>=20){
            return false;
        }
//System.out.println("x1: "+x1+" y1: "+y1+" x2: "+x2+" y2: "+y2);
        int[][]ovalues=old.values;
        int cplayer=0;
        if(ovalues[x1][y1]==1&&ovalues[x2][y2]==1){
            cplayer=1;
        }
        else if(ovalues[x1][y1]==2&&ovalues[x2][y2]==2){
            cplayer=2;
        }
        if(cplayer==0){
            return false;
        }
        if(values[x1][y1]!=cplayer||values[x2][y2]!=cplayer){
            return false;
        }
//System.out.println("cplayer: "+cplayer);
        int diffx=x2-x1;
        int diffy=y2-y1;
        int diffxabs=diffx;
        int diffyabs=diffy;
        if(diffxabs<0){
            diffxabs=-diffxabs;
        }
        if(diffyabs<0){
            diffyabs=-diffyabs;
        }
        for(int i=0;i<=diffxabs;i++){
            for(int j=0;j<=diffyabs;j++){
                int diffi=0;
                int diffai=0;
                if(i>0){
                    diffi=diffxabs/i;
                    diffai=diffxabs%i;
                }
                int diffj=0;
                int diffaj=0;
                if(j>0){
                    diffj=diffyabs/j;
                    diffaj=diffyabs%j;
                }
                if((diffi==diffj||diffi==0||diffj==0)&&diffai==0&&diffaj==0){
//System.out.println("PairHolder");
                    PairHolder ph=new PairHolder();
                    boolean all=true;
                    int diffk=diffi;
                    if(diffj>diffk){
                        diffk=diffj;
                    }
//System.out.println("diffk: "+diffk);
                    for(int k=1;k<diffk;k++){
                        int ddivx=0;
                        int ddivy=0;
                        if(diffxabs>0){
                            ddivx=diffx/diffxabs;
                        }
                        if(diffyabs>0){
                            ddivy=diffy/diffyabs;
                        }
                        if(values[x1+k*i*ddivx][y1+k*j*ddivy]==cplayer){
                            ph.add(x1+k*i*ddivx,y1+k*j*ddivy);
                        }
                        else{
                            all=false;
                        }
                    }
//ph.print();
                    if(all){
                        boolean error=false;
                        for(int i1=0;i1<30;i1++){
                            for(int i2=0;i2<20;i2++){
                                if(values[i1][i2]!=ovalues[i1][i2]&&!ph.contained(i1,i2)){
                                    error=true;
                                }
                            }
                        }
                        if(!error){
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
    public int won(){
        boolean one=false;
        boolean two=false;
        for(int i=0;i<30;i++){
            for(int j=0;j<20;j++){
                if(values[i][j]==1){
                    one=true;
                }
                else if(values[i][j]==2){
                    two=true;
                }
            }
        }
        if(one&&two){
            return 0;
        }
        if(one&&!two){
            return 1;
        }
        if(!one&&two){
            return 2;
        }
        return 0;
    }
}
class PairHolder{
    int[]a=new int[0];
    int[]b=new int[0];
    public PairHolder(){
    }
    public void print(){
        for(int i=0;i<a.length;i++){
            System.out.println(""+a[i]+" "+b[i]);
        }
    }
    public void add(int a1,int b1){
        int n=a.length;
        int[]a2=new int[n+1];
        int[]b2=new int[n+1];
        for(int i=0;i<n;i++){
            a2[i]=a[i];
            b2[i]=b[i];
        }
        a2[n]=a1;
        b2[n]=b1;
        a=a2;
        b=b2;
    }
    public boolean contained(int a1,int b1){
        int n=a.length;
        for(int i=0;i<n;i++){
            if(a[i]==a1&&b[i]==b1){
                return true;
            }
        }
        return false;
    }
}
class AstroReversi2 extends JPanel implements Runnable,ActionListener{
    SCanvasAstroReversi sc;
    JTextField info;
    JButton action;
    Thread t;
    boolean running=true;
    int state=0;
    int redleft=248;
    int greenleft=248;
    boolean actionb=false;
    boolean clickb=false;
    int mx=0;
    int my=0;
    int revxb=0;
    int revyb=0;
    int revxb2=0;
    int revyb2=0;
    ReversiBrett rev;
    ReversiBrett rev2;
    private static final long serialVersionUID = -7966932604692152425L;
    public AstroReversi2(){
//        super("AstroReversi");
//        pack();
        setSize(640,480);
        setLayout(null);
        sc=new SCanvasAstroReversi();
        info=new JTextField("player 1 set stone (red)");
        action=new JButton("action");
        action.setEnabled(false);
        add(sc);
        add(info);
        add(action);
        action.addActionListener(this);
        info.setBounds(10,40,380,27);
        action.setBounds(410,40,180,27);
        sc.setBounds(20,70,600,400);
        rev=new ReversiBrett();
        rev.values[14][9]=1;
        rev.values[15][9]=1;
        rev.values[14][10]=2;
        rev.values[15][10]=2;
        setVisible(true);
        t=new Thread(this);
        t.start();
    }
    public void runcontent(){
                if(rev!=null){
                    int player=rev.won();
                    if(player==1){
                        info.setText("player 1 (red) has won");
                        running=false;
                    }
                    if(player==2){
                        info.setText("player 2 (green) has won");
                        running=false;
                    }
                }
                if(clickb){
                    clickb=false;
                    if(state==0&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev.values[mx][my]==0){
                            rev.values[mx][my]=1;
                            rev2=rev.cloneo();
                            sc.set(rev2);
                            info.setText("select red reverse borders (1)");
                            state=1;
                            redleft--;
                        }
                    }
                    else if(state==1&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb=mx;
                            revyb=my;
                            sc.borderx1=mx;
                            sc.bordery1=my;
                            info.setText("select red reverse borders (2)");
                            sc.bcount=1;
                            state=2;
                        }
                    }
                    else if(state==2&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb2=mx;
                            revyb2=my;
                            sc.borderx2=mx;
                            sc.bordery2=my;
                            info.setText("reverse green stones");
                            action.setEnabled(true);
                            action.setText("ok, player 2");
                            sc.bcount=2;
                            state=3;
                        }
                    }
                    else if(state==3&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            int diffx=revxb2-revxb;
                            int diffy=revyb2-revyb;
                            int diffxabs=diffx;
                            if(diffxabs<0){
                                diffxabs=-diffxabs;
                            }
                            int diffyabs=diffy;
                            if(diffyabs<0){
                                diffyabs=-diffyabs;
                            }
                            int xc=mx-revxb;
                            int yc=my-revyb;
                            if(xc<0){
                                xc=-xc;
                            }
                            if(yc<0){
                                yc=-yc;
                            }
//System.out.println("diffxabs: "+diffxabs+" diffyabs: "+diffyabs);
                            if(xc!=0&&yc!=0&&(float)diffxabs/xc==(float)diffyabs/yc){
                                rev2.values[mx][my]=1;
                            }
                            if(xc!=0&&yc==0&&((mx>=revxb&&mx<=revxb2)||(mx>=revxb2&&mx<=revxb))){
                                rev2.values[mx][my]=1;
                            }
                            if(yc!=0&&xc==0&&((my>=revyb&&my<=revyb2)||(my>=revyb2&&my<=revyb))){
                                rev2.values[mx][my]=1;
                            }
                        }
                    }
                    else if(state==4&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev.values[mx][my]==0){
                            rev.values[mx][my]=2;
                            rev2=rev.cloneo();
                            sc.set(rev2);
                            info.setText("select green reverse borders (1)");
                            state=5;
                            greenleft--;
                        }
                    }
                    else if(state==5&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            revxb=mx;
                            revyb=my;
                            sc.borderx1=mx;
                            sc.bordery1=my;
                            info.setText("select green reverse borders (2)");
                            sc.bcount=1;
                            state=6;
                        }
                    }
                    else if(state==6&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            revxb2=mx;
                            revyb2=my;
                            sc.borderx2=mx;
                            sc.bordery2=my;
                            info.setText("reverse red stones");
                            action.setEnabled(true);
                            action.setText("ok, player 1");
                            sc.bcount=2;
                            state=7;
                        }
                    }
                    else if(state==7&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            int diffx=revxb2-revxb;
                            int diffy=revyb2-revyb;
                            int diffxabs=diffx;
                            if(diffxabs<0){
                                diffxabs=-diffxabs;
                            }
                            int diffyabs=diffy;
                            if(diffyabs<0){
                                diffyabs=-diffyabs;
                            }
                            int xc=mx-revxb;
                            int yc=my-revyb;
                            if(xc<0){
                                xc=-xc;
                            }
                            if(yc<0){
                                yc=-yc;
                            }
                            if(xc!=0&&yc!=0&&(float)diffxabs/xc==(float)diffyabs/yc){
                                rev2.values[mx][my]=2;
                            }
                            if(xc!=0&&yc==0&&((mx>=revxb&&mx<=revxb2)||(mx>=revxb2&&mx<=revxb))){
                                rev2.values[mx][my]=2;
                            }
                            if(yc!=0&&xc==0&&((my>=revyb&&my<=revyb2)||(my>=revyb2&&my<=revyb))){
                                rev2.values[mx][my]=2;
                            }
                        }
                    }
                }
                if(actionb){
                    actionb=false;
                    if(state==3){
                        sc.bcount=0;
                        if(rev2.moveok(rev,revxb,revyb,revxb2,revyb2)){
                            if(greenleft>0){
                                state=4;
                                rev=rev2;
                                info.setText("player 2 set stone (green)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                            else{
                                state=5;
                                rev=rev2;
                                info.setText("select green reverse borders (1)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                        }
                        else{
                            info.setText("irregular move: try again");
                            rev2=rev;
                            sc.set(rev);
                            state=1;
                        }
                    }
                    if(state==7){
                        sc.bcount=0;
                        if(rev2.moveok(rev,revxb,revyb,revxb2,revyb2)){
                            if(redleft>0){
                                state=0;
                                rev=rev2;
                                info.setText("player 1 set stone (red)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                            else{
                                state=1;
                                rev=rev2;
                                info.setText("select red reverse borders (1)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                        }
                        else{
                            info.setText("irregular move: try again");
                            rev2=rev;
                            sc.set(rev);
                            state=5;
                        }
                    }
                }
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(20);
                if(sc!=null){
                    sc.runcontent(this);
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==27||key==KeyEvent.VK_ESCAPE){
                setVisible(false);
                running=false;
                AstroReversi.app2.p1.setVisible(true);
            }
    }
    public void actionPerformed(ActionEvent ae){
            if(ae.getSource()==action){
                actionb=true;
            }
    }
    public void mprocess(MouseEvent me){
            mx=(me.getX()-20)/20;
            my=(me.getY()-70)/20;
            clickb=true;
    }
}
class SCanvasAstroReversi extends JPanel implements Runnable{
    Thread t;
    ReversiBrett rev;
    ReversiBrett nrev;
    boolean setrev=false;
    boolean running=true;
    Image img;
    ImFrameAstroReversi imf;
    Graphics h;
    int borderx1=0;
    int bordery1=0;
    int borderx2=0;
    int bordery2=0;
    int bcount=0;
    private static final long serialVersionUID = 6225510094646400598L;
    public SCanvasAstroReversi(){
        imf=new ImFrameAstroReversi();
        img=imf.img;
        h=img.getGraphics();
        rev=new ReversiBrett();
        rev.values[14][9]=1;
        rev.values[15][9]=1;
        rev.values[14][10]=2;
        rev.values[15][10]=2;
        t=new Thread(this);
        t.start();
    }
    public void set(ReversiBrett nrev){
        this.nrev=nrev;
        setrev=true;
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(20);
                setrev();
                repaint();
            }
            catch(Exception e){
            }
        }
    }
    public synchronized void setrev(){
                if(setrev){
                    setrev=false;
                    rev=nrev;
                }
    }
    public synchronized void runcontent(AstroReversi2 ar){
        ar.runcontent();
    }
    public synchronized void runcontent(AstroReversiComp arc){
        arc.runcontent();
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,600,400);
        for(int i=0;i<30;i++){
            for(int j=0;j<20;j++){
                h.setColor(Color.black);
                h.drawRect(i*20,j*20,20,20);
                if(rev.values[i][j]==1){
                    h.setColor(Color.red);
                    h.fillOval(i*20+2,j*20+2,16,16);
                }
                else if(rev.values[i][j]==2){
                    h.setColor(Color.green);
                    h.fillOval(i*20+2,j*20+2,16,16);
                }
            }
        }
        h.setColor(Color.blue);
        if(bcount==1){
            h.drawRect(borderx1*20+1,bordery1*20+1,18,18);
            h.drawRect(borderx1*20,bordery1*20,20,20);
        }
        if(bcount==2){
            h.drawRect(borderx1*20+1,bordery1*20+1,18,18);
            h.drawRect(borderx1*20,bordery1*20,20,20);
            h.drawRect(borderx2*20+1,bordery2*20+1,18,18);
            h.drawRect(borderx2*20,bordery2*20,20,20);
        }
        g.drawImage(img,0,0,this);
//        paint(g);
    }
}
class ImFrameAstroReversi extends JFrame{
    Image img;
    private static final long serialVersionUID = 2061222348281010649L;
    public ImFrameAstroReversi(){
        pack();
        img=createImage(600,400);
    }
}
class AstroReversiComp extends JPanel implements Runnable,ActionListener{
    SCanvasAstroReversi sc;
    JTextField info;
    JButton action;
    Thread t;
    boolean running=true;
    int state=0;
    int redleft=248;
    int greenleft=248;
    boolean actionb=false;
    boolean clickb=false;
    int mx=0;
    int my=0;
    int revxb=0;
    int revyb=0;
    int revxb2=0;
    int revyb2=0;
    ReversiBrett rev;
    ReversiBrett rev2;
    private static final long serialVersionUID = -448316889146605475L;
    public AstroReversiComp(){
//        super("AstroReversi");
//        pack();
        setSize(640,480);
        setLayout(null);
        sc=new SCanvasAstroReversi();
        info=new JTextField("player set stone (red)");
        action=new JButton("action");
        action.setEnabled(false);
        add(sc);
        add(info);
        add(action);
        info.setBounds(10,40,380,27);
        action.setBounds(410,40,180,27);
        sc.setBounds(20,70,600,400);
        action.addActionListener(this);
        rev=new ReversiBrett();
        rev.values[14][9]=1;
        rev.values[15][9]=1;
        rev.values[14][10]=2;
        rev.values[15][10]=2;
        setVisible(true);
        t=new Thread(this);
        t.start();
    }
    public void runcontent(){
                if(rev!=null){
                    int player=rev.won();
                    if(player==1){
                        info.setText("player (red) has won");
                        running=false;
                    }
                    if(player==2){
                        info.setText("computer (green) has won");
                        running=false;
                    }
                }
                if(clickb){
                    clickb=false;
                    if(state==0&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev.values[mx][my]==0){
                            rev.values[mx][my]=1;
                            rev2=rev.cloneo();
                            sc.set(rev2);
                            info.setText("select red reverse borders (1)");
                            state=1;
                            redleft--;
                        }
                    }
                    else if(state==1&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb=mx;
                            revyb=my;
                            sc.borderx1=mx;
                            sc.bordery1=my;
                            info.setText("select red reverse borders (2)");
                            sc.bcount=1;
                            state=2;
                        }
                    }
                    else if(state==2&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb2=mx;
                            revyb2=my;
                            sc.borderx2=mx;
                            sc.bordery2=my;
                            info.setText("reverse green stones");
                            action.setEnabled(true);
                            action.setText("ok, player 2");
                            sc.bcount=2;
                            state=3;
                        }
                    }
                    else if(state==3&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            int diffx=revxb2-revxb;
                            int diffy=revyb2-revyb;
                            int diffxabs=diffx;
                            if(diffxabs<0){
                                diffxabs=-diffxabs;
                            }
                            int diffyabs=diffy;
                            if(diffyabs<0){
                                diffyabs=-diffyabs;
                            }
                            int xc=mx-revxb;
                            int yc=my-revyb;
                            if(xc<0){
                                xc=-xc;
                            }
                            if(yc<0){
                                yc=-yc;
                            }
//System.out.println("diffxabs: "+diffxabs+" diffyabs: "+diffyabs);
                            if(xc!=0&&yc!=0&&(float)diffxabs/xc==(float)diffyabs/yc){
                                rev2.values[mx][my]=1;
                            }
                            if(xc!=0&&yc==0&&((mx>=revxb&&mx<=revxb2)||(mx>=revxb2&&mx<=revxb))){
                                rev2.values[mx][my]=1;
                            }
                            if(yc!=0&&xc==0&&((my>=revyb&&my<=revyb2)||(my>=revyb2&&my<=revyb))){
                                rev2.values[mx][my]=1;
                            }
                        }
                    }
                }
                if(actionb){
                    actionb=false;
                    if(state==3){
                        sc.bcount=0;
                        if(rev2.moveok(rev,revxb,revyb,revxb2,revyb2)){
                            if(greenleft>0){
                                state=4;
                                rev=rev2;
                                info.setText("computer sets new stone");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                            else{
                                state=5;
                                rev=rev2;
                                info.setText("computer selects reverse borders");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                        }
                        else{
                            info.setText("irregular move: try again");
                            rev2=rev;
                            sc.set(rev);
                            state=1;
                        }
                    }
                }
                if(state==4||state==5){
                    ReversiBrett[][]copy=new ReversiBrett[30][20];
                    ReversiBrett[][]target=new ReversiBrett[30][20];
                    for(int i=0;i<30;i++){
                        for(int j=0;j<20;j++){
                            if(rev.values[i][j]==0){
                                copy[i][j]=rev.cloneo();
                                boolean stopb=(copy[i][j].values[i][j]==2);
                                if(state==4&&copy[i][j].values[i][j]==0){
                                    copy[i][j].values[i][j]=2;
                                    stopb=true;
                                }
                                else if(state==4){
                                    stopb=false;
                                }
                                int max=0;
                                ReversiBrett cur=null;
                                for(int i1=0;stopb&&i1<30;i1++){
                                    for(int i2=0;i2<20;i2++){
                                        if(i1!=i||i2!=j){
                                            if(copy[i][j].values[i1][i2]==2){
                                                int diffx=i1-i;
                                                int diffy=i2-j;
                                                int diffxabs=diffx;
                                                if(diffxabs<0){
                                                    diffxabs=-diffx;
                                                }
                                                int diffyabs=diffy;
                                                if(diffyabs<0){
                                                    diffyabs=-diffy;
                                                }
                                                for(int j1=-diffxabs;j1<=diffxabs;j1++){
                                                    for(int j2=-diffyabs;j2<=diffyabs;j2++){
                                                        ReversiBrett tmp=copy[i][j].cloneo();
                                                        boolean found=false;
                                                        boolean runb=true;
                                                        int startx=i;
                                                        int starty=j;
                                                        int count=0;
                                                        while(runb&&(j1!=0||j2!=0)){
//System.out.println("startx: "+startx+" starty: "+starty);
                                                            startx=startx+j1;
                                                            starty=starty+j2;
                                                            if(startx<0||startx>=30||starty<0||starty>=20){
                                                                runb=false;
                                                            }
                                                            else if(startx==i1&&starty==i2){
                                                                found=true;
                                                                runb=false;
                                                            }
                                                            else if(tmp.values[startx][starty]==2){
                                                                runb=false;
                                                            }
                                                            else if(tmp.values[startx][starty]==0){
                                                                runb=false;
                                                            }
                                                            else if(tmp.values[startx][starty]==1){
                                                                tmp.values[startx][starty]=2;
                                                                count++;
                                                            }
                                                        }
                                                        if(found&&count>=max){
                                                            max=count;
                                                            target[i][j]=tmp;
                                                            target[i][j].max=max;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    ReversiBrett sel=null;
                    int curm=0;
                    for(int i=0;i<30;i++){
                        for(int j=0;j<20;j++){
                            if(target[i][j]!=null){
                                if(target[i][j].max>=curm){
                                    curm=target[i][j].max;
                                    sel=target[i][j];
                                }
                            }
                        }
                    }
                    rev=sel;
                    sc.set(rev);
                    if(redleft>0){
                        info.setText("player set stone");
                        action.setText("action");
                        action.setEnabled(false);
                        state=0;
                    }
                    else{
                        info.setText("player select red borders (1)");
                        action.setText("action");
                        action.setEnabled(false);
                        state=1;
                    }
                }
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(20);
                if(sc!=null){
                    sc.runcontent(this);
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==27||key==KeyEvent.VK_ESCAPE){
                setVisible(false);
                running=false;
                AstroReversi.app2.p1.setVisible(true);
            }
    }
    public void actionPerformed(ActionEvent ae){
            if(ae.getSource()==action){
                actionb=true;
            }
    }
    public void mprocess(MouseEvent me){
            mx=(me.getX()-20)/20;
            my=(me.getY()-70)/20;
            clickb=true;
    }
}
class ReversiServer implements Runnable{
    AstroReversiServer aro;
    ServerSocket seso;
    Thread t;
    ReversiSocket revso;
    boolean running=true;
    boolean connected=false;
    public ReversiServer(AstroReversiServer aro){
        this.aro=aro;
        t=new Thread(this);
        t.start();
    }
    public void action(){
        if(revso!=null){
            revso.action();
        }
    }
    public void click(int mx,int my){
        if(revso!=null){
            revso.click(mx,my);
        }
    }
    public void run(){
        try{
            seso=new ServerSocket(8999);
        }
        catch(Exception exc){
        }
//        while(running){
            try{
                Socket so=seso.accept();
                connected=true;
                revso=new ReversiSocket(so,aro);
            }
            catch(Exception e){
            }
//        }
    }
}
class ReversiSocket implements Runnable{
    AstroReversiServer aro;
    Socket so;
    Thread t;
    boolean running=true;
    OutputStream os;
    PrintStream ps;
    public ReversiSocket(Socket so,AstroReversiServer aro){
        this.so=so;
        this.aro=aro;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            InputStream is=so.getInputStream();
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            os=so.getOutputStream();
            ps=new PrintStream(os);
            while(running){
                String s=dis.readLine();
                if(s.equals("click")){
                    int mx=Integer.parseInt(dis.readLine());
                    int my=Integer.parseInt(dis.readLine());
                    aro.click(mx,my);
                }
                else if(s.equals("action")){
                    aro.action();
                }
                else if(s.equals("exit")){
                    running=false;
                }
            }
        }
        catch(Exception e){
        }
    }
    public void action(){
        try{
            ps.println("action");
        }
        catch(Exception e){
        }
    }
    public void click(int mx,int my){
        try{
            ps.println("click");
            ps.println(""+mx);
            ps.println(""+my);
        }
        catch(Exception e){
        }
    }
}
class AstroReversiServer extends JFrame implements Runnable,ActionListener{
    SCanvasAstroReversi sc;
    JTextField info;
    JButton action;
    Thread t;
    boolean running=true;
    int state=0;
    int redleft=248;
    int greenleft=248;
    boolean actionb=false;
    boolean clickb=false;
    int mx=0;
    int my=0;
    int revxb=0;
    int revyb=0;
    int revxb2=0;
    int revyb2=0;
    ReversiBrett rev;
    ReversiBrett rev2;
    ReversiServer rs;
    private static final long serialVersionUID = -213317589725557460L;
    public AstroReversiServer(){
        super("AstroReversiServer");
        pack();
        setSize(640,480);
        setLayout(null);
        sc=new SCanvasAstroReversi();
        rs=new ReversiServer(this);
        info=new JTextField("player 1 set stone (red)");
        action=new JButton("action");
        action.setEnabled(false);
        add(sc);
        add(info);
        add(action);
        info.setBounds(10,40,380,27);
        action.setBounds(410,40,180,27);
        sc.setBounds(20,70,600,400);
        action.addActionListener(this);
        rev=new ReversiBrett();
        rev.values[14][9]=1;
        rev.values[15][9]=1;
        rev.values[14][10]=2;
        rev.values[15][10]=2;
        t=new Thread(this);
        t.start();
    }
    public void action(){
        actionb=true;
    }
    public void click(int mx,int my){
        this.mx=mx;
        this.my=my;
        clickb=true;
    }
    public void run(){
        while(!rs.connected){
            try{
                Thread.sleep(100);
            }
            catch(Exception exc){
            }
        }
        setVisible(true);
        while(running){
            try{
                Thread.sleep(20);
                if(rev!=null){
                    int player=rev.won();
                    if(player==1){
                        info.setText("player 1 (red) has won");
                        running=false;
                    }
                    if(player==2){
                        info.setText("player 2 (green) has won");
                        running=false;
                    }
                }
                if(clickb){
                    clickb=false;
                    if(state==0&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev.values[mx][my]==0){
                            rev.values[mx][my]=1;
                            rev2=rev.cloneo();
                            sc.set(rev2);
                            info.setText("select red reverse borders (1)");
                            state=1;
                            redleft--;
                        }
                    }
                    else if(state==1&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb=mx;
                            revyb=my;
                            sc.borderx1=mx;
                            sc.bordery1=my;
                            info.setText("select red reverse borders (2)");
                            sc.bcount=1;
                            state=2;
                        }
                    }
                    else if(state==2&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb2=mx;
                            revyb2=my;
                            sc.borderx2=mx;
                            sc.bordery2=my;
                            info.setText("reverse green stones");
                            action.setEnabled(true);
                            action.setText("ok, player 2");
                            sc.bcount=2;
                            state=3;
                        }
                    }
                    else if(state==3&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            int diffx=revxb2-revxb;
                            int diffy=revyb2-revyb;
                            int diffxabs=diffx;
                            if(diffxabs<0){
                                diffxabs=-diffxabs;
                            }
                            int diffyabs=diffy;
                            if(diffyabs<0){
                                diffyabs=-diffyabs;
                            }
                            int xc=mx-revxb;
                            int yc=my-revyb;
                            if(xc<0){
                                xc=-xc;
                            }
                            if(yc<0){
                                yc=-yc;
                            }
//System.out.println("diffxabs: "+diffxabs+" diffyabs: "+diffyabs);
                            if(xc!=0&&yc!=0&&(float)diffxabs/xc==(float)diffyabs/yc){
                                rev2.values[mx][my]=1;
                            }
                            if(xc!=0&&yc==0&&((mx>=revxb&&mx<=revxb2)||(mx>=revxb2&&mx<=revxb))){
                                rev2.values[mx][my]=1;
                            }
                            if(yc!=0&&xc==0&&((my>=revyb&&my<=revyb2)||(my>=revyb2&&my<=revyb))){
                                rev2.values[mx][my]=1;
                            }
                        }
                    }
                    else if(state==4&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev.values[mx][my]==0){
                            rev.values[mx][my]=2;
                            rev2=rev.cloneo();
                            sc.set(rev2);
                            info.setText("select green reverse borders (1)");
                            state=5;
                            greenleft--;
                        }
                    }
                    else if(state==5&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            revxb=mx;
                            revyb=my;
                            sc.borderx1=mx;
                            sc.bordery1=my;
                            info.setText("select green reverse borders (2)");
                            sc.bcount=1;
                            state=6;
                        }
                    }
                    else if(state==6&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            revxb2=mx;
                            revyb2=my;
                            sc.borderx2=mx;
                            sc.bordery2=my;
                            info.setText("reverse red stones");
                            action.setEnabled(true);
                            action.setText("ok, player 1");
                            sc.bcount=2;
                            state=7;
                        }
                    }
                    else if(state==7&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            int diffx=revxb2-revxb;
                            int diffy=revyb2-revyb;
                            int diffxabs=diffx;
                            if(diffxabs<0){
                                diffxabs=-diffxabs;
                            }
                            int diffyabs=diffy;
                            if(diffyabs<0){
                                diffyabs=-diffyabs;
                            }
                            int xc=mx-revxb;
                            int yc=my-revyb;
                            if(xc<0){
                                xc=-xc;
                            }
                            if(yc<0){
                                yc=-yc;
                            }
                            if(xc!=0&&yc!=0&&(float)diffxabs/xc==(float)diffyabs/yc){
                                rev2.values[mx][my]=2;
                            }
                            if(xc!=0&&yc==0&&((mx>=revxb&&mx<=revxb2)||(mx>=revxb2&&mx<=revxb))){
                                rev2.values[mx][my]=2;
                            }
                            if(yc!=0&&xc==0&&((my>=revyb&&my<=revyb2)||(my>=revyb2&&my<=revyb))){
                                rev2.values[mx][my]=2;
                            }
                        }
                    }
                }
                if(actionb){
                    actionb=false;
                    if(state==3){
                        sc.bcount=0;
                        if(rev2.moveok(rev,revxb,revyb,revxb2,revyb2)){
                            if(greenleft>0){
                                state=4;
                                rev=rev2;
                                info.setText("player 2 set stone (green)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                            else{
                                state=5;
                                rev=rev2;
                                info.setText("select green reverse borders (1)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                        }
                        else{
                            info.setText("irregular move: try again");
                            rev2=rev;
                            sc.set(rev);
                            state=1;
                        }
                    }
                    if(state==7){
                        sc.bcount=0;
                        if(rev2.moveok(rev,revxb,revyb,revxb2,revyb2)){
                            if(redleft>0){
                                state=0;
                                rev=rev2;
                                info.setText("player 1 set stone (red)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                            else{
                                state=1;
                                rev=rev2;
                                info.setText("select red reverse borders (1)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                        }
                        else{
                            info.setText("irregular move: try again");
                            rev2=rev;
                            sc.set(rev);
                            state=5;
                        }
                    }
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
        if(state<4){
            if(evt.getSource()==action){
                actionb=true;
                rs.action();
            }
        }
    }
    public void mprocess(MouseEvent me){
        if(state<4){
            mx=(me.getX()-20)/20;
            my=(me.getY()-70)/20;
            clickb=true;
            rs.click(mx,my);
        }
    }
}
class AstroReversiClient extends JFrame implements Runnable,ActionListener{
    SCanvasAstroReversi sc;
    JTextField info;
    JButton action;
    Thread t;
    boolean running=true;
    int state=0;
    int redleft=248;
    int greenleft=248;
    boolean actionb=false;
    boolean clickb=false;
    int mx=0;
    int my=0;
    int revxb=0;
    int revyb=0;
    int revxb2=0;
    int revyb2=0;
    ReversiBrett rev;
    ReversiBrett rev2;
    ReversiSocketClient rs;
    private static final long serialVersionUID = -3641280080717705897L;
    public AstroReversiClient(String server){
        super("AstroReversiClient");
        pack();
        setSize(640,480);
        setLayout(null);
        sc=new SCanvasAstroReversi();
        rs=new ReversiSocketClient(server,this);
        info=new JTextField("player 1 set stone (red)");
        action=new JButton("action");
        action.setEnabled(false);
        add(sc);
        add(info);
        add(action);
        info.setBounds(10,40,380,27);
        action.setBounds(410,40,180,27);
        sc.setBounds(20,70,600,400);
        action.addActionListener(this);
        rev=new ReversiBrett();
        rev.values[14][9]=1;
        rev.values[15][9]=1;
        rev.values[14][10]=2;
        rev.values[15][10]=2;
        setVisible(true);
        t=new Thread(this);
        t.start();
    }
    public void action(){
        actionb=true;
    }
    public void click(int mx,int my){
        this.mx=mx;
        this.my=my;
        clickb=true;
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(20);
                if(rs.error){
                    info.setText("login failed");
                    running=false;
                }
                if(rev!=null){
                    int player=rev.won();
                    if(player==1){
                        info.setText("player 1 (red) has won");
                        running=false;
                    }
                    if(player==2){
                        info.setText("player 2 (green) has won");
                        running=false;
                    }
                }
                if(clickb){
                    clickb=false;
                    if(state==0&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev.values[mx][my]==0){
                            rev.values[mx][my]=1;
                            rev2=rev.cloneo();
                            sc.set(rev2);
                            info.setText("select red reverse borders (1)");
                            state=1;
                            redleft--;
                        }
                    }
                    else if(state==1&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb=mx;
                            revyb=my;
                            sc.borderx1=mx;
                            sc.bordery1=my;
                            info.setText("select red reverse borders (2)");
                            sc.bcount=1;
                            state=2;
                        }
                    }
                    else if(state==2&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            revxb2=mx;
                            revyb2=my;
                            sc.borderx2=mx;
                            sc.bordery2=my;
                            info.setText("reverse green stones");
                            action.setEnabled(true);
                            action.setText("ok, player 2");
                            sc.bcount=2;
                            state=3;
                        }
                    }
                    else if(state==3&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            int diffx=revxb2-revxb;
                            int diffy=revyb2-revyb;
                            int diffxabs=diffx;
                            if(diffxabs<0){
                                diffxabs=-diffxabs;
                            }
                            int diffyabs=diffy;
                            if(diffyabs<0){
                                diffyabs=-diffyabs;
                            }
                            int xc=mx-revxb;
                            int yc=my-revyb;
                            if(xc<0){
                                xc=-xc;
                            }
                            if(yc<0){
                                yc=-yc;
                            }
//System.out.println("diffxabs: "+diffxabs+" diffyabs: "+diffyabs);
                            if(xc!=0&&yc!=0&&(float)diffxabs/xc==(float)diffyabs/yc){
                                rev2.values[mx][my]=1;
                            }
                            if(xc!=0&&yc==0&&((mx>=revxb&&mx<=revxb2)||(mx>=revxb2&&mx<=revxb))){
                                rev2.values[mx][my]=1;
                            }
                            if(yc!=0&&xc==0&&((my>=revyb&&my<=revyb2)||(my>=revyb2&&my<=revyb))){
                                rev2.values[mx][my]=1;
                            }
                        }
                    }
                    else if(state==4&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev.values[mx][my]==0){
                            rev.values[mx][my]=2;
                            rev2=rev.cloneo();
                            sc.set(rev2);
                            info.setText("select green reverse borders (1)");
                            state=5;
                            greenleft--;
                        }
                    }
                    else if(state==5&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            revxb=mx;
                            revyb=my;
                            sc.borderx1=mx;
                            sc.bordery1=my;
                            info.setText("select green reverse borders (2)");
                            sc.bcount=1;
                            state=6;
                        }
                    }
                    else if(state==6&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==2){
                            revxb2=mx;
                            revyb2=my;
                            sc.borderx2=mx;
                            sc.bordery2=my;
                            info.setText("reverse red stones");
                            action.setEnabled(true);
                            action.setText("ok, player 1");
                            sc.bcount=2;
                            state=7;
                        }
                    }
                    else if(state==7&&mx>=0&&mx<30&&my>=0&&my<20){
                        if(rev2.values[mx][my]==1){
                            int diffx=revxb2-revxb;
                            int diffy=revyb2-revyb;
                            int diffxabs=diffx;
                            if(diffxabs<0){
                                diffxabs=-diffxabs;
                            }
                            int diffyabs=diffy;
                            if(diffyabs<0){
                                diffyabs=-diffyabs;
                            }
                            int xc=mx-revxb;
                            int yc=my-revyb;
                            if(xc<0){
                                xc=-xc;
                            }
                            if(yc<0){
                                yc=-yc;
                            }
                            if(xc!=0&&yc!=0&&(float)diffxabs/xc==(float)diffyabs/yc){
                                rev2.values[mx][my]=2;
                            }
                            if(xc!=0&&yc==0&&((mx>=revxb&&mx<=revxb2)||(mx>=revxb2&&mx<=revxb))){
                                rev2.values[mx][my]=2;
                            }
                            if(yc!=0&&xc==0&&((my>=revyb&&my<=revyb2)||(my>=revyb2&&my<=revyb))){
                                rev2.values[mx][my]=2;
                            }
                        }
                    }
                }
                if(actionb){
                    actionb=false;
                    if(state==3){
                        sc.bcount=0;
                        if(rev2.moveok(rev,revxb,revyb,revxb2,revyb2)){
                            if(greenleft>0){
                                state=4;
                                rev=rev2;
                                info.setText("player 2 set stone (green)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                            else{
                                state=5;
                                rev=rev2;
                                info.setText("select green reverse borders (1)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                        }
                        else{
                            info.setText("irregular move: try again");
                            rev2=rev;
                            sc.set(rev);
                            state=1;
                        }
                    }
                    if(state==7){
                        sc.bcount=0;
                        if(rev2.moveok(rev,revxb,revyb,revxb2,revyb2)){
                            if(redleft>0){
                                state=0;
                                rev=rev2;
                                info.setText("player 1 set stone (red)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                            else{
                                state=1;
                                rev=rev2;
                                info.setText("select red reverse borders (1)");
                                action.setText("action");
                                action.setEnabled(false);
                            }
                        }
                        else{
                            info.setText("irregular move: try again");
                            rev2=rev;
                            sc.set(rev);
                            state=5;
                        }
                    }
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
        if(state>=4){
            if(evt.getSource()==action){
                actionb=true;
                rs.action();
            }
        }
    }
    public void mprocess(MouseEvent me){
        if(state>=4){
            mx=(me.getX()-20)/20;
            my=(me.getY()-70)/20;
            clickb=true;
            rs.click(mx,my);
        }
    }
}
class ReversiSocketClient implements Runnable{
    AstroReversiClient aro;
    String server;
    Thread t;
    boolean running=true;
    OutputStream os;
    PrintStream ps;
    boolean error=false;
    public ReversiSocketClient(String server,AstroReversiClient aro){
        this.server=server;
        this.aro=aro;
        t=new Thread(this);
        t.start();
    }
    public void run(){
        try{
            Socket so=new Socket(server,8999);
            InputStream is=so.getInputStream();
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            os=so.getOutputStream();
            ps=new PrintStream(os);
            while(running){
                String s=dis.readLine();
                if(s.equals("click")){
                    int mx=Integer.parseInt(dis.readLine());
                    int my=Integer.parseInt(dis.readLine());
                    aro.click(mx,my);
                }
                else if(s.equals("action")){
                    aro.action();
                }
                else if(s.equals("exit")){
                    running=false;
                }
            }
        }
        catch(Exception e){
            error=true;
        }
    }
    public void action(){
        try{
            ps.println("action");
        }
        catch(Exception e){
        }
    }
    public void click(int mx,int my){
        try{
            ps.println("click");
            ps.println(""+mx);
            ps.println(""+my);
        }
        catch(Exception e){
        }
    }
}
