import java.awt.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.applet.*;
import javax.swing.*;
import java.awt.event.*;
public class Dynamite extends JApplet implements KeyListener{
    DframeDynamite dframe;
    static JApplet app;
    private static final long serialVersionUID = -4283824577241338850L;
    public void init(){
        app=this;
        setLayout(null);
        dframe=new DframeDynamite(new ImageFrameDynamite());
        add(dframe);
        setSize(600,480);
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(dframe!=null){
            dframe.process(this,e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==KeyEvent.VK_UP)dframe.up();
            if(key==KeyEvent.VK_DOWN)dframe.down();
            if(key==KeyEvent.VK_LEFT)dframe.left();
            if(key==KeyEvent.VK_RIGHT)dframe.right();
            if(key==KeyEvent.VK_ENTER||key==10||key==13)dframe.bomb();
            if(key==27||key==KeyEvent.VK_ESCAPE){
                dframe.running=false;
                remove(dframe);
                dframe=new DframeDynamite(new ImageFrameDynamite());
                add(dframe);
                dframe.setBounds(0,0,600,480);
            }
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public static void main(String[]args){
//        new Dynamite();
    }
}
class DframeDynamite extends JPanel implements Runnable{
    Thread t;
    ImageFrameDynamite ifr;
    Graphics h;
    Image img;
    Image boden;
    Image stone;
    Image hardstone;
    Image gegneri;
    Image bomb;
    Image player;
    boolean completed=true;
    boolean gameover;
    int levs;
    int curlev;
    int[][]levground=new int[30][22];
    Vector<Object> levels=new Vector<Object>();
    Vector<Object> bombs=new Vector<Object>();
    Vector<Object> gegner=new Vector<Object>();
    int xpos;
    int ypos;
    MediaTracker tracker;
    boolean running=true;
    private static final long serialVersionUID = 2385300190961685461L;
    public DframeDynamite(ImageFrameDynamite ifr){
        setSize(600,480);
        boden=Dynamite.getImage("boden.gif");
        stone=Dynamite.getImage("stone.gif");
        hardstone=Dynamite.getImage("hardstone.gif");
        gegneri=Dynamite.getImage("gegner.gif");
        bomb=Dynamite.getImage("bomb.gif");
        player=Dynamite.getImage("player.gif");
        tracker=new MediaTracker(this);
        tracker.addImage(stone,0);
        tracker.addImage(hardstone,0);
        tracker.addImage(gegneri,0);
        tracker.addImage(bomb,0);
        tracker.addImage(player,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception me){
        }
        t=new Thread(this);
        img=ifr.img;
        h=img.getGraphics();
        loadLevelNames();
        t.start();
    }
    public void bomb(){
        newBomb(xpos/20,ypos/20,true);
    }
    public void loadLevelNames(){
        try{
            InputStream fis=Dynamite.getInputStream("lev.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String lev="";
            while((lev=dis.readLine())!=null){
                levels.addElement(lev);
                levs++;
            }
            fis.close();
        }
        catch(Exception e){};
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(100);
                repaint();
            }
            catch(Exception e){
            }
        }
    }
    public synchronized void process(Dynamite d,KeyEvent e){
        d.process(e);
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,700,700);
        if(curlev>=levs&&completed==true){
            h.setColor(Color.black);
            h.drawString("Game won",100,100);
            g.drawImage(img,0,0,this);
            return;
        }
        if(completed){
            loadNewLevel();
            completed=false;
        }
        for(int i=0;i<30;i++){
            for(int j=0;j<22;j++){
                if(levground[i][j]==0){
                    h.drawImage(boden,i*20,j*20,this);
                }
                if(levground[i][j]==1){
                    h.drawImage(stone,i*20,j*20,this);
                }
                if(levground[i][j]==2){
                    h.drawImage(hardstone,i*20,j*20,this);
                }
                if(levground[i][j]==4){
                    h.drawImage(bomb,i*20,j*20,this);
                }
                if(levground[i][j]==5){
                    levground[i][j]=0;
                    h.drawImage(player,i*20,j*20,this);
                    xpos=i*20;
                    ypos=j*20;
                }
            }
        }
        Object[]o=gegner.toArray();
        if(o.length==0){
            completed=true;
        }
        for(int i=0;i<o.length;i++){
            Gegner g2=(Gegner)o[i];
            if(g2.isAmZiel()){
                newGegner(g2.newx,g2.newy);
                gegner.remove(g2);
            }
            else{
                h.drawImage(gegneri,g2.getX(),g2.getY(),this);
                if(((int)(Math.random()*40))<2){
                    newBomb(g2.getFieldX(),g2.getFieldY(),false);
                }
                g2.step++;
                if(g2.step>3){
                    g2.pos=g2.pos-1;
                    g2.setXY(g2.pos);
                }
            }
        }
        Object[]b=bombs.toArray();
        for(int i=0;i<b.length;i++){
            Bomb bo=(Bomb)b[i];
            if(bo.timer<=0){
                bombs.remove(bo);
                levground[bo.x][bo.y]=0;
            }
            if(bo.timer<=12){
                int length=3-bo.timer/4;
                boolean up=true;
                int posu=0;
                int exo=bo.x;
                int eyo=bo.y;
                while(eyo<22&&up&&posu<=length){
                    if(levground[exo][eyo]==2)break;
                    if(levground[exo][eyo]==1){
                        levground[exo][eyo]=0;
                        up=false;
                    }
                    posu++;
                    eyo++;
                }
                boolean down=true;
                int posu2=0;
                int exo2=bo.x;
                int eyo2=bo.y;
                while(eyo2>=0&&down&&posu2<=length){
                    if(levground[exo2][eyo2]==2)break;
                    if(levground[exo2][eyo2]==1){
                        levground[exo2][eyo2]=0;
                        down=false;
                    }
                    posu2++;
                    eyo2--;
                }
                boolean right=true;
                int posu3=0;
                int exo3=bo.x;
                int eyo3=bo.y;
                while(exo3<30&&right&&posu3<=length){
                    if(levground[exo3][eyo3]==2)break;
                    if(levground[exo3][eyo3]==1){
                        levground[exo3][eyo3]=0;
                        right=false;
                    }
                    posu3++;
                    exo3++;
                }
                boolean left=true;
                int posu4=0;
                int exo4=bo.x;
                int eyo4=bo.y;
                while(exo4>=0&&left&&posu4<=length){
                    if(levground[exo4][eyo4]==2)break;
                    if(levground[exo4][eyo4]==1){
                        levground[exo4][eyo4]=0;
                        left=false;
                    }
                    posu4++;
                    exo4--;
                }
                for(int k=exo4;k<=exo3;k++){
                    if(k==xpos/20&&eyo3==ypos/20){
                        gameover=true;
                    }
                    if(bo.eigen){
                        clear(k,eyo3);
                    }
                    for(int z=0;z<100;z++){
                        int hx=(int)(Math.random()*20);
                        int hy=(int)(Math.random()*20);
                        int col=(int)(Math.random()*2);
                        if(col==0){
                            h.setColor(Color.white);
                            h.fillRect(k*20+hx,eyo4*20+hy,2,2);
                        }
                        else{
                            h.setColor(Color.black);
                            h.fillRect(k*20+hx,eyo4*20+hy,2,2);
                        }
                    }
                }
                for(int k=eyo2;k<=eyo;k++){
                    if(k==ypos/20&&exo==xpos/20){
                        gameover=true;
                    }
                    if(bo.eigen){
                        clear(exo,k);
                    }
                    for(int z=0;z<100;z++){
                        int hx=(int)(Math.random()*20);
                        int hy=(int)(Math.random()*20);
                        int col=(int)(Math.random()*2);
                        if(col==0){
                            h.setColor(Color.white);
                            h.fillRect(exo*20+hx,k*20+hy,2,2);
                        }
                        else{
                            h.setColor(Color.black);
                            h.fillRect(exo*20+hx,k*20+hy,2,2);
                        }
                    }
                }
            }
            bo.timer--;
        }
        if(gameover){
            gameover=false;
            completed=true;
            curlev=0;
        }
        h.drawImage(player,xpos,ypos,this);
        g.drawImage(img,0,40,this);
//        paint(g);
    }
    public void up(){
        if(ypos-20>=0){
            if(levground[xpos/20][(ypos-20)/20]==0){
                ypos-=20;
            }
        }
    }
    public void down(){
        if(ypos+20<440){
            if(levground[xpos/20][(ypos+20)/20]==0){
                ypos+=20;
            }
        }
    }
    public void left(){
        if(xpos-20>=0){
            if(levground[(xpos-20)/20][ypos/20]==0){
                xpos-=20;
            }
        }
    }
    public void right(){
        if(xpos+20<600){
            if(levground[(xpos+20)/20][ypos/20]==0){
                xpos+=20;
            }
        }
    }
    public void clear(int x,int y){
        Object[]o=gegner.toArray();
        for(int i=0;i<o.length;i++){
            Gegner g=(Gegner)o[i];
            if(x==g.getFieldX()&&y==g.getFieldY()){
                gegner.remove(g);
            }
        }
    }
    public void newBomb(int x,int y,boolean eigen){
        Bomb b=new Bomb(x,y);
        b.eigen=eigen;
        bombs.addElement(b);
        levground[x][y]=4;
    }
    public void loadNewLevel(){
        gegner=new Vector<Object>();
        bombs=new Vector<Object>();
        Object[]ls=levels.toArray();
        String dat=(String)ls[curlev];
        try{
            InputStream fis=Dynamite.getInputStream(dat);
            for(int i=0;i<30;i++){
                for(int j=0;j<22;j++){
                    levground[i][j]=fis.read();
                }
            }
            fis.close();
        }
        catch(Exception e){};
        for(int i=0;i<30;i++){
            for(int j=0;j<22;j++){
                if(levground[i][j]==3){
                    levground[i][j]=0;
                    newGegner(i,j);
                }
            }
        }
        curlev++;
    }
    public void newGegner(int i,int j){
        boolean wtar=true;
        Elem result=null;
        while(wtar){
            boolean[][]expl=new boolean[30][22];
            int x=(int)(Math.random()*30);
            int y=(int)(Math.random()*22);
            if(levground[x][y]==0||levground[x][y]==4){
                Queue q=new Queue();
                Elem f=new Elem(i,j,null);
                expl[i][j]=true;
                q.addElem(f);
                boolean searching=true;
                boolean found=false;
                while(searching){
                    if(q.isEmpty()){
                        searching=false;
                        break;
                    }
                    else{
                        Elem e=q.pop();
                        if(e.x==x&&e.y==y){
                            found=true;
                            searching=false;
                            wtar=false;
                            result=e;
                        }
                        else{
                            if(e.x-1>=0){
                                if(levground[e.x-1][e.y]==0&&!expl[e.x-1][e.y]){
                                    expl[e.x-1][e.y]=true;
                                    q.addElem(new Elem(e.x-1,e.y,e));
                                }
                            }
                            if(e.y-1>=0){
                                if(levground[e.x][e.y-1]==0&&!expl[e.x][e.y-1]){
                                    expl[e.x][e.y-1]=true;
                                    q.addElem(new Elem(e.x,e.y-1,e));
                                }
                            }
                            if(e.x+1<30){
                                if(levground[e.x+1][e.y]==0&&!expl[e.x+1][e.y]){
                                    expl[e.x+1][e.y]=true;
                                    q.addElem(new Elem(e.x+1,e.y,e));
                                }
                            }
                            if(e.y+1<22){
                                if(levground[e.x][e.y+1]==0&&!expl[e.x][e.y+1]){
                                    expl[e.x][e.y+1]=true;
                                    q.addElem(new Elem(e.x,e.y+1,e));
                                }
                            }
                        }
                    }
                }
            }
        }
        Gegner g=new Gegner();
        g.endq=result;
        g.waylength=g.getWayLength();
        g.pos=g.waylength-1;
        g.setXY(g.pos);
        gegner.addElement(g);
    }
}
class Bomb{
    int x;
    int y;
    int timer;
    boolean eigen;
    public Bomb(int x,int y){
        this.x=x;
        this.y=y;
        timer=30;
    }
}
class Gegner{
    Elem endq;
    int oldx;
    int oldy;
    int newx;
    int newy;
    int step;
    int waylength;
    int pos;
    public Gegner(){
    }
    public boolean isAmZiel(){
        if(pos<=0&&step==3)return true;
        return false;
    }
    public int getWayLength(){
        Elem nend=endq;
        waylength=0;
        while(nend!=null){
            nend=nend.fore;
            waylength++;
        }
        waylength--;
        return waylength;
    }
    public void incStep(){
        step++;
    }
    public int getFieldX(){
        if(step<=2){
            return oldx;
        }
        else{
            return newx;
        }
    }
    public int getFieldY(){
        if(step<=2){
            return oldy;
        }
        else{
            return newy;
        }
    }
    public void setXY(int pos){
        this.pos=pos;
        Elem old=endq;
        for(int i=0;i<pos+1;i++){
            old=old.fore;
        }
        Elem newe=endq;
        for(int i=0;i<pos;i++){
            newe=newe.fore;
        }
        step=0;
        oldx=old.x;
        oldy=old.y;
        newx=newe.x;
        newy=newe.y;
    }
    public int getX(){
        int dx=newx*20-oldx*20;
        return oldx*20+(dx/4)*step;
    }
    public int getY(){
        int dy=newy*20-oldy*20;
        return oldy*20+(dy/4)*step;
    }
}
class Queue{
    Elem first;
    Elem last;
    public boolean isEmpty(){
        return (first==null);
    }
    public void addElem(Elem e){
        if(first==null){
            first=e;
            last=e;
        }
        else{
            last.next=e;
            last=last.next;
        }
    }
    public Elem pop(){
        if(first==null)return null;
        Elem ret=first;
        first=first.next;
        return ret;
    }
}
class Elem{
    int x;
    int y;
    Elem fore;
    Elem next;
    public Elem(int x,int y,Elem fore){
        this.x=x;
        this.y=y;
        this.fore=fore;
    }
}
class ImageFrameDynamite extends JFrame{
    Image img;
    private static final long serialVersionUID = 1526363582968977328L;
    public ImageFrameDynamite(){
        pack();
        img=createImage(800,800);
    }
}
