import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
public class MiniGolf extends JApplet implements Runnable,ActionListener,MouseListener,KeyListener{
    Thread t;
    Vector<String> playerscontent;
    JList<String> players;
    JScrollPane spplayers;
    Vector<String> resultscontent;
    JList<String> results;
    JScrollPane spresults;
    JTextField player;
    JButton add;
    JButton remove;
    JButton play;
    boolean playb=false;
    String[]levs=new String[0];
    static JApplet app;
    static MiniGolf app2;
    JPanel p1;
    JLabel la;
    MFrameMiniGolf mf;
    boolean cancel=false;
    private static final long serialVersionUID = -2111686659497773848L;
    public void init(){
        app=this;
        app2=this;
        setLayout(null);
        la=new JLabel("MiniGolf");
        add(la);
        setSize(400,480);
        la.setBounds(10,10,200,27);
        playerscontent=new Vector<String>();
        players=new JList<String>(playerscontent);
        spplayers=new JScrollPane(players);
        resultscontent=new Vector<String>();
        results=new JList<String>(resultscontent);
        spresults=new JScrollPane(results);
        player=new JTextField("");
        add=new JButton("add player");
        remove=new JButton("remove");
        play=new JButton("play");
        p1=new JPanel();
        p1.setLayout(null);
        add(p1);
        p1.setBounds(0,40,400,440);
        p1.add(spplayers);
        p1.add(spresults);
        p1.add(player);
        p1.add(add);
        p1.add(remove);
        p1.add(play);
        spplayers.setBounds(10,40,180,140);
        spresults.setBounds(210,40,180,140);
        player.setBounds(10,200,100,27);
        add.setBounds(120,200,100,27);
        remove.setBounds(230,200,100,27);
        play.setBounds(10,230,100,27);
        add.addActionListener(this);
        remove.addActionListener(this);
        play.addActionListener(this);
        levload();
        loadr();
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addMouseListener(this);
        addKeyListener(this);
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void saver(){
        try{
            FileOutputStream fos=new FileOutputStream("res.ini");
            PrintStream ps=new PrintStream(fos);
            int n=resultscontent.size();
            for(int i=0;i<n;i++){
                ps.println(resultscontent.elementAt(i));
            }
            fos.close();
        }
        catch(Exception e){
        }
    }
    public void loadr(){
        try{
            InputStream fis=MiniGolf.getInputStream("res.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp="";
            while((inp=dis.readLine())!=null){
                resultscontent.addElement(inp);
            }
            results.setListData(resultscontent);
            fis.close();
        }
        catch(Exception e){
        }
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(100);
                if(playb){
                    playb=false;
                    int n=levs.length;
                    int playersc=playerscontent.size();
                    String[]pn=new String[playersc];
                    for(int i=0;i<playersc;i++){
                        pn[i]=playerscontent.elementAt(i);
                    }
                    int[]hits=new int[playersc];
                    p1.setVisible(false);
                    for(int i=0;i<n&&!cancel;i++){
                        for(int j=0;j<playersc&&!cancel;j++){
                            mf=new MFrameMiniGolf(levs[i],pn[j],hits[j]);
                            add(mf);
                            mf.setBounds(0,40,400,440);
                            while(!mf.won&&!cancel){
                                Thread.sleep(1000);
                            }
                            hits[j]=hits[j]+mf.hits;
                            remove(mf);
                        }
                    }
                    if(cancel){
                        mf.running=false;
                        la.setText("canceled");
                    }
                    else{
                        la.setText("MiniGolf");
                    }
                    p1.setVisible(true);
                    if(!cancel){
                        for(int i=0;i<playersc;i++){
                            resultscontent.addElement(pn[i]+": "+hits[i]);
                        }
                        results.setListData(resultscontent);
                    }
                    cancel=false;
                }
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public void levload(){
        try{
            InputStream fis2=MiniGolf.getInputStream("levs.ini");
            BufferedReader dis2=new BufferedReader(new InputStreamReader(fis2));
            int n=0;
            while(dis2.readLine()!=null){
                n++;
            }
            fis2.close();
            levs=new String[n];
            InputStream fis=MiniGolf.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp="";
            int i=0;
            while((inp=dis.readLine())!=null){
                levs[i]=inp;
                i++;
            }
            fis.close();
        }
        catch(Exception e){
        }
    }
    public static void main(String[]args){
        new MiniGolf();
    }
//        if(evt.id==Event.WINDOW_DESTROY){
//            saver();
//            System.exit(0);
//        }
    public synchronized void actionPerformed(ActionEvent evt){
            if(evt.getSource()==add){
                if(!"".equals(player.getText())){
                    playerscontent.addElement(player.getText());
                    players.setListData(playerscontent);
                }
            }
            if(evt.getSource()==remove){
                int ind=players.getSelectedIndex();
                if(ind!=-1&&ind<playerscontent.size()){
                    playerscontent.removeElementAt(ind);
                    players.setListData(playerscontent);
                }
            }
            if(evt.getSource()==play){
                playb=true;
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(key==27||key==KeyEvent.VK_ESCAPE){
            cancel=true;
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void mousePressed(MouseEvent me) {
        requestFocus();
        if(mf!=null){
            mf.mprocess(me);
        }
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
    }
}
class MFrameMiniGolf extends JPanel implements Runnable{
    String player;
    String level;
    MCanvasMiniGolf mcanvas;
    Objekte objs;
    double lx=0;
    double ly=0;
    int hits=0;
    Thread t;
    int state=1;
    boolean running=true;
    int xm=0;
    int ym=0;
    int xl2=0;
    int yl2=0;
    double mx=0;
    double my=0;
    long timea=0;
    long timeb=0;
    double speed=0;
    boolean win=false;
    boolean clickedb=false;
    boolean won=false;
    private static final long serialVersionUID = 7143317416340102907L;
    public MFrameMiniGolf(String level,String player,int hits){
        MiniGolf.app2.la.setText(""+player+" at "+level+" with "+hits+" hits total");
//        pack();
//        resize(400,440);
        setLayout(null);
        this.player=player;
        this.level=level;
        objs=new Objekte();
        loadlevel();
        mcanvas=new MCanvasMiniGolf(this);
        mcanvas.xpos=mx;
        mcanvas.ypos=my;
        mcanvas.xcorner=(int)mx-200;
        mcanvas.ycorner=(int)my-200;
        add(mcanvas);
        mcanvas.setBounds(0,40,400,400);
        setVisible(true);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(100);
                mcanvas.step(this);
                mcanvas.repaint();
            }
            catch(Exception e){
            }
        }
    }
    public void step(){
        if(state==0){
            if(clickedb){
                clickedb=false;
                if(xm>=390){
                    mcanvas.xcorner=mcanvas.xcorner-20;
                }
                else if(xm<=10){
                    mcanvas.xcorner=mcanvas.xcorner+20;
                }
                else if(ym>=430){
                    mcanvas.ycorner=mcanvas.ycorner-20;
                }
                else if(ym<=50){
                    mcanvas.ycorner=mcanvas.ycorner+20;
                }
                else{
                    int xl=mcanvas.xcorner+xm;
                    int yl=mcanvas.ycorner+ym-40;
                    mcanvas.xpos=xl;
                    mcanvas.ypos=yl;
                    state=1;
                }
            }
        }
        if(state==1){
            if(clickedb){
                clickedb=false;
                if(xm>=380){
                    mcanvas.xcorner=mcanvas.xcorner-20;
                }
                else if(xm<=20){
                    mcanvas.xcorner=mcanvas.xcorner+20;
                }
                else if(ym>=420){
                    mcanvas.ycorner=mcanvas.ycorner-20;
                }
                else if(ym<=60){
                    mcanvas.ycorner=mcanvas.ycorner+20;
                }
                else{
                    xl2=mcanvas.xcorner+xm;
                    yl2=mcanvas.ycorner+ym-40;
                    timea=System.currentTimeMillis();
                    state=2;
                }
            }
        }
        if(state==2){
            if(clickedb){
                clickedb=false;
                if(xm>=390){
                    mcanvas.xcorner=mcanvas.xcorner-20;
                }
                else if(xm<=10){
                    mcanvas.xcorner=mcanvas.xcorner+20;
                }
                else if(ym>=430){
                    mcanvas.ycorner=mcanvas.ycorner-20;
                }
                else if(ym<=50){
                    mcanvas.ycorner=mcanvas.ycorner+20;
                }
                else{
                    timeb=System.currentTimeMillis();
                    double dx=(int)(mcanvas.xpos-xl2);
                    double dy=(int)(mcanvas.ypos-yl2);
                    double len=Math.sqrt(dx*dx+dy*dy);
                    dx=dx/len;
                    dy=dy/len;
                    mcanvas.xdrift=dx;
                    mcanvas.ydrift=dy;
                    speed=((double)(timeb-timea))/50;
                    if(speed>20){
                        speed=20;
                    }
                    hits++;
                    MiniGolf.app2.la.setText("hits: "+hits);
                    state=3;
                }
            }
        }
        if(state==3){
            Objekt[]objekte=objs.objekte;
            int n=objekte.length;
            int i=0;
            boolean nohit=true;
            mcanvas.xcorner=(int)mcanvas.xpos-200;
            mcanvas.ycorner=(int)mcanvas.ypos-200;
            while(i<n){
                Rechner r=new Rechner(objekte[i],mcanvas.xpos,mcanvas.ypos,mcanvas.xdrift,mcanvas.ydrift,speed);
                if(r.hit){
//System.out.println("xpos: "+r.xpos);
//System.out.println("ypos: "+r.ypos);
//System.out.println("xdrift: "+r.xdir);
//System.out.println("ydrift: "+r.ydir);
                    nohit=false;
                    i=n;
                    mcanvas.xpos=r.xpos;
                    mcanvas.ypos=r.ypos;
                    mcanvas.xdrift=r.xdir;
                    mcanvas.ydrift=r.ydir;
                }
                i++;
            }
            if(nohit){
                mcanvas.xpos+=speed*mcanvas.xdrift;
                mcanvas.ypos+=speed*mcanvas.ydrift;
            }
            speed=speed*0.97;
            double xd=lx-mcanvas.xpos;
            double yd=ly-mcanvas.ypos;
            double entf=Math.sqrt(xd*xd+yd*yd);
            if(entf<=10){
                double dlen=Math.sqrt(xd*xd+yd*yd);
                double xd2=xd/dlen;
                double yd2=yd/dlen;
                mcanvas.xpos=mcanvas.xpos+xd2*(10-dlen)/2;
                mcanvas.ypos=mcanvas.ypos+yd2*(10-dlen)/2;
            }
            if(entf<=3){
                won=true;
                setVisible(false);
                running=false;
            }
            if(speed<=0.1){
                MiniGolf.app2.la.setText("Ready! Hits: "+hits);
                state=1;
            }
        }
    }
    public void loadlevel(){
        try{
            InputStream fis=MiniGolf.getInputStream(level);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            lx=new Double(dis.readLine()).doubleValue();
            ly=new Double(dis.readLine()).doubleValue();
            mx=new Double(dis.readLine()).doubleValue();
            my=new Double(dis.readLine()).doubleValue();
            int n=new Integer(dis.readLine()).intValue();
            for(int i=0;i<n;i++){
                double d1=new Double(dis.readLine()).doubleValue();
                double d2=new Double(dis.readLine()).doubleValue();
                double d3=new Double(dis.readLine()).doubleValue();
                double d4=new Double(dis.readLine()).doubleValue();
                Objekt o=new Objekt(d1,d2,d3-d1,d4-d2);
                objs.add(o);
            }
            fis.close();
        }
        catch(Exception e){
            System.out.println("e: "+e+" : "+level);
        }
    }
    public void mprocess(MouseEvent me){
            xm=me.getX();
            ym=me.getY();
            clickedb=true;
    }
}
class MCanvasMiniGolf extends JPanel{
    MFrameMiniGolf mf;
    Objekte objs;
    double xpos;
    double ypos;
    Image img;
    Graphics h;
    int xcorner=0;
    int ycorner=0;
    double xdrift=0;
    double ydrift=0;
    private static final long serialVersionUID = -1074794352766225204L;
    public MCanvasMiniGolf(MFrameMiniGolf mf){
        this.mf=mf;
        objs=mf.objs;
        ImFrameMiniGolf imf=new ImFrameMiniGolf();
        img=imf.img;
        h=img.getGraphics();
    }
    public synchronized void step(MFrameMiniGolf m){
        m.step();
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.white);
        h.fillRect(-10,-10,500,500);
        if(mf.state==2){
            long timec=System.currentTimeMillis();
            int len=(int)((timec-mf.timea)*0.4);
            if(len>=400){
                len=400;
            }
            h.setColor(Color.black);
            h.fillRect(0,400-len,20,len);
        }
        Objekt[]objekte=objs.objekte;
        h.setColor(Color.black);
        int n=objekte.length;
        for(int i=0;i<n;i++){
            Objekt o=objekte[i];
            int x1=(int)(o.anchorx)-xcorner;
            int y1=(int)(o.anchory)-ycorner;
            int x2=(int)(o.directionx)+x1;
            int y2=(int)(o.directiony)+y1;
            h.drawLine(x1,y1,x2,y2);
        }
        h.setColor(Color.black);
        h.fillOval((int)xpos-3-xcorner,(int)ypos-3-ycorner,6,6);
        h.drawOval((int)mf.lx-4-xcorner,(int)mf.ly-4-ycorner,8,8);
        g.drawImage(img,0,0,this);
//        paint(g);
    }
}
class ImFrameMiniGolf extends JFrame{
    Image img;
    private static final long serialVersionUID = -3832794695135256549L;
    public ImFrameMiniGolf(){
        pack();
        img=createImage(800,600);
    }
}
class Objekte{
    Objekt[]objekte=new Objekt[0];
    public Objekte(){
    }
    public void add(Objekt o){
        int n=objekte.length;
        Objekt[]objekte2=new Objekt[n+1];
        for(int i=0;i<n;i++){
            objekte2[i]=objekte[i];
        }
        objekte2[n]=o;
        objekte=objekte2;
    }
}
class Objekt{
    double anchorx=0;
    double anchory=0;
    double directionx=0;
    double directiony=0;
    public Objekt(double anchorx,double anchory,double directionx,double directiony){
        this.anchorx=anchorx;
        this.anchory=anchory;
        this.directionx=directionx;
        this.directiony=directiony;
    }
}
class Rechner{
    double xpos=0;
    double ypos=0;
    double xdrift=0;
    double ydrift=0;
    double xr=0;
    double yr=0;
    double xhit=0;
    double yhit=0;
    double xdir=0;
    double ydir=0;
    boolean hit=true;
    public Rechner(Objekt o,double xpos,double ypos,double xdir,double ydir,double speed){
        xdrift=xdir*speed;
        ydrift=ydir*speed;
        double[][]matrix=new double[2][3];
        matrix[0][0]=-o.directionx;
        matrix[1][0]=-o.directiony;
        matrix[0][1]=xdrift;
        matrix[1][1]=ydrift;
        matrix[0][2]=o.anchorx-xpos;
        matrix[1][2]=o.anchory-ypos;
//System.out.println("newproc");
//printm(matrix);
        if(matrix[0][0]==0){
            for(int i=0;i<3;i++){
                double tmp=matrix[0][i];
                matrix[0][i]=matrix[1][i];
                matrix[1][i]=tmp;
            }
        }
//printm(matrix);
        if(matrix[1][0]!=0){
            double a=matrix[0][0]/matrix[1][0];
            matrix[1][0]=0;
            matrix[1][1]=matrix[1][1]*a-matrix[0][1];
            matrix[1][2]=matrix[1][2]*a-matrix[0][2];
        }
//printm(matrix);
        if(matrix[1][1]!=0){
            yr=matrix[1][2]/matrix[1][1];
        }
        else{
            hit=false;
        }
        if(hit){
            if(matrix[0][0]!=0){
                xr=(matrix[0][2]-matrix[0][1]*yr)/matrix[0][0];
            }
            else{
                hit=false;
            }
        }
        if(hit&&!(xr>=0&&xr<1&&yr>=0&&yr<1)){
            hit=false;
        }
//System.out.println("xr: "+xr);
//System.out.println("yr: "+yr);
//System.out.println("anchorx: "+o.anchorx);
//System.out.println("anchory: "+o.anchory);
        if(hit){
            xhit=xpos+xdrift*yr;
            yhit=ypos+ydrift*yr;
            double diffx=xpos-xhit;
            double diffy=ypos-yhit;
            double weg=Math.sqrt(diffx*diffx+diffy*diffy);
            double posw=0;
            if(diffx==0){
                if(diffy>=0){
                    posw=Math.PI/2;
                }
                else{
                    posw=-Math.PI/2;
                }
            }
            else{
                posw=Math.atan(diffy/diffx);
                if(diffx<0&&diffy<0){
                    posw=posw+Math.PI;
                }
                if(diffx<0&&diffy>0){
                    posw=posw+Math.PI;
                }
            }
            if(posw>Math.PI){
                posw=posw-2*Math.PI;
            }
            if(posw<-Math.PI){
                posw=posw+2*Math.PI;
            }

            double diffx2=o.anchorx-xhit;
            double diffy2=o.anchory-yhit;
            double posw2=0;
            if(diffx2==0){
                if(diffy2>=0){
                    posw2=Math.PI/2;
                }
                else{
                    posw2=-Math.PI/2;
                }
            }
            else{
                posw2=Math.atan(diffy2/diffx2);
                if(diffx2<0&&diffy2<0){
                    posw2=posw2+Math.PI;
                }
                if(diffx2<0&&diffy2>0){
                    posw2=posw2+Math.PI;
                }
            }
            if(posw2>Math.PI){
                posw2=posw2-2*Math.PI;
            }
            if(posw2<-Math.PI){
                posw2=posw2+2*Math.PI;
            }
            double poswt=posw+Math.PI;
            double poswt2=posw2+Math.PI;
            double diffw=poswt-poswt2;
            if(diffw>Math.PI){
                diffw=-(2*Math.PI-diffw);
            }
            if(diffw<-Math.PI){
                diffw=(2*Math.PI+diffw);
            }
            boolean diffws=false;
            if(diffw<0){
                diffw=-diffw;
                diffws=true;
            }
            double poswt3=poswt2+Math.PI;
            if(poswt3>2*Math.PI){
                poswt3=poswt3-2*Math.PI;
            }
            double diffw2=poswt-poswt3;
            if(diffw2>Math.PI){
                diffw2=-(2*Math.PI-diffw2);
            }
            if(diffw2<-Math.PI){
                diffw2=(2*Math.PI+diffw2);
            }
            boolean diffws2=false;
            if(diffw2<0){
                diffw2=-diffw2;
                diffws2=true;
            }
            double tpos=0;
            if(diffw<=diffw2){
                if(diffws){
                    tpos=poswt-(Math.PI-2*diffw);
//System.out.println("s1 "+diffw);
                }
                else{
                    tpos=poswt+Math.PI-2*diffw;
//System.out.println("s2 "+diffw);
                }
            }
            else{
                if(diffws2){
                    tpos=poswt-(Math.PI-2*diffw2);
//System.out.println("s3 "+diffw2);
                }
                else{
                    tpos=poswt+Math.PI-2*diffw2;
//System.out.println("s4 "+diffw2);
                }
            }
            if(tpos<0){
                tpos=tpos+2*Math.PI;
            }
            if(tpos>=2*Math.PI){
                tpos=tpos-2*Math.PI;
            }
            tpos=tpos-Math.PI;
//System.out.println("poswt: "+poswt);
//System.out.println("poswt2: "+poswt2);
//System.out.println("poswt3: "+poswt3);
//System.out.println("diffw: "+diffw);
//System.out.println("diffw2: "+diffw2);
//System.out.println("tpos: "+tpos);
            this.xdir=Math.cos(tpos);
            this.ydir=Math.sin(tpos);
//System.out.println("xdir: "+this.xdir);
//System.out.println("ydir: "+this.ydir);
            this.xpos=xhit+this.xdir*(speed-weg);
            this.ypos=yhit+this.ydir*(speed-weg);
        }
    }
    public void printm(double[][]x){
        System.out.println("new matrix");
        for(int i=0;i<2;i++){
            for(int j=0;j<3;j++){
                System.out.print(" "+x[i][j]);
            }
            System.out.println("");
        }
    }
}
