import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
public class OpenLevelDynamite3D extends JApplet implements Runnable,ActionListener,KeyListener{
    JLabel la;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    Thread t;
    JButton b;
    boolean startb=false;
    static JApplet app;
    static OpenLevelDynamite3D app2;
    JPanel p1;
    Dynamite3D dyn;
    public void init(){
        app=this;
        app2=this;
        setLayout(null);
        la=new JLabel("Dynamite3D");
        add(la);
        la.setBounds(10,10,200,27);
        setSize(400,480);
        setLayout(null);
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        b=new JButton("open");
        p1=new JPanel();
        p1.setLayout(null);
        add(p1);
        p1.setBounds(0,40,400,440);
        p1.add(spl);
        p1.add(b);
        spl.setBounds(10,40,380,300);
        b.setBounds(10,350,380,27);
        b.addActionListener(this);
        setVisible(true);
        readLevelList();
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(true){
            try{
                repaint();
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                        String levstring=lcontent.elementAt(ind);
                        la.setText("Dynamite3D: "+levstring);
                        p1.setVisible(false);
                        dyn=new Dynamite3D(this,levstring);
                        add(dyn);
                        dyn.setBounds(0,0,400,440);
                    }
                }
            }
            catch(Exception e){
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
            if(evt.getSource()==b){
                startb=true;
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(dyn!=null&&key>0){
            dyn.keycode=key;
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void readLevelList(){
        try{
            InputStream is=OpenLevelDynamite3D.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String news="";
            while((news=dis.readLine())!=null){
                lcontent.addElement(news);
            }
            l.setListData(lcontent);
            is.close();
        }
        catch(Exception e){};
    }
}
class Dynamite3D extends JPanel implements Runnable{
    Thread t;
    int xpos=0;
    int ypos=0;
    int xdrift=0;
    int ydrift=0;
    String name;
    int[][]screen;
    Group[][]groupscreen;
    Group[][]groupscreenb;
    Group player;
    int width=0;
    int height=0;
    int lifes=3;
    int points=0;
    int treasures=0;
    int xstart=0;
    int ystart=0;
    boolean wall=true;
    boolean inverse=false;
    boolean moveplayer=true;
    double alpha=0;
    double beta=Math.PI/4;
    Vektor camerapos;
    Vektor cameraposplus;
    PathPath pp;
    Bomb[]bombs=new Bomb[100];
    EngineDynamite3D eng;
    OpenLevelDynamite3D ol;
    boolean endfirst=true;
    boolean running=true;
    boolean verloren=false;
    int winstatus=0;
    int keycode=0;
    public Dynamite3D(OpenLevelDynamite3D ol,String name){
//        super("Astro Solutions Dynamite3D");
//        resize(400,440);
        setLayout(null);
        this.ol=ol;
        eng=new EngineDynamite3D();
        eng.setStatus("");
        add(eng);
        eng.setBounds(0,40,400,400);
        setVisible(true);
        this.name=name;
        pp=new PathPath();
        screen=new int[30][18];
        groupscreen=new Group[30][18];
        groupscreenb=new Group[30][18];
        player=ObjectGenerator.getPlayer();
        loadScreen();
        build();
        t=new Thread(this);
        t.start();
    }
    public void setWallOn(){
        wall=true;
    }
    public void setWallOff(){
        wall=false;
    }
    public void loadScreen(){
        try{
            InputStream is=OpenLevelDynamite3D.getInputStream(name);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=is.read();
//System.out.println("i: "+i+" j: "+j+" screen: "+screen[i][j]);
                    if(screen[i][j]==3){
                        xpos=i*50;
                        ypos=j*50;
                        xstart=xpos;
                        ystart=ypos;
                        camerapos=new Vektor(xpos+25,ypos+25,300);
                        cameraposplus=new Vektor(-Math.cos(alpha)*300,-Math.sin(alpha)*300,0);
                        player.transform(xpos,ypos,0);
                        eng.add(player);
                        screen[i][j]=0;
                    }
                    if(screen[i][j]==4){
                        Path p=new Path(eng,screen,i,j);
                        pp.add(p);
                        treasures++;
                        screen[i][j]=0;
                    }
                }
            }
        }
        catch(Exception e){
        }
    }
    public void run(){
        int gc=0;
        while(running){
//            try{
//System.out.println("xxx"+Runtime.getRuntime().freeMemory());
                step();
//System.out.println("yyy");
                if(gc>=100){
                    gc=0;
                    System.gc();
                }
                gc=gc+1;
//System.out.println("yyy");
                cameraposplus.x=Math.cos(alpha)*300;
                cameraposplus.y=Math.sin(alpha)*300;
                camerapos.x=xpos+25;
                camerapos.y=ypos+25;
                double xtrans=camerapos.x+cameraposplus.x;
                double ytrans=camerapos.y+cameraposplus.y;
                double ztrans=camerapos.z+cameraposplus.z;
                double alphab=alpha;
                double betab=beta;
                setWallOn();
//System.out.println("transform");
                eng.transform(-xtrans,-ytrans,-ztrans);
//System.out.println("xtrans: "+xtrans);
//System.out.println("ytrans: "+ytrans);
//System.out.println("ztrans: "+ztrans);
//System.out.println("alphab: "+alphab);
//System.out.println("betab: "+betab);
                alphab=alphab+Math.PI;
                if(alphab>2*Math.PI){
                    alphab=alphab-2*Math.PI;
                }
                eng.rotLeft(-alphab);
                eng.rotUp(betab);
//System.out.println("gs: "+groupscreen[0][0].start.start.x);
                eng.setOn();
                eng.move();
                eng.repaint();
try{
                Thread.sleep(100);
}
catch(Exception e){
}
                eng.setOff();
                eng.rotUp(-betab);
                eng.rotLeft(alphab);
                eng.transform(xtrans,ytrans,ztrans);
                setWallOff();
                if(keycode>0){
                    process(keycode);
                    keycode=0;
                }
//            }
//            catch(Exception e){
//                System.out.println("e: "+e);
//                try{
//                    Thread.sleep(10000);
//                }
//                catch(Exception eb){
//                };
//            }
        }
        repaint();
    }
    public static void main(String[]args){
//        new Dynamite3D("TEST.LEV");
        new OpenLevelDynamite3D();
    }
    public void process(int key){
            if(key==27||key==KeyEvent.VK_ESCAPE){
                running=false;
                setVisible(false);
                OpenLevelDynamite3D.app2.p1.setVisible(true);
            }
            if(key==KeyEvent.VK_DOWN){
                if(moveplayer){
//System.out.println("a");
                    keyPressed(-4);
                }
                else{
//System.out.println("b");
                    if(!inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_UP){
                if(moveplayer){
                    keyPressed(-3);
                }
                else{
                    if(inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_RIGHT){
                if(moveplayer){
                    keyPressed(-1);
                }
                else{
                    alpha=alpha-Math.PI/90;
                    if(alpha<0){
                        alpha=alpha+2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_LEFT){
                if(moveplayer){
                    keyPressed(-2);
                }
                else{
                    alpha=alpha+Math.PI/90;
                    if(alpha>2*Math.PI){
                        alpha=alpha-2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_DELETE){
                if(moveplayer){
                    moveplayer=false;
                }
                else{
                    moveplayer=true;
                }
            }
            if(key==KeyEvent.VK_ENTER||key==10||key==13){
                if(moveplayer){
                    keyPressed(-5);
                }
            }
    }
    public void keyPressed(int keycode){
        if(keycode==-3){
            double axpos=xpos;
            if(xpos==0){
                xpos=xpos-50;
            }
            if(xpos-50>=0&&screen[(xpos-50)/50][ypos/50]!=1&&screen[(xpos-50)/50][ypos/50]!=2){
                xpos=xpos-50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-4){
            double axpos=xpos;
            if(xpos==1450){
                xpos=xpos+50;
            }
            if(xpos+50<1500&&screen[(xpos+50)/50][ypos/50]!=1&&screen[(xpos+50)/50][ypos/50]!=2){
                xpos=xpos+50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-2){
            double aypos=ypos;
            if(ypos==850){
                ypos=ypos+50;
            }
            if(ypos+50<900&&screen[xpos/50][(ypos+50)/50]!=1&&screen[xpos/50][(ypos+50)/50]!=2){
                ypos=ypos+50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-1){
            double aypos=ypos;
            if(ypos==0){
                ypos=ypos-50;
            }
            if(ypos-50>=0&&screen[xpos/50][(ypos-50)/50]!=1&&screen[xpos/50][(ypos-50)/50]!=2){
                ypos=ypos-50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-5&&!verloren){
            newbomb(xpos/50,ypos/50,true);
        }
        if(keycode==-8){
//            Loader mov=new Loader(m,"game stopped");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
    }
    public void build(){
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                int x=i;
                int y=j;
                if(x>=0&&y>=0&&x<30&&y<18){
//System.out.println("xp:"+xp+"i:"+i);
                    if(screen[x][y]==0){
                        groupscreen[x][y]=ObjectGenerator.getBoden();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==1){
                        groupscreen[x][y]=ObjectGenerator.getSoftStone();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==2){
                        groupscreen[x][y]=ObjectGenerator.getHardStone();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                }
            }
        }
    }
    public void step(){
//System.out.println("hallo2");
        boolean loso=false;
        int xposb=xpos/50;
        int yposb=ypos/50;
        Path p=pp.start;
//System.out.println("a");
        while(p!=null){
            if(!p.active&&p.first){
                p.first=false;
                eng.remove(p.gegner);
            }
            if(p.active){
                int n=p.xpoint.length;
                int c=p.cur;
                if(c>=n){
                    p.newpath();
                    p.cur=p.cur+1;
                }
                else{
                    int xg=p.xpoint[c]/50;
                    int yg=p.ypoint[c]/50;
                    int ran=(int)(Math.random()*35);
                    if(ran<0){
                        ran=-ran;
                    }
                    if(ran==0){
                        newbomb(xg,yg,false);
                    }
                    for(int i=0;i<100;i++){
                        if(bombs[i]!=null&&bombs[i].yours&&bombs[i].cur<=20){
                            int xb=bombs[i].x;
                            int yb=bombs[i].y;
                            int xd=xg-xb;
                            int yd=yg-yb;
                            if(xd==0&&yd==0&&p.active){
                                treasures--;
                                p.active=false;
                            }
                            else if(xd==0){
                                int yd2=yd;
                                if(yd2<0)yd2=-yd2;
                                int drifty=yd/yd2;
                                int bby=yb;
                                int j=0;
                                while(j<=yd2&&bby>=0&&bby<18&&screen[xb][bby]<2){
                                    bby=bby+drifty;
                                    j++;
                                }
                                if(j==yd2+1&&p.active){
                                    treasures--;
                                    p.active=false;
                                }
                            }
                            else if(yd==0){
                                int xd2=xd;
                                if(xd2<0)xd2=-xd2;
                                int driftx=xd/xd2;
                                int bbx=xb;
                                int j=0;
                                while(j<=xd2&&bbx>=0&&bbx<30&&screen[bbx][yb]<2){
                                    bbx=bbx+driftx;
                                    j++;
                                }
                                if(j==xd2+1&&p.active){
                                    treasures--;
                                    p.active=false;
                                }
                            }
                        }
                    }
                    if(xg==xposb&&yg==yposb){
                        loso=true;
                    }
                    p.cur=p.cur+1;
                    p.gegner.transform(p.xpoint[c]-p.xpoint[c-1],p.ypoint[c]-p.ypoint[c-1],0);
                }
            }
            p=p.next;
        }
//System.out.println("hallo3");
        for(int j=0;j<100;j++){
            if(bombs[j]!=null){
                int co=bombs[j].cur;
                int bx=bombs[j].x;
                int by=bombs[j].y;
                if(co>20){
//System.out.println("bx1: "+bx);
//System.out.println("by1: "+by);
                    if(bombs[j].isnew){
                        eng.add(bombs[j].bomb);
                        bombs[j].inserted();
                    }
                }
                else if(co==20){
//System.out.println("bx2: "+bx);
//System.out.println("by2: "+by);
//System.out.println(""+bombs[j].bomb);
//System.out.println("ssx"+bombs[j].bomb.start.start.x);
//System.out.println("ssxb"+bombs[j].bomb.start.grnext);
                    eng.remove(bombs[j].bomb);
//System.out.println(bombs[j].explosion);
                    if(groupscreenb[bx][by]==null){
                        groupscreenb[bx][by]=ObjectGenerator.getExplosion();
                        groupscreenb[bx][by].transform(bx*50,by*50,0);
                        eng.add(groupscreenb[bx][by]);
                    }
//System.out.println("b");
                    boolean b1=true;
                    boolean b2=true;
                    boolean b3=true;
                    boolean b4=true;
                    for(int ib=1;ib<=3;ib++){
                        if(bx+ib<30&&groupscreenb[bx+ib][by]==null&&b1){
                            groupscreenb[bx+ib][by]=ObjectGenerator.getExplosion();
                            groupscreenb[bx+ib][by].transform((bx+ib)*50,by*50,0);
                            eng.add(groupscreenb[bx+ib][by]);
                            if(screen[bx+ib][by]>1){
                                b1=false;
                            }
                            if(screen[bx+ib][by]==1){
                                screen[bx+ib][by]=0;
                                eng.remove(groupscreen[bx+ib][by]);
                            }
                        }
                        if(bx-ib>=0&&groupscreenb[bx-ib][by]==null&&b2){
                            groupscreenb[bx-ib][by]=ObjectGenerator.getExplosion();
                            groupscreenb[bx-ib][by].transform((bx-ib)*50,by*50,0);
                            eng.add(groupscreenb[bx-ib][by]);
                            if(screen[bx-ib][by]>1){
                                b2=false;
                            }
                            if(screen[bx-ib][by]==1){
                                screen[bx-ib][by]=0;
                                eng.remove(groupscreen[bx-ib][by]);
                            }
                        }
                        if(by-ib>=0&&groupscreenb[bx][by-ib]==null&&b3){
                            groupscreenb[bx][by-ib]=ObjectGenerator.getExplosion();
                            groupscreenb[bx][by-ib].transform(bx*50,(by-ib)*50,0);
                            eng.add(groupscreenb[bx][by-ib]);
                            if(screen[bx][by-ib]>1){
                                b3=false;
                            }
                            if(screen[bx][by-ib]==1){
                                screen[bx][by-ib]=0;
                                eng.remove(groupscreen[bx][by-ib]);
                            }
                        }
                        if(by+ib<18&&groupscreenb[bx][by+ib]==null&&b4){
                            groupscreenb[bx][by+ib]=ObjectGenerator.getExplosion();
                            groupscreenb[bx][by+ib].transform(bx*50,(by+ib)*50,0);
                            eng.add(groupscreenb[bx][by+ib]);
                            if(screen[bx][by+ib]>1){
                                b4=false;
                            }
                            if(screen[bx][by+ib]==1){
                                screen[bx][by+ib]=0;
                                eng.remove(groupscreen[bx][by+ib]);
                            }
                        }
                    }
//System.out.println("c");
                }
                else{
//System.out.println("delse");
                    int f=co%3;
                    int i=0;
                    while(i<=3&&bx+i<30&&screen[bx+i][by]<2){
                        if((bx+i)==xposb&&by==yposb){
                            loso=true;
                        }
                        Group bombexplosion=groupscreenb[bx+i][by];

                        Color colo=Color.red;
                        int rgb3=(int)(Math.random()*256);
                        colo=new Color(rgb3*256*256);
//try{
//Thread.sleep(1000);
//}
//catch(Exception e){
//}
//System.out.println(""+bombexplosion);
//System.out.println("bexpl1: "+bombexplosion.start);
//System.out.println("bexpl2: "+bombexplosion.start.next);
//System.out.println("bexpl3: "+bombexplosion.start.next.next);
//System.out.println("bexpl4: "+bombexplosion.start.next.next.next);
//System.out.println("bexpl5: "+bombexplosion.start.next.next.next.next);
                        if(bombexplosion!=null){
                            bombexplosion.start.col=colo;
                            bombexplosion.start.rcol=Color.red;
                            bombexplosion.start.next.col=colo;
                            bombexplosion.start.next.rcol=Color.red;
                            bombexplosion.start.next.next.col=colo;
                            bombexplosion.start.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.next.rcol=Color.red;
                        }
                        int s=screen[bx+i][by];
                        screen[bx+i][by]=0;
                        i=i+1;
                        if(s==1){
                            i=4;
                        }
                    }
                    i=1;
                    while(i<=3&&bx-i>=0&&screen[bx-i][by]<2){
                        if((bx-i)==xposb&&by==yposb){
                            loso=true;
                        }
                        Group bombexplosion=groupscreenb[bx-i][by];

                        Color colo=Color.red;
                        int rgb3=(int)(Math.random()*256);
                        colo=new Color(rgb3*256*256);
//System.out.println(""+bombexplosion);
//System.out.println("bexpl1: "+bombexplosion.start);
//System.out.println("bexpl2: "+bombexplosion.start.next);
//System.out.println("bexpl3: "+bombexplosion.start.next.next);
//System.out.println("bexpl4: "+bombexplosion.start.next.next.next);
//System.out.println("bexpl5: "+bombexplosion.start.next.next.next.next);
                        if(bombexplosion!=null){
                            bombexplosion.start.col=colo;
                            bombexplosion.start.rcol=Color.red;
                            bombexplosion.start.next.col=colo;
                            bombexplosion.start.next.rcol=Color.red;
                            bombexplosion.start.next.next.col=colo;
                            bombexplosion.start.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.next.rcol=Color.red;
                        }

                        int s=screen[bx-i][by];
                        screen[bx-i][by]=0;
                        i=i+1;
                        if(s==1){
                            i=4;
                        }
                    }
                    i=1;
                    while(i<=3&&by+i<18&&screen[bx][by+i]<2){
                        if(bx==xposb&&(by+i)==yposb){
                            loso=true;
                        }
                        Group bombexplosion=groupscreenb[bx][by+i];

                        Color colo=Color.red;
                        int rgb3=(int)(Math.random()*256);
                        colo=new Color(rgb3*256*256);
//System.out.println(""+bombexplosion);
//System.out.println("bexpl1: "+bombexplosion.start);
//System.out.println("bexpl2: "+bombexplosion.start.next);
//System.out.println("bexpl3: "+bombexplosion.start.next.next);
//System.out.println("bexpl4: "+bombexplosion.start.next.next.next);
//System.out.println("bexpl5: "+bombexplosion.start.next.next.next.next);
                        if(bombexplosion!=null){
                            bombexplosion.start.col=colo;
                            bombexplosion.start.rcol=Color.red;
                            bombexplosion.start.next.col=colo;
                            bombexplosion.start.next.rcol=Color.red;
                            bombexplosion.start.next.next.col=colo;
                            bombexplosion.start.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.next.rcol=Color.red;
                        }

                        int s=screen[bx][by+i];
                        screen[bx][by+i]=0;
                        i=i+1;
                        if(s==1){
                            i=4;
                        }
                    }
                    i=1;
                    while(i<=3&&by-i>=0&&screen[bx][by-i]<2){
                        if(bx==xposb&&(by-i)==yposb){
                            loso=true;
                        }
                        Group bombexplosion=groupscreenb[bx][by-i];

                        Color colo=Color.red;
                        int rgb3=(int)(Math.random()*256);
                        colo=new Color(rgb3*256*256);
//System.out.println(""+bombexplosion);
//System.out.println("bexpl1: "+bombexplosion.start);
//System.out.println("bexpl2: "+bombexplosion.start.next);
//System.out.println("bexpl3: "+bombexplosion.start.next.next);
//System.out.println("bexpl4: "+bombexplosion.start.next.next.next);
//System.out.println("bexpl5: "+bombexplosion.start.next.next.next.next);
                        if(bombexplosion!=null){
                            bombexplosion.start.col=colo;
                            bombexplosion.start.rcol=Color.red;
                            bombexplosion.start.next.col=colo;
                            bombexplosion.start.next.rcol=Color.red;
                            bombexplosion.start.next.next.col=colo;
                            bombexplosion.start.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.rcol=Color.red;
                            bombexplosion.start.next.next.next.next.col=colo;
                            bombexplosion.start.next.next.next.next.rcol=Color.red;
                        }
                        int s=screen[bx][by-i];
                        screen[bx][by-i]=0;
                        i=i+1;
                        if(s==1){
                            i=4;
                        }
                    }
                }
                bombs[j].cur=bombs[j].cur-1;
                if(bombs[j].cur<=0){
                    int ic=0;
                    while(ic<=3){
                        if(bx-ic>=0){
                            if(groupscreenb[bx-ic][by]!=null){
                                eng.remove(groupscreenb[bx-ic][by]);
                                groupscreenb[bx-ic][by]=null;
                            }
                        }
                        if(bx+ic<30){
                            if(groupscreenb[bx+ic][by]!=null){
                                eng.remove(groupscreenb[bx+ic][by]);
                                groupscreenb[bx+ic][by]=null;
                            }
                        }
                        if(by-ic>=0){
                            if(groupscreenb[bx][by-ic]!=null){
                                eng.remove(groupscreenb[bx][by-ic]);
                                groupscreenb[bx][by-ic]=null;
                            }
                        }
                        if(by+ic<18){
                            if(groupscreenb[bx][by+ic]!=null){
                                eng.remove(groupscreenb[bx][by+ic]);
                                groupscreenb[bx][by+ic]=null;
                            }
                        }
                        ic++;
                    }
                    if(groupscreenb[bx][by]!=null){
                        eng.remove(groupscreenb[bx][by]);
                        groupscreenb[bx][by]=null;
                    }
                    bombs[j]=null;
                }
            }
        }
//System.out.println("hallo4");
        if(xpos<0||xpos>=1500){
            loso=true;
        }
        if(ypos<0||ypos>=900){
            loso=true;
        }
        if(treasures==0&&!verloren){
            if(winstatus==0){
                OpenLevelDynamite3D.app2.la.setText("You won!");
                winstatus=1;
            }
            if(endfirst){
                endfirst=false;
                ol.setVisible(true);
            }
//            eng.setStatus("You won!");
//            Loader mov=new Loader(m,"You won!");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
        if(loso){
            lifes--;
            if(lifes<=0){
                verloren=true;
                player.transform(xstart-xpos,ystart-ypos,0);
                xpos=xstart;
                ypos=ystart;
                xdrift=0;
                ydrift=0;
                if(winstatus==0){
                    OpenLevelDynamite3D.app2.la.setText("You lost!");
                    winstatus=2;
                }
                if(endfirst){
                    endfirst=false;
                    ol.setVisible(true);
                }
//                eng.setStatus("You lost!");
//                Loader mov=new Loader(m,"You lost!");
//                Display d=Display.getDisplay(m);
//                d.setCurrent((Displayable)mov);
            }
            else{
                player.transform(xstart-xpos,ystart-ypos,0);
                xpos=xstart;
                ypos=ystart;
                xdrift=0;
                ydrift=0;
            }
        }
//System.out.println("b");
//        h.drawImage(you,width/2+100,height/2+100,0);
//        g.drawImage(img,-100,-100,0);
    }
    public void newbomb(int x,int y,boolean yours){
        int i=0;
        while(i<100&&bombs[i]!=null){
            i++;
        }
        if(i<100){
            bombs[i]=new Bomb(x,y,yours);
        }
    }
}
class PathPath{
    Path start;
    Path end;
    public boolean empty(){
        return (start==null);
    }
    public Path top(){
        Path ret=start;
        if(start!=null){
            start=start.next;
        }
        return ret;
    }
    public void add(Path p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
}
class Path{
    int cur=0;
    Path next;
    int[]xpoint=new int[0];
    int[]ypoint=new int[0];
    int[][]level;
    int x;
    int y;
    boolean active;
    Group gegner;
    boolean first=true;
    public Path(EngineDynamite3D eng,int[][]level,int x,int y){
        this.level=level;
        this.x=x;
        this.y=y;
        active=true;
        gegner=ObjectGenerator.getGegner();
        gegner.transform(x*50,y*50,0);
        eng.add(gegner);
    }
    public void newpath(){
        int ran1=(int)(Math.random()*30);
        if(ran1<0){
            ran1=-ran1;
        }
        int ran2=(int)(Math.random()*18);
        if(ran2<0){
            ran2=-ran2;
        }
        int x2=ran1;
        int y2=ran2;
        PathQueue pq=new PathQueue();
        boolean[][]visited=new boolean[30][18];
        pq.add(x,y,null);
        visited[x][y]=true;
        PathElem last=null;
        for(int i=0;i<25&&!pq.empty();i++){
            PathElem top=pq.top();
            last=top;
            int x3=top.x;
            int y3=top.y;
            if(x3+1>=0&&x3+1<30&&y3>=0&&y3<18&&!visited[x3+1][y3]&&level[x3+1][y3]==0){
                pq.add(x3+1,y3,top);
                visited[x3+1][y3]=true;
            }
            if(x3-1>=0&&x3-1<30&&y3>=0&&y3<18&&!visited[x3-1][y3]&&level[x3-1][y3]==0){
                pq.add(x3-1,y3,top);
                visited[x3-1][y3]=true;
            }
            if(x3>=0&&x3<30&&y3-1>=0&&y3-1<18&&!visited[x3][y3-1]&&level[x3][y3-1]==0){
                pq.add(x3,y3-1,top);
                visited[x3][y3-1]=true;
            }
            if(x3>=0&&x3<30&&y3+1>=0&&y3+1<18&&!visited[x3][y3+1]&&level[x3][y3+1]==0){
                pq.add(x3,y3+1,top);
                visited[x3][y3+1]=true;
            }
        }
        int count=0;
        PathElem cur=last;
        while(cur!=null){
            count++;
            cur=cur.fore;
        }
        int n=(count-1)*4+1;
        xpoint=new int[n];
        ypoint=new int[n];
        cur=last;
        for(int i=0;i<count-1;i++){
            PathElem cn=cur.fore;
            int xd=cn.x-cur.x;
            int yd=cn.y-cur.y;
            for(int j=0;j<4;j++){
                xpoint[i*4+j]=cur.x*50+xd*j*12;
                ypoint[i*4+j]=cur.y*50+yd*j*12;
            }
            cur=cur.fore;
        }
        xpoint[n-1]=cur.x*50;
        ypoint[n-1]=cur.y*50;
        int[]xpoint2=new int[n];
        int[]ypoint2=new int[n];
        for(int i=0;i<n;i++){
            xpoint2[i]=xpoint[n-1-i];
            ypoint2[i]=ypoint[n-1-i];
        }
        xpoint=xpoint2;
        ypoint=ypoint2;
        x=xpoint[n-1]/50;
        y=ypoint[n-1]/50;
        this.cur=0;
    }
}
class PathQueue{
    PathElem start;
    PathElem end;
    public boolean empty(){
        return (start==null);
    }
    public PathElem top(){
        PathElem ret=start;
        if(start!=null){
            start=start.next;
        }
        return ret;
    }
    public void add(int x,int y,PathElem fore){
        PathElem np=new PathElem(x,y,fore);
        if(start==null){
            start=np;
            end=np;
        }
        else{
            end.next=np;
            end=end.next;
        }
    }
}
class PathElem{
    PathElem next;
    PathElem fore;
    int x;
    int y;
    public PathElem(int x,int y,PathElem fore){
        this.x=x;
        this.y=y;
        this.fore=fore;
    }
}
class Bomb{
    int cur;
    boolean yours;
    int x;
    int y;
    Group bomb;
    Group explosion;
    boolean isnew=true;
    public Bomb(int x,int y,boolean yours){
        this.x=x;
        this.y=y;
        this.yours=yours;
        cur=40;
        bomb=ObjectGenerator.getBomb();
//        explosion=ObjectGenerator.getExplosion();
        bomb.transform(x*50,y*50,0);
//        explosion.transform(x*50,y*50,0);
    }
    public void inserted(){
        isnew=false;
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.darkGray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,0);
        Vektor v6=new Vektor(40,10,0);
        Vektor v7=new Vektor(40,40,0);
        Vektor v8=new Vektor(10,40,0);
        Quad q2=new Quad(Color.gray,Color.gray,v5,v6,v7,v8);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getSoftStone(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.yellow,Color.yellow,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,25);
        Vektor v16=new Vektor(5,5,25);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,25);
        Vektor v20=new Vektor(5,45,25);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,25);
        Vektor v24=new Vektor(45,5,25);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getHardStone(){
        Vektor v1=new Vektor(5,5,40);
        Vektor v2=new Vektor(45,5,40);
        Vektor v3=new Vektor(45,45,40);
        Vektor v4=new Vektor(5,45,40);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,40);
        Vektor v6=new Vektor(40,10,40);
        Vektor v7=new Vektor(40,40,40);
        Vektor v8=new Vektor(10,40,40);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,40);
        Vektor v12=new Vektor(5,5,40);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,40);
        Vektor v16=new Vektor(5,5,40);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,40);
        Vektor v20=new Vektor(5,45,40);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,40);
        Vektor v24=new Vektor(45,5,40);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getPlayer(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.green,Color.green,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.blue,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(10,5,10);
        Vektor v14=new Vektor(40,5,10);
        Vektor v15=new Vektor(40,5,20);
        Vektor v16=new Vektor(10,5,20);
        Quad q4=new Quad(Color.green,Color.green,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,5);
        Vektor v18=new Vektor(5,45,5);
        Vektor v19=new Vektor(5,45,25);
        Vektor v20=new Vektor(5,5,25);
        Quad q5=new Quad(Color.blue,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(5,10,10);
        Vektor v22=new Vektor(5,40,10);
        Vektor v23=new Vektor(5,40,20);
        Vektor v24=new Vektor(5,10,20);
        Quad q6=new Quad(Color.green,Color.green,v21,v22,v23,v24);
        Vektor v25=new Vektor(5,45,5);
        Vektor v26=new Vektor(45,45,5);
        Vektor v27=new Vektor(45,45,25);
        Vektor v28=new Vektor(5,45,25);
        Quad q7=new Quad(Color.blue,Color.black,v25,v26,v27,v28);
        Vektor v29=new Vektor(10,45,10);
        Vektor v30=new Vektor(40,45,10);
        Vektor v31=new Vektor(40,45,20);
        Vektor v32=new Vektor(10,45,20);
        Quad q8=new Quad(Color.green,Color.green,v29,v30,v31,v32);
        Vektor v33=new Vektor(45,5,5);
        Vektor v34=new Vektor(45,45,5);
        Vektor v35=new Vektor(45,45,25);
        Vektor v36=new Vektor(45,5,25);
        Quad q9=new Quad(Color.blue,Color.black,v33,v34,v35,v36);
        Vektor v37=new Vektor(45,10,10);
        Vektor v38=new Vektor(45,40,10);
        Vektor v39=new Vektor(45,40,20);
        Vektor v40=new Vektor(45,10,20);
        Quad q10=new Quad(Color.green,Color.green,v37,v38,v39,v40);
        Vektor v41=new Vektor(25,25,37);
        Kugel kug=new Kugel(Color.red,Color.red,v41,12);
        PaintGroup p1=new PaintGroup();
        q1.setPaintGroup(p1);
        q2.setPaintGroup(p1);
        PaintGroup p2=new PaintGroup();
        q3.setPaintGroup(p2);
        q4.setPaintGroup(p2);
        PaintGroup p3=new PaintGroup();
        q5.setPaintGroup(p3);
        q6.setPaintGroup(p3);
        PaintGroup p4=new PaintGroup();
        q7.setPaintGroup(p4);
        q8.setPaintGroup(p4);
        PaintGroup p5=new PaintGroup();
        q9.setPaintGroup(p5);
        q10.setPaintGroup(p5);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        g.add(q8);
        g.add(q9);
        g.add(q10);
        g.add(kug);
        return g;
    }
    public static Group getGegner(){
        Vektor v1=new Vektor(5,5,5);
        Vektor v2=new Vektor(45,5,5);
        Vektor v3=new Vektor(25,25,25);
        Triangle t1=new Triangle(Color.darkGray,Color.black,v1,v2,v3);
        Vektor v4=new Vektor(5,5,5);
        Vektor v5=new Vektor(5,45,5);
        Vektor v6=new Vektor(25,25,25);
        Triangle t2=new Triangle(Color.darkGray,Color.black,v4,v5,v6);
        Vektor v7=new Vektor(5,45,5);
        Vektor v8=new Vektor(45,45,5);
        Vektor v9=new Vektor(25,25,25);
        Triangle t3=new Triangle(Color.darkGray,Color.black,v7,v8,v9);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,45,5);
        Vektor v12=new Vektor(25,25,25);
        Triangle t4=new Triangle(Color.darkGray,Color.black,v10,v11,v12);
        Vektor v13=new Vektor(25,25,37);
        Kugel kug=new Kugel(Color.lightGray,Color.lightGray,v13,12);
        Group g=new Group();
        g.add(t1);
        g.add(t2);
        g.add(t3);
        g.add(t4);
        g.add(kug);
        return g;
    }
    public static Group getBomb(){
        Vektor v1=new Vektor(25,25,25);
        Kugel kug=new Kugel(Color.black,Color.black,v1,25);
        Group g=new Group();
        g.add(kug);
        return g;
    }
    public static Group getExplosion(){
        Vektor v1=new Vektor(0,0,50);
        Vektor v2=new Vektor(50,0,50);
        Vektor v3=new Vektor(50,50,50);
        Vektor v4=new Vektor(0,50,50);
        Quad q1=new Quad(Color.red,Color.red,v1,v2,v3,v4);
        Vektor v5=new Vektor(0,0,0);
        Vektor v6=new Vektor(50,0,0);
        Vektor v7=new Vektor(50,0,50);
        Vektor v8=new Vektor(0,0,50);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(0,0,0);
        Vektor v10=new Vektor(0,50,0);
        Vektor v11=new Vektor(0,50,50);
        Vektor v12=new Vektor(0,0,50);
        Quad q3=new Quad(Color.red,Color.red,v9,v10,v11,v12);
        Vektor v13=new Vektor(0,50,0);
        Vektor v14=new Vektor(50,50,0);
        Vektor v15=new Vektor(50,50,50);
        Vektor v16=new Vektor(0,50,50);
        Quad q4=new Quad(Color.red,Color.red,v13,v14,v15,v16);
        Vektor v17=new Vektor(50,0,0);
        Vektor v18=new Vektor(50,50,0);
        Vektor v19=new Vektor(50,50,50);
        Vektor v20=new Vektor(50,0,50);
        Quad q5=new Quad(Color.red,Color.red,v17,v18,v19,v20);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        return g;
    }
}
class EngineDynamite3D extends JPanel{
    Thread t;
    ImageFrameKmoon3D imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineDynamite3D(){
        imf=new ImageFrameKmoon3D();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
//    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
//    }
    public synchronized void paint(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
//        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameKmoon3D extends JFrame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameKmoon3D(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
