import java.io.*;
import java.net.*;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
public class OpenLevelStrangeWorld extends JApplet implements Runnable,KeyListener,ActionListener{
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    Thread t;
    JButton b;
    boolean startb=false;
    JLabel label;
    static JApplet app;
    static OpenLevelStrangeWorld app2;
    JPanel p1;
    StrangeWorld sw;
    private static final long serialVersionUID = 2536911410564892873L;
    public void init(){
        app=this;
        app2=this;
        setSize(400,440);
        setLayout(null);
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        b=new JButton("open");
        label=new JLabel("use delete and cursor keys");
        p1=new JPanel();
        p1.setLayout(null);
        add(p1);
        p1.setBounds(0,0,400,440);
        p1.add(spl);
        p1.add(b);
        p1.add(label);
        spl.setBounds(10,40,380,300);
        b.setBounds(10,350,380,27);
        b.addActionListener(this);
        label.setBounds(10,380,380,27);
        setVisible(true);
        readLevelList();
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                        String levstring=lcontent.elementAt(ind);
                        p1.setVisible(false);
                        sw=new StrangeWorld(this,levstring);
                        add(sw);
                        sw.setBounds(0,0,400,440);
                    }
                }
            }
            catch(Exception e){
            }
        }
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void actionPerformed(ActionEvent evt){
            if(evt.getSource()==b){
                startb=true;
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(sw!=null){
            sw.process(e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void readLevelList(){
        try{
            InputStream is=OpenLevelStrangeWorld.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String news="";
            while((news=dis.readLine())!=null){
                lcontent.addElement(news);
            }
            l.setListData(lcontent);
            is.close();
        }
        catch(Exception e){};
    }
}
class StrangeWorld extends JPanel implements Runnable{
    Thread t;
    double xpos=0;
    double ypos=0;
    double xplus=0;
    double yplus=0;
    String name;
    int[][]screen;
    Group[][]groupscreen1;
    Group[][]groupscreen2;
    Group[][]groupscreen3;
    Group[][]groupscreen4;
    Group[][]groupscreen5;
    Group[][]groupscreen6;
    int lifes=3;
    int points=0;
    boolean key=false;
    boolean door=false;
    boolean wall=true;
    boolean inverse=false;
    boolean moveplayer=true;
    double alpha=3*Math.PI/2;
    double beta=0;
    Vektor camera;
    EngineStrangeWorld eng;
    OpenLevelStrangeWorld ol;
    int keypressed=0;
    Vektor camerapos;
    boolean running=true;
    int counter=0;
    boolean newb=true;
    private static final long serialVersionUID = -1278249513020651961L;
    public StrangeWorld(OpenLevelStrangeWorld ol,String name){
//        super("Astro Solutions StrangeWorld 3D");
//        resize(400,440);
        setLayout(null);
        this.ol=ol;
        camerapos=new Vektor(0,0,110);
        eng=new EngineStrangeWorld();
        eng.setStatus("");
        add(eng);
        eng.setBounds(0,40,400,400);
        setVisible(true);
        this.name=name;
        screen=new int[20][20];
        groupscreen1=new Group[20][20];
        groupscreen2=new Group[20][20];
        groupscreen3=new Group[20][20];
        groupscreen4=new Group[20][20];
        groupscreen5=new Group[20][20];
        groupscreen6=new Group[20][20];
        loadscreen();
        t=new Thread(this);
        t.start();
    }
    public void keyPressed(int key){
        keypressed=key;
    }
    public void setWallOn(){
        wall=true;
    }
    public void setWallOff(){
        wall=false;
    }
    public void loadscreen(){
        try{
            InputStream is=OpenLevelStrangeWorld.getInputStream(name);
            for(int i=0;i<20;i++){
                for(int j=0;j<20;j++){
                    screen[i][j]=is.read();
                    if(screen[i][j]==0){
                        Group g=Objects.getFloor();
                        g.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g;
                        eng.add(g);
                    }
                    else if(screen[i][j]==1){
                        Group g1=Objects.getWand1();
                        Group g1b=Objects.getWand1();
                        g1b.transform(200,0,0);
                        Group g2=Objects.getWand2();
                        Group g2b=Objects.getWand2();
                        g2b.transform(0,200,0);
                        Group g3=Objects.getWand3();
                        Group g3b=Objects.getWand3();
                        g3b.transform(0,0,200);
                        g1.transform(i*220+10,j*220+10,0);
                        g1b.transform(i*220+10,j*220+10,0);
                        g2.transform(i*220+10,j*220+10,0);
                        g2b.transform(i*220+10,j*220+10,0);
                        g3.transform(i*220+10,j*220+10,0);
                        g3b.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g1;
                        groupscreen2[i][j]=g1b;
                        groupscreen3[i][j]=g2;
                        groupscreen4[i][j]=g2b;
                        groupscreen5[i][j]=g3;
                        groupscreen6[i][j]=g3b;
                        eng.add(g1);
                        eng.add(g1b);
                        eng.add(g2);
                        eng.add(g2b);
                        eng.add(g3);
                        eng.add(g3b);
                    }
                    else if(screen[i][j]==8){
                        Group g1=Objects.getLoch1();
                        Group g1b=Objects.getLoch1();
                        g1b.transform(200,0,0);
                        Group g2=Objects.getLoch2();
                        Group g2b=Objects.getLoch2();
                        g2b.transform(0,200,0);
                        Group g3=Objects.getLoch3();
                        Group g3b=Objects.getLoch3();
                        g3b.transform(0,0,200);
                        g1.transform(i*220+10,j*220+10,0);
                        g1b.transform(i*220+10,j*220+10,0);
                        g2.transform(i*220+10,j*220+10,0);
                        g2b.transform(i*220+10,j*220+10,0);
                        g3.transform(i*220+10,j*220+10,0);
                        g3b.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g1;
                        groupscreen2[i][j]=g1b;
                        groupscreen3[i][j]=g2;
                        groupscreen4[i][j]=g2b;
                        groupscreen5[i][j]=g3;
                        groupscreen6[i][j]=g3b;
                        eng.add(g1);
                        eng.add(g1b);
                        eng.add(g2);
                        eng.add(g2b);
                        eng.add(g3);
                        eng.add(g3b);
                    }
                    else if(screen[i][j]==10){
                        Group g1=Objects.getSauger1();
                        Group g1b=Objects.getSauger1();
                        g1b.transform(200,0,0);
                        Group g2=Objects.getSauger2();
                        Group g2b=Objects.getSauger2();
                        g2b.transform(0,200,0);
                        Group g3=Objects.getSauger3();
                        Group g3b=Objects.getSauger3();
                        g3b.transform(0,0,200);
                        g1.transform(i*220+10,j*220+10,0);
                        g1b.transform(i*220+10,j*220+10,0);
                        g2.transform(i*220+10,j*220+10,0);
                        g2b.transform(i*220+10,j*220+10,0);
                        g3.transform(i*220+10,j*220+10,0);
                        g3b.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g1;
                        groupscreen2[i][j]=g1b;
                        groupscreen3[i][j]=g2;
                        groupscreen4[i][j]=g2b;
                        groupscreen5[i][j]=g3;
                        groupscreen6[i][j]=g3b;
                        eng.add(g1);
                        eng.add(g1b);
                        eng.add(g2);
                        eng.add(g2b);
                        eng.add(g3);
                        eng.add(g3b);
                    }
                    else if(screen[i][j]==15){
                        Group g=Objects.getFloor();
                        g.transform(i*220+10,j*220+10,0);
                        eng.add(g);

                        Group g1=Objects.getKey1();
                        Group g1b=Objects.getKey1();
                        g1b.transform(200,0,0);
                        Group g2=Objects.getKey2();
                        Group g2b=Objects.getKey2();
                        g2b.transform(0,200,0);
                        Group g3=Objects.getKey3();
                        Group g3b=Objects.getKey3();
                        g3b.transform(0,0,200);
                        g1.transform(i*220+10,j*220+10,0);
                        g1b.transform(i*220+10,j*220+10,0);
                        g2.transform(i*220+10,j*220+10,0);
                        g2b.transform(i*220+10,j*220+10,0);
                        g3.transform(i*220+10,j*220+10,0);
                        g3b.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g1;
                        groupscreen2[i][j]=g1b;
                        groupscreen3[i][j]=g2;
                        groupscreen4[i][j]=g2b;
                        groupscreen5[i][j]=g3;
                        groupscreen6[i][j]=g3b;
                        eng.add(g1);
                        eng.add(g1b);
                        eng.add(g2);
                        eng.add(g2b);
                        eng.add(g3);
                        eng.add(g3b);
                    }
                    else if(screen[i][j]==12){
                        Group g=Objects.getFloor();
                        g.transform(i*220+10,j*220+10,0);
                        eng.add(g);

                        Group g1=Objects.getDoor1();
                        Group g1b=Objects.getDoor1();
                        g1b.transform(200,0,0);
                        Group g2=Objects.getDoor2();
                        Group g2b=Objects.getDoor2();
                        g2b.transform(0,200,0);
                        Group g3=Objects.getDoor3();
                        Group g3b=Objects.getDoor3();
                        g3b.transform(0,0,200);
                        g1.transform(i*220+10,j*220+10,0);
                        g1b.transform(i*220+10,j*220+10,0);
                        g2.transform(i*220+10,j*220+10,0);
                        g2b.transform(i*220+10,j*220+10,0);
                        g3.transform(i*220+10,j*220+10,0);
                        g3b.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g1;
                        groupscreen2[i][j]=g1b;
                        groupscreen3[i][j]=g2;
                        groupscreen4[i][j]=g2b;
                        groupscreen5[i][j]=g3;
                        groupscreen6[i][j]=g3b;
                        eng.add(g1);
                        eng.add(g1b);
                        eng.add(g2);
                        eng.add(g2b);
                        eng.add(g3);
                        eng.add(g3b);
                    }
                    else if(screen[i][j]==3){
                        Group g=Objects.getFloor();
                        g.transform(i*220+10,j*220+10,0);
                        eng.add(g);

                        Group g1=Objects.getDetek1();
                        Group g1b=Objects.getDetek1();
                        g1b.transform(200,0,0);
                        Group g2=Objects.getDetek2();
                        Group g2b=Objects.getDetek2();
                        g2b.transform(0,200,0);
                        Group g3=Objects.getDetek3();
                        Group g3b=Objects.getDetek3();
                        g3b.transform(0,0,200);
                        g1.transform(i*220+10,j*220+10,0);
                        g1b.transform(i*220+10,j*220+10,0);
                        g2.transform(i*220+10,j*220+10,0);
                        g2b.transform(i*220+10,j*220+10,0);
                        g3.transform(i*220+10,j*220+10,0);
                        g3b.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g1;
                        groupscreen2[i][j]=g1b;
                        groupscreen3[i][j]=g2;
                        groupscreen4[i][j]=g2b;
                        groupscreen5[i][j]=g3;
                        groupscreen6[i][j]=g3b;
                        eng.add(g1);
                        eng.add(g1b);
                        eng.add(g2);
                        eng.add(g2b);
                        eng.add(g3);
                        eng.add(g3b);
                    }
                    else if(screen[i][j]==14){
                        Group g=Objects.getFloor();
                        g.transform(i*220+10,j*220+10,0);
                        eng.add(g);

                        Group g1=Objects.getTreasure1();
                        Group g1b=Objects.getTreasure1();
                        g1b.transform(200,0,0);
                        Group g2=Objects.getTreasure2();
                        Group g2b=Objects.getTreasure2();
                        g2b.transform(0,200,0);
                        Group g3=Objects.getTreasure3();
                        Group g3b=Objects.getTreasure3();
                        g3b.transform(0,0,200);
                        g1.transform(i*220+10,j*220+10,0);
                        g1b.transform(i*220+10,j*220+10,0);
                        g2.transform(i*220+10,j*220+10,0);
                        g2b.transform(i*220+10,j*220+10,0);
                        g3.transform(i*220+10,j*220+10,0);
                        g3b.transform(i*220+10,j*220+10,0);
                        groupscreen1[i][j]=g1;
                        groupscreen2[i][j]=g1b;
                        groupscreen3[i][j]=g2;
                        groupscreen4[i][j]=g2b;
                        groupscreen5[i][j]=g3;
                        groupscreen6[i][j]=g3b;
                        eng.add(g1);
                        eng.add(g1b);
                        eng.add(g2);
                        eng.add(g2b);
                        eng.add(g3);
                        eng.add(g3b);
                    }
                    else{
                        int r=(int)(Math.random()*256);
                        int g2=(int)(Math.random()*256);
                        int b=(int)(Math.random()*256);
                        Color col=new Color(r,g2,b);
                        Vektor v=new Vektor(i*220+110,j*220+110,110);
                        Kugel k=new Kugel(col,col,v,50);
                        Group g=new Group();
                        g.add(k);
                        eng.add(g);
                        groupscreen1[i][j]=g;
                        Group f=Objects.getFloor();
                        f.transform(i*220+10,j*220+10,0);
                        groupscreen2[i][j]=f;
                        eng.add(f);
                    }
                }
            }
            is.close();
        }
        catch(Exception e){
        }
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==27||key==KeyEvent.VK_ESCAPE){
                running=false;
                ol.label.setText("You used ESC to quit level. ");
                setVisible(false);
                OpenLevelStrangeWorld.app2.p1.setVisible(true);
            }
            if(key==KeyEvent.VK_DOWN){
                if(moveplayer){
//System.out.println("a");
                    keyPressed(-4);
                }
                else{
//System.out.println("b");
                    if(!inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_UP){
                if(moveplayer){
                    keyPressed(-3);
                }
                else{
                    if(inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_LEFT){
                if(false&&moveplayer){
                    keyPressed(-1);
                }
                else{
                    alpha=alpha-Math.PI/90;
                    if(alpha<0){
                        alpha=alpha+2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_RIGHT){
                if(false&&moveplayer){
                    keyPressed(-2);
                }
                else{
                    alpha=alpha+Math.PI/90;
                    if(alpha>2*Math.PI){
                        alpha=alpha-2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_DELETE){
                if(moveplayer){
                    moveplayer=false;
                }
                else{
                    moveplayer=true;
                }
            }
    }
    public void run(){
        int gc=0;
        while(running){
//            try{
//System.out.println("xxx"+Runtime.getRuntime().freeMemory());
                step();
                if(lifes<=0){
                    eng.setStatus("you lost! points: "+points);
                }
                else if(door){
                    eng.setStatus("you won! points: "+points);
                }
                else{
                    eng.setStatus("key: "+key+" points: "+points);
                }
                camerapos.transform(xplus,yplus,0);
//System.out.println("yyy");
                if(gc>=100){
                    gc=0;
                    System.gc();
                }
                gc=gc+1;
//System.out.println("yyy");
                double xtrans=camerapos.x;
                double ytrans=camerapos.y;
                double ztrans=camerapos.z;
                double alphab=alpha;
                double betab=beta;
                setWallOn();
//System.out.println("transform");
                eng.transform(-xtrans,-ytrans,-ztrans);
//System.out.println("xtrans: "+xtrans);
//System.out.println("ytrans: "+ytrans);
//System.out.println("ztrans: "+ztrans);
//System.out.println("alphab: "+alphab);
//System.out.println("betab: "+betab);
                alphab=alphab+Math.PI;
                if(alphab>2*Math.PI){
                    alphab=alphab-2*Math.PI;
                }
                eng.rotLeft(-alphab);
                eng.rotUp(betab);
//System.out.println("gs: "+groupscreen[0][0].start.start.x);
                eng.setOn();
                eng.move();
                eng.repaint();
try{
                Thread.sleep(100);
}
catch(Exception e){
}
                eng.setOff();
                eng.rotUp(-betab);
                eng.rotLeft(alphab);
                eng.transform(xtrans,ytrans,ztrans);
                setWallOff();
//            }
//            catch(Exception e){
//                System.out.println("e: "+e);
//                try{
//                    Thread.sleep(10000);
//                }
//                catch(Exception eb){
//                };
//            }
        }
    }
    public void step(){
        int xr=0;
        int yr=0;
        counter++;
        if(counter>=10){
            points--;
            counter=0;
        }
        if(keypressed!=0){
            if(keypressed==-3){
                xr=-(int)(Math.cos(alpha)*25);
                yr=-(int)(Math.sin(alpha)*25);
                camerapos.x=camerapos.x+xr;
                camerapos.y=camerapos.y+yr;
            }
            if(keypressed==-4){
                xr=(int)(Math.cos(alpha)*25);
                yr=(int)(Math.sin(alpha)*25);
                camerapos.x=camerapos.x+xr;
                camerapos.y=camerapos.y+yr;
            }
            keypressed=0;
        }
        int x=(int)(camerapos.x/220);
        int y=(int)(camerapos.y/220);
        if(x>=0&&y>=0&&x<=19&&y<=19){
            if(screen[x][y]==1){
                camerapos.x=camerapos.x-xr;
                camerapos.y=camerapos.y-yr;
            }
            else if(screen[x][y]==8){
                camerapos.x=0;
                camerapos.y=0;
                lifes--;
                if(lifes<=0){
                    ol.label.setText("You lost in level "+name+"!");
                    hide();
                    ol.p1.show();
//                    new OpenLevelStrangeWorld();
                }
            }
            else if(screen[x][y]==10){
                points=points-10;
            }
            else if(screen[x][y]==12&&key){
                door=true;
                if(newb){
                    newb=false;
                    ol.label.setText("You won the level "+name+" with "+points+" points!");
                    hide();
                    ol.p1.show();
//                    new OpenLevelStrangeWorld();
                }
            }
            else if(screen[x][y]==12&&!key){
                camerapos.x=camerapos.x-xr;
                camerapos.y=camerapos.y-yr;
            }
            else if(screen[x][y]==14){
                if(groupscreen1[x][y]!=null){
                    points=points+150;
                    eng.remove(groupscreen1[x][y]);
                    groupscreen1[x][y]=null;
                }
                if(groupscreen2[x][y]!=null){
                    eng.remove(groupscreen2[x][y]);
                    groupscreen2[x][y]=null;
                }
                if(groupscreen3[x][y]!=null){
                    eng.remove(groupscreen3[x][y]);
                    groupscreen3[x][y]=null;
                }
                if(groupscreen4[x][y]!=null){
                    eng.remove(groupscreen4[x][y]);
                    groupscreen4[x][y]=null;
                }
                if(groupscreen5[x][y]!=null){
                    eng.remove(groupscreen5[x][y]);
                    groupscreen5[x][y]=null;
                }
                if(groupscreen6[x][y]!=null){
                    eng.remove(groupscreen6[x][y]);
                    groupscreen6[x][y]=null;
                }
            }
            else if(screen[x][y]==3){
                if(groupscreen1[x][y]!=null){
                    points=points+200;
                    eng.remove(groupscreen1[x][y]);
                    groupscreen1[x][y]=null;
                }
                if(groupscreen2[x][y]!=null){
                    eng.remove(groupscreen2[x][y]);
                    groupscreen2[x][y]=null;
                }
                if(groupscreen3[x][y]!=null){
                    eng.remove(groupscreen3[x][y]);
                    groupscreen3[x][y]=null;
                }
                if(groupscreen4[x][y]!=null){
                    eng.remove(groupscreen4[x][y]);
                    groupscreen4[x][y]=null;
                }
                if(groupscreen5[x][y]!=null){
                    eng.remove(groupscreen5[x][y]);
                    groupscreen5[x][y]=null;
                }
                if(groupscreen6[x][y]!=null){
                    eng.remove(groupscreen6[x][y]);
                    groupscreen6[x][y]=null;
                }
            }
            else if(screen[x][y]==15){
                key=true;
                if(groupscreen1[x][y]!=null){
                    eng.remove(groupscreen1[x][y]);
                    groupscreen1[x][y]=null;
                }
                if(groupscreen2[x][y]!=null){
                    eng.remove(groupscreen2[x][y]);
                    groupscreen2[x][y]=null;
                }
                if(groupscreen3[x][y]!=null){
                    eng.remove(groupscreen3[x][y]);
                    groupscreen3[x][y]=null;
                }
                if(groupscreen4[x][y]!=null){
                    eng.remove(groupscreen4[x][y]);
                    groupscreen4[x][y]=null;
                }
                if(groupscreen5[x][y]!=null){
                    eng.remove(groupscreen5[x][y]);
                    groupscreen5[x][y]=null;
                }
                if(groupscreen6[x][y]!=null){
                    eng.remove(groupscreen6[x][y]);
                    groupscreen6[x][y]=null;
                }
            }
            else if(screen[x][y]>0){
                if(groupscreen1[x][y]!=null){
                    points=points+screen[x][y]*10;
                    eng.remove(groupscreen1[x][y]);
                    groupscreen1[x][y]=null;
                }
            }
        }
    }
    public static void main(String[]args){
//        new Dynamite3D("TEST.LEV");
        new OpenLevelStrangeWorld();
    }
}
class Objects{
    public static Group getFloor(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(200,0,200);
Color cb1=new Color(255,0,255);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.3333333333333333,0.3666666666666665,0.0);
p1.add(v1);
Vektor v2=new Vektor(199.6,0.3666666666666665,0.0);
p1.add(v2);
Vektor v3=new Vektor(199.6,199.66666666666666,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.3333333333333333,199.66666666666666,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,250,250);
Color cb2=new Color(0,20,120);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(20.0,20.0,0.0);
p2.add(v5);
Vektor v6=new Vektor(180.0,20.03333333333333,0.0);
p2.add(v6);
Vektor v7=new Vektor(180.33333333333334,180.33333333333334,0.0);
p2.add(v7);
Vektor v8=new Vektor(20.066666666666666,180.06666666666666,0.0);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(10,10,190);
Color cb3=new Color(0,0,255);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(50.03333333333333,50.0,0.0);
p3.add(v9);
Vektor v10=new Vektor(150.06666666666666,50.066666666666634,0.0);
p3.add(v10);
Vektor v11=new Vektor(150.03333333333333,150.06666666666666,0.0);
p3.add(v11);
Vektor v12=new Vektor(50.06666666666666,150.33333333333334,0.0);
p3.add(v12);
p3.setPaintGroup(pg);
g.add(p3);
Color ca4=new Color(200,0,0);
Color cb4=new Color(150,0,0);
Polygon p4=new Polygon(ca4,cb4);
Vektor v13=new Vektor(80.0,80.0,0.0);
p4.add(v13);
Vektor v14=new Vektor(120.0,80.06666666666668,0.0);
p4.add(v14);
Vektor v15=new Vektor(120.0,120.06666666666665,0.0);
p4.add(v15);
Vektor v16=new Vektor(80.0,120.06666666667,0.0);
p4.add(v16);
p4.setPaintGroup(pg);
g.add(p4);
return g;
    }
    public static Group getWand1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(0,0,255);
Color cb1=new Color(0,255,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.0,1.333333333333334,1.5);
p1.add(v1);
Vektor v2=new Vektor(0.0,198.66666666666666,1.3333333333333333);
p1.add(v2);
Vektor v3=new Vektor(0.0,199.33333333333334,198.66666666666666);
p1.add(v3);
Vektor v4=new Vektor(0.0,1.333333333333334,198.66666666666666);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(255,0,0);
Color cb2=new Color(0,255,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(0.0,27.333333333333332,12.666666666666664);
p2.add(v5);
Vektor v6=new Vektor(0.0,188.0,12.666666666666664);
p2.add(v6);
Vektor v7=new Vektor(0.0,188.33333333333334,172.0);
p2.add(v7);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(127,0,0);
Color cb3=new Color(0,255,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v8=new Vektor(0.0,13.333333333333334,23.0);
p3.add(v8);
Vektor v9=new Vektor(0.0,179.33333333333334,187.33333333333334);
p3.add(v9);
Vektor v10=new Vektor(0.0,13.33333333333334,187.66666666666666);
p3.add(v10);
p3.setPaintGroup(pg);
g.add(p3);
Color ca4=new Color(0,127,0);
Color cb4=new Color(0,255,0);
Polygon p4=new Polygon(ca4,cb4);
Vektor v11=new Vektor(0.0,41.333333333333336,65.33333333333333);
p4.add(v11);
Vektor v12=new Vektor(0.0,156.0,65.66666666666666);
p4.add(v12);
Vektor v13=new Vektor(0.0,156.0,128.0);
p4.add(v13);
Vektor v14=new Vektor(0.0,41.666666666666664,128.0);
p4.add(v14);
p4.setPaintGroup(pg);
g.add(p4);
return g;
    }
    public static Group getWand2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(0,0,255);
Color cb1=new Color(0,255,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(1.333333333333334,0.0,1.5);
p1.add(v1);
Vektor v2=new Vektor(198.66666666666666,0.0,1.3333333333333333);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,0.0,198.66666666666666);
p1.add(v3);
Vektor v4=new Vektor(1.333333333333334,0.0,198.66666666666666);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(255,0,0);
Color cb2=new Color(0,255,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(27.333333333333332,0.0,12.666666666666664);
p2.add(v5);
Vektor v6=new Vektor(188.0,0.0,12.666666666666664);
p2.add(v6);
Vektor v7=new Vektor(188.33333333333334,0.0,172.0);
p2.add(v7);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(127,0,0);
Color cb3=new Color(0,255,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v8=new Vektor(13.333333333333334,0.0,23.0);
p3.add(v8);
Vektor v9=new Vektor(179.33333333333334,0.0,187.33333333333334);
p3.add(v9);
Vektor v10=new Vektor(13.33333333333334,0.0,187.66666666666666);
p3.add(v10);
p3.setPaintGroup(pg);
g.add(p3);
Color ca4=new Color(0,127,0);
Color cb4=new Color(0,255,0);
Polygon p4=new Polygon(ca4,cb4);
Vektor v11=new Vektor(41.333333333333336,0.0,65.33333333333333);
p4.add(v11);
Vektor v12=new Vektor(156.0,0.0,65.66666666666666);
p4.add(v12);
Vektor v13=new Vektor(156.0,0.0,128.0);
p4.add(v13);
Vektor v14=new Vektor(41.666666666666664,0.0,128.0);
p4.add(v14);
p4.setPaintGroup(pg);
g.add(p4);
return g;
    }
    public static Group getWand3(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(0,0,255);
Color cb1=new Color(0,255,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(1.333333333333334,1.5,0.0);
p1.add(v1);
Vektor v2=new Vektor(198.66666666666666,1.3333333333333333,0.0);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,198.66666666666666,0.0);
p1.add(v3);
Vektor v4=new Vektor(1.333333333333334,198.66666666666666,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(255,0,0);
Color cb2=new Color(0,255,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(27.333333333333332,12.666666666666664,0.0);
p2.add(v5);
Vektor v6=new Vektor(188.0,12.666666666666664,0.0);
p2.add(v6);
Vektor v7=new Vektor(188.33333333333334,172.0,0.0);
p2.add(v7);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(127,0,0);
Color cb3=new Color(0,255,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v8=new Vektor(13.333333333333334,23.0,0.0);
p3.add(v8);
Vektor v9=new Vektor(179.33333333333334,187.33333333333334,0.0);
p3.add(v9);
Vektor v10=new Vektor(13.33333333333334,187.66666666666666,0.0);
p3.add(v10);
p3.setPaintGroup(pg);
g.add(p3);
Color ca4=new Color(0,127,0);
Color cb4=new Color(0,255,0);
Polygon p4=new Polygon(ca4,cb4);
Vektor v11=new Vektor(41.333333333333336,65.33333333333333,0.0);
p4.add(v11);
Vektor v12=new Vektor(156.0,65.66666666666666,0.0);
p4.add(v12);
Vektor v13=new Vektor(156.0,128.0,0.0);
p4.add(v13);
Vektor v14=new Vektor(41.666666666666664,128.0,0.0);
p4.add(v14);
p4.setPaintGroup(pg);
g.add(p4);
return g;
    }
    public static Group getTreasure1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(60,60,60);
Color cb1=new Color(0,0,80);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.0,0.6666666666666666,0.6);
p1.add(v1);
Vektor v2=new Vektor(0.0,199.66666666666666,0.6666666666666665);
p1.add(v2);
Vektor v3=new Vektor(0.0,199.33333333333334,199.66666666666666);
p1.add(v3);
Vektor v4=new Vektor(0.0,0.6666666666666666,199.66666666666666);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(200,200,0);
Color cb2=new Color(200,0,200);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(0.0,15.0,90.0);
p2.add(v5);
Vektor v6=new Vektor(0.0,185.0,90.0);
p2.add(v6);
Vektor v7=new Vektor(0.0,185.0,175.0);
p2.add(v7);
Vektor v8=new Vektor(0.0,15.0,175.0);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(255,0,255);
Color cb3=new Color(255,0,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(0.0,43.333333333333336,90.66666666666667);
p3.add(v9);
Vektor v10=new Vektor(0.0,40.666666666666664,66.66666666666667);
p3.add(v10);
Vektor v11=new Vektor(0.0,56.666666666666664,40.666666666666664);
p3.add(v11);
Vektor v12=new Vektor(0.0,105.33333333333333,43.333333333333336);
p3.add(v12);
Vektor v13=new Vektor(0.0,123.33333333333331,43.333333333333336);
p3.add(v13);
Vektor v14=new Vektor(0.0,157.33333333333334,55.99999999999999);
p3.add(v14);
Vektor v15=new Vektor(0.0,136.66666666666666,90.0);
p3.add(v15);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getTreasure2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(60,60,60);
Color cb1=new Color(0,0,80);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.6666666666666666,0.0,0.6);
p1.add(v1);
Vektor v2=new Vektor(199.66666666666666,0.0,0.6666666666666665);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,0.0,199.66666666666666);
p1.add(v3);
Vektor v4=new Vektor(0.6666666666666666,0.0,199.66666666666666);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(200,200,0);
Color cb2=new Color(200,0,200);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(15.0,0.0,90.0);
p2.add(v5);
Vektor v6=new Vektor(185.0,0.0,90.0);
p2.add(v6);
Vektor v7=new Vektor(185.0,0.0,175.0);
p2.add(v7);
Vektor v8=new Vektor(15.0,0.0,175.0);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(255,0,255);
Color cb3=new Color(255,0,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(43.333333333333336,0.0,90.66666666666667);
p3.add(v9);
Vektor v10=new Vektor(40.666666666666664,0.0,66.66666666666667);
p3.add(v10);
Vektor v11=new Vektor(56.666666666666664,0.0,40.666666666666664);
p3.add(v11);
Vektor v12=new Vektor(105.33333333333333,0.0,43.333333333333336);
p3.add(v12);
Vektor v13=new Vektor(123.33333333333331,0.0,43.333333333333336);
p3.add(v13);
Vektor v14=new Vektor(157.33333333333334,0.0,55.99999999999999);
p3.add(v14);
Vektor v15=new Vektor(136.66666666666666,0.0,90.0);
p3.add(v15);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getTreasure3(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(60,60,60);
Color cb1=new Color(0,0,80);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.6666666666666666,0.6,0.0);
p1.add(v1);
Vektor v2=new Vektor(199.66666666666666,0.6666666666666665,0.0);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,199.66666666666666,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.6666666666666666,199.66666666666666,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(200,200,0);
Color cb2=new Color(200,0,200);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(15.0,90.0,0.0);
p2.add(v5);
Vektor v6=new Vektor(185.0,90.0,0.0);
p2.add(v6);
Vektor v7=new Vektor(185.0,175.0,0.0);
p2.add(v7);
Vektor v8=new Vektor(15.0,175.0,0.0);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(255,0,255);
Color cb3=new Color(255,0,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(43.333333333333336,90.66666666666667,0.0);
p3.add(v9);
Vektor v10=new Vektor(40.666666666666664,66.66666666666667,0.0);
p3.add(v10);
Vektor v11=new Vektor(56.666666666666664,40.666666666666664,0.0);
p3.add(v11);
Vektor v12=new Vektor(105.33333333333333,43.333333333333336,0.0);
p3.add(v12);
Vektor v13=new Vektor(123.33333333333331,43.333333333333336,0.0);
p3.add(v13);
Vektor v14=new Vektor(157.33333333333334,55.99999999999999,0.0);
p3.add(v14);
Vektor v15=new Vektor(136.66666666666666,90.0,0.0);
p3.add(v15);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getSauger1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(100,100,0);
Color cb1=new Color(0,0,255);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.0,0.2,0.3333333333333335);
p1.add(v1);
Vektor v2=new Vektor(0.0,199.6,0.3333333333333335);
p1.add(v2);
Vektor v3=new Vektor(0.0,199.33333333333334,199.33333333333334);
p1.add(v3);
Vektor v4=new Vektor(0.0,0.3333333333333333,199.6);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,255,0);
Color cb2=new Color(0,127,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(0.0,180.0,45.333333333333336);
p2.add(v5);
Vektor v6=new Vektor(0.0,180.0,180.66666666666666);
p2.add(v6);
Vektor v7=new Vektor(0.0,20.0,180.66666666666666);
p2.add(v7);
Vektor v8=new Vektor(0.0,20.333333333333332,132.66666666666666);
p2.add(v8);
Vektor v9=new Vektor(0.0,137.33333333333334,132.66666666666666);
p2.add(v9);
Vektor v10=new Vektor(0.0,137.33333333333334,75.33333333333333);
p2.add(v10);
Vektor v11=new Vektor(0.0,105.33333333333333,75.0);
p2.add(v11);
Vektor v12=new Vektor(0.0,76.0,85.66666666666667);
p2.add(v12);
Vektor v13=new Vektor(0.0,55.333333333333336,66.66666666666667);
p2.add(v13);
Vektor v14=new Vektor(0.0,64.00000000000001,34.99999999999999);
p2.add(v14);
Vektor v15=new Vektor(0.0,110.66666666666667,16.666666666666668);
p2.add(v15);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(10,10,0);
Color cb3=new Color(255,255,255);
Polygon p3=new Polygon(ca3,cb3);
Vektor v16=new Vektor(0.0,96.0,62.0);
p3.add(v16);
Vektor v17=new Vektor(0.0,72.0,62.66666666666666);
p3.add(v17);
Vektor v18=new Vektor(0.0,80.0,44.0);
p3.add(v18);
Vektor v19=new Vektor(0.0,102.0,42.666666666666664);
p3.add(v19);
Vektor v20=new Vektor(0.0,102.66666666666666,52.666666666666664);
p3.add(v20);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getSauger2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(100,100,0);
Color cb1=new Color(0,0,255);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.2,0.0,0.3333333333333335);
p1.add(v1);
Vektor v2=new Vektor(199.6,0.0,0.3333333333333335);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,0.0,199.33333333333334);
p1.add(v3);
Vektor v4=new Vektor(0.3333333333333333,0.0,199.6);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,255,0);
Color cb2=new Color(0,127,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(180.0,0.0,45.333333333333336);
p2.add(v5);
Vektor v6=new Vektor(180.0,0.0,180.66666666666666);
p2.add(v6);
Vektor v7=new Vektor(20.0,0.0,180.66666666666666);
p2.add(v7);
Vektor v8=new Vektor(20.333333333333332,0.0,132.66666666666666);
p2.add(v8);
Vektor v9=new Vektor(137.33333333333334,0.0,132.66666666666666);
p2.add(v9);
Vektor v10=new Vektor(137.33333333333334,0.0,75.33333333333333);
p2.add(v10);
Vektor v11=new Vektor(105.33333333333333,0.0,75.0);
p2.add(v11);
Vektor v12=new Vektor(76.0,0.0,85.66666666666667);
p2.add(v12);
Vektor v13=new Vektor(55.333333333333336,0.0,66.66666666666667);
p2.add(v13);
Vektor v14=new Vektor(64.00000000000001,0.0,34.99999999999999);
p2.add(v14);
Vektor v15=new Vektor(110.66666666666667,0.0,16.666666666666668);
p2.add(v15);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(10,10,0);
Color cb3=new Color(255,255,255);
Polygon p3=new Polygon(ca3,cb3);
Vektor v16=new Vektor(96.0,0.0,62.0);
p3.add(v16);
Vektor v17=new Vektor(72.0,0.0,62.66666666666666);
p3.add(v17);
Vektor v18=new Vektor(80.0,0.0,44.0);
p3.add(v18);
Vektor v19=new Vektor(102.0,0.0,42.666666666666664);
p3.add(v19);
Vektor v20=new Vektor(102.66666666666666,0.0,52.666666666666664);
p3.add(v20);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getSauger3(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(100,100,0);
Color cb1=new Color(0,0,255);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.2,0.3333333333333335,0.0);
p1.add(v1);
Vektor v2=new Vektor(199.6,0.3333333333333335,0.0);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,199.33333333333334,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.3333333333333333,199.6,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,255,0);
Color cb2=new Color(0,127,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(180.0,45.333333333333336,0.0);
p2.add(v5);
Vektor v6=new Vektor(180.0,180.66666666666666,0.0);
p2.add(v6);
Vektor v7=new Vektor(20.0,180.66666666666666,0.0);
p2.add(v7);
Vektor v8=new Vektor(20.333333333333332,132.66666666666666,0.0);
p2.add(v8);
Vektor v9=new Vektor(137.33333333333334,132.66666666666666,0.0);
p2.add(v9);
Vektor v10=new Vektor(137.33333333333334,75.33333333333333,0.0);
p2.add(v10);
Vektor v11=new Vektor(105.33333333333333,75.0,0.0);
p2.add(v11);
Vektor v12=new Vektor(76.0,85.66666666666667,0.0);
p2.add(v12);
Vektor v13=new Vektor(55.333333333333336,66.66666666666667,0.0);
p2.add(v13);
Vektor v14=new Vektor(64.00000000000001,34.99999999999999,0.0);
p2.add(v14);
Vektor v15=new Vektor(110.66666666666667,16.666666666666668,0.0);
p2.add(v15);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(10,10,0);
Color cb3=new Color(255,255,255);
Polygon p3=new Polygon(ca3,cb3);
Vektor v16=new Vektor(96.0,62.0,0.0);
p3.add(v16);
Vektor v17=new Vektor(72.0,62.66666666666666,0.0);
p3.add(v17);
Vektor v18=new Vektor(80.0,44.0,0.0);
p3.add(v18);
Vektor v19=new Vektor(102.0,42.666666666666664,0.0);
p3.add(v19);
Vektor v20=new Vektor(102.66666666666666,52.666666666666664,0.0);
p3.add(v20);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getLoch1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(127,0,0);
Color cb1=new Color(0,127,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.0,0.333333333333334,199.0);
p1.add(v1);
Vektor v2=new Vektor(0.0,0.5,0.5);
p1.add(v2);
Vektor v3=new Vektor(0.0,200.33333333333334,0.5);
p1.add(v3);
Vektor v4=new Vektor(0.0,199.33333333333334,199.33333333333334);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,0,0);
Color cb2=new Color(255,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(0.0,97.99999999999999,55.66666666666668);
p2.add(v5);
Vektor v6=new Vektor(0.0,147.33333333333334,51.33333333333333);
p2.add(v6);
Vektor v7=new Vektor(0.0,174.66666666666666,118.0);
p2.add(v7);
Vektor v8=new Vektor(0.0,143.33333333333334,151.33333333333334);
p2.add(v8);
Vektor v9=new Vektor(0.0,50.0,140.0);
p2.add(v9);
Vektor v10=new Vektor(0.0,41.33333333333333,104.66666666666666);
p2.add(v10);
Vektor v11=new Vektor(0.0,34.66666666666667,79.33333333333333);
p2.add(v11);
Vektor v12=new Vektor(0.0,87.33333333333333,45.33333333333333);
p2.add(v12);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(255,0,0);
Color cb3=new Color(0,0,127);
Polygon p3=new Polygon(ca3,cb3);
Vektor v13=new Vektor(0.0,75.33333333333333,90.66666666666667);
p3.add(v13);
Vektor v14=new Vektor(0.0,95.33333333333333,78.66666666666667);
p3.add(v14);
Vektor v15=new Vektor(0.0,150.66666666666666,100.0);
p3.add(v15);
Vektor v16=new Vektor(0.0,140.0,122.0);
p3.add(v16);
Vektor v17=new Vektor(0.0,121.33333333333334,132.66666666666666);
p3.add(v17);
Vektor v18=new Vektor(0.0,86.66666666666667,117.33333333333333);
p3.add(v18);
Vektor v19=new Vektor(0.0,67.33333333333333,108.0);
p3.add(v19);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getLoch2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(127,0,0);
Color cb1=new Color(0,127,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.333333333333334,0.0,199.0);
p1.add(v1);
Vektor v2=new Vektor(0.5,0.0,0.5);
p1.add(v2);
Vektor v3=new Vektor(200.33333333333334,0.0,0.5);
p1.add(v3);
Vektor v4=new Vektor(199.33333333333334,0.0,199.33333333333334);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,0,0);
Color cb2=new Color(255,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(97.99999999999999,0.0,55.66666666666668);
p2.add(v5);
Vektor v6=new Vektor(147.33333333333334,0.0,51.33333333333333);
p2.add(v6);
Vektor v7=new Vektor(174.66666666666666,0.0,118.0);
p2.add(v7);
Vektor v8=new Vektor(143.33333333333334,0.0,151.33333333333334);
p2.add(v8);
Vektor v9=new Vektor(50.0,0.0,140.0);
p2.add(v9);
Vektor v10=new Vektor(41.33333333333333,0.0,104.66666666666666);
p2.add(v10);
Vektor v11=new Vektor(34.66666666666667,0.0,79.33333333333333);
p2.add(v11);
Vektor v12=new Vektor(87.33333333333333,0.0,45.33333333333333);
p2.add(v12);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(255,0,0);
Color cb3=new Color(0,0,127);
Polygon p3=new Polygon(ca3,cb3);
Vektor v13=new Vektor(75.33333333333333,0.0,90.66666666666667);
p3.add(v13);
Vektor v14=new Vektor(95.33333333333333,0.0,78.66666666666667);
p3.add(v14);
Vektor v15=new Vektor(150.66666666666666,0.0,100.0);
p3.add(v15);
Vektor v16=new Vektor(140.0,0.0,122.0);
p3.add(v16);
Vektor v17=new Vektor(121.33333333333334,0.0,132.66666666666666);
p3.add(v17);
Vektor v18=new Vektor(86.66666666666667,0.0,117.33333333333333);
p3.add(v18);
Vektor v19=new Vektor(67.33333333333333,0.0,108.0);
p3.add(v19);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getLoch3(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(127,0,0);
Color cb1=new Color(0,127,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.333333333333334,199.0,0.0);
p1.add(v1);
Vektor v2=new Vektor(0.5,0.5,0.0);
p1.add(v2);
Vektor v3=new Vektor(200.33333333333334,0.5,0.0);
p1.add(v3);
Vektor v4=new Vektor(199.33333333333334,199.33333333333334,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(0,0,0);
Color cb2=new Color(255,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(97.99999999999999,55.66666666666668,0.0);
p2.add(v5);
Vektor v6=new Vektor(147.33333333333334,51.33333333333333,0.0);
p2.add(v6);
Vektor v7=new Vektor(174.66666666666666,118.0,0.0);
p2.add(v7);
Vektor v8=new Vektor(143.33333333333334,151.33333333333334,0.0);
p2.add(v8);
Vektor v9=new Vektor(50.0,140.0,0.0);
p2.add(v9);
Vektor v10=new Vektor(41.33333333333333,104.66666666666666,0.0);
p2.add(v10);
Vektor v11=new Vektor(34.66666666666667,79.33333333333333,0.0);
p2.add(v11);
Vektor v12=new Vektor(87.33333333333333,45.33333333333333,0.0);
p2.add(v12);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(255,0,0);
Color cb3=new Color(0,0,127);
Polygon p3=new Polygon(ca3,cb3);
Vektor v13=new Vektor(75.33333333333333,90.66666666666667,0.0);
p3.add(v13);
Vektor v14=new Vektor(95.33333333333333,78.66666666666667,0.0);
p3.add(v14);
Vektor v15=new Vektor(150.66666666666666,100.0,0.0);
p3.add(v15);
Vektor v16=new Vektor(140.0,122.0,0.0);
p3.add(v16);
Vektor v17=new Vektor(121.33333333333334,132.66666666666666,0.0);
p3.add(v17);
Vektor v18=new Vektor(86.66666666666667,117.33333333333333,0.0);
p3.add(v18);
Vektor v19=new Vektor(67.33333333333333,108.0,0.0);
p3.add(v19);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getKey1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(10,10,10);
Color cb1=new Color(0,255,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.0,0.3333333333333333,0.3666666666666665);
p1.add(v1);
Vektor v2=new Vektor(0.0,199.66666666666666,0.2);
p1.add(v2);
Vektor v3=new Vektor(0.0,199.33333333333334,199.6);
p1.add(v3);
Vektor v4=new Vektor(0.0,0.3,199.63333333333335);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(240,240,240);
Color cb2=new Color(255,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(0.0,19.333333333333332,146.66666666666669);
p2.add(v5);
Vektor v6=new Vektor(0.0,128.66666666666666,48.666666666666664);
p2.add(v6);
Vektor v7=new Vektor(0.0,127.33333333333331,17.333333333333336);
p2.add(v7);
Vektor v8=new Vektor(0.0,177.33333333333334,17.333333333333332);
p2.add(v8);
Vektor v9=new Vektor(0.0,187.33333333333334,60.0);
p2.add(v9);
Vektor v10=new Vektor(0.0,154.66666666666666,67.33333333333333);
p2.add(v10);
Vektor v11=new Vektor(0.0,71.66666666666667,135.66666666666666);
p2.add(v11);
Vektor v12=new Vektor(0.0,87.33333333333333,160.33333333333334);
p2.add(v12);
Vektor v13=new Vektor(0.0,78.33333333333333,166.66666666666666);
p2.add(v13);
Vektor v14=new Vektor(0.0,57.333333333333336,148.00000000000003);
p2.add(v14);
Vektor v15=new Vektor(0.0,50.66666666666666,154.0);
p2.add(v15);
Vektor v16=new Vektor(0.0,70.0,170.0);
p2.add(v16);
Vektor v17=new Vektor(0.0,61.33333333333334,177.0);
p2.add(v17);
Vektor v18=new Vektor(0.0,42.0,162.66666666666666);
p2.add(v18);
Vektor v19=new Vektor(0.0,36.0,166.66666666666666);
p2.add(v19);
Vektor v20=new Vektor(0.0,51.0,180.33333333333334);
p2.add(v20);
Vektor v21=new Vektor(0.0,47.0,182.0);
p2.add(v21);
Vektor v22=new Vektor(0.0,12.666666666666664,155.33333333333334);
p2.add(v22);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(10,10,10);
Color cb3=new Color(255,0,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v23=new Vektor(0.0,144.66666666666666,42.0);
p3.add(v23);
Vektor v24=new Vektor(0.0,144.0,29.333333333333332);
p3.add(v24);
Vektor v25=new Vektor(0.0,169.99999999999997,33.333333333333336);
p3.add(v25);
Vektor v26=new Vektor(0.0,174.66666666666666,50.0);
p3.add(v26);
Vektor v27=new Vektor(0.0,148.66666666666666,49.333333333333336);
p3.add(v27);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getKey2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(10,10,10);
Color cb1=new Color(0,255,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.3333333333333333,0.0,0.3666666666666665);
p1.add(v1);
Vektor v2=new Vektor(199.66666666666666,0.0,0.2);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,0.0,199.6);
p1.add(v3);
Vektor v4=new Vektor(0.3,0.0,199.63333333333335);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(240,240,240);
Color cb2=new Color(255,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(19.333333333333332,0.0,146.66666666666669);
p2.add(v5);
Vektor v6=new Vektor(128.66666666666666,0.0,48.666666666666664);
p2.add(v6);
Vektor v7=new Vektor(127.33333333333331,0.0,17.333333333333336);
p2.add(v7);
Vektor v8=new Vektor(177.33333333333334,0.0,17.333333333333332);
p2.add(v8);
Vektor v9=new Vektor(187.33333333333334,0.0,60.0);
p2.add(v9);
Vektor v10=new Vektor(154.66666666666666,0.0,67.33333333333333);
p2.add(v10);
Vektor v11=new Vektor(71.66666666666667,0.0,135.66666666666666);
p2.add(v11);
Vektor v12=new Vektor(87.33333333333333,0.0,160.33333333333334);
p2.add(v12);
Vektor v13=new Vektor(78.33333333333333,0.0,166.66666666666666);
p2.add(v13);
Vektor v14=new Vektor(57.333333333333336,0.0,148.00000000000003);
p2.add(v14);
Vektor v15=new Vektor(50.66666666666666,0.0,154.0);
p2.add(v15);
Vektor v16=new Vektor(70.0,0.0,170.0);
p2.add(v16);
Vektor v17=new Vektor(61.33333333333334,0.0,177.0);
p2.add(v17);
Vektor v18=new Vektor(42.0,0.0,162.66666666666666);
p2.add(v18);
Vektor v19=new Vektor(36.0,0.0,166.66666666666666);
p2.add(v19);
Vektor v20=new Vektor(51.0,0.0,180.33333333333334);
p2.add(v20);
Vektor v21=new Vektor(47.0,0.0,182.0);
p2.add(v21);
Vektor v22=new Vektor(12.666666666666664,0.0,155.33333333333334);
p2.add(v22);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(10,10,10);
Color cb3=new Color(255,0,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v23=new Vektor(144.66666666666666,0.0,42.0);
p3.add(v23);
Vektor v24=new Vektor(144.0,0.0,29.333333333333332);
p3.add(v24);
Vektor v25=new Vektor(169.99999999999997,0.0,33.333333333333336);
p3.add(v25);
Vektor v26=new Vektor(174.66666666666666,0.0,50.0);
p3.add(v26);
Vektor v27=new Vektor(148.66666666666666,0.0,49.333333333333336);
p3.add(v27);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getKey3(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(10,10,10);
Color cb1=new Color(0,255,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.3333333333333333,0.3666666666666665,0.0);
p1.add(v1);
Vektor v2=new Vektor(199.66666666666666,0.2,0.0);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,199.6,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.3,199.63333333333335,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(240,240,240);
Color cb2=new Color(255,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(19.333333333333332,146.66666666666669,0.0);
p2.add(v5);
Vektor v6=new Vektor(128.66666666666666,48.666666666666664,0.0);
p2.add(v6);
Vektor v7=new Vektor(127.33333333333331,17.333333333333336,0.0);
p2.add(v7);
Vektor v8=new Vektor(177.33333333333334,17.333333333333332,0.0);
p2.add(v8);
Vektor v9=new Vektor(187.33333333333334,60.0,0.0);
p2.add(v9);
Vektor v10=new Vektor(154.66666666666666,67.33333333333333,0.0);
p2.add(v10);
Vektor v11=new Vektor(71.66666666666667,135.66666666666666,0.0);
p2.add(v11);
Vektor v12=new Vektor(87.33333333333333,160.33333333333334,0.0);
p2.add(v12);
Vektor v13=new Vektor(78.33333333333333,166.66666666666666,0.0);
p2.add(v13);
Vektor v14=new Vektor(57.333333333333336,148.00000000000003,0.0);
p2.add(v14);
Vektor v15=new Vektor(50.66666666666666,154.0,0.0);
p2.add(v15);
Vektor v16=new Vektor(70.0,170.0,0.0);
p2.add(v16);
Vektor v17=new Vektor(61.33333333333334,177.0,0.0);
p2.add(v17);
Vektor v18=new Vektor(42.0,162.66666666666666,0.0);
p2.add(v18);
Vektor v19=new Vektor(36.0,166.66666666666666,0.0);
p2.add(v19);
Vektor v20=new Vektor(51.0,180.33333333333334,0.0);
p2.add(v20);
Vektor v21=new Vektor(47.0,182.0,0.0);
p2.add(v21);
Vektor v22=new Vektor(12.666666666666664,155.33333333333334,0.0);
p2.add(v22);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(10,10,10);
Color cb3=new Color(255,0,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v23=new Vektor(144.66666666666666,42.0,0.0);
p3.add(v23);
Vektor v24=new Vektor(144.0,29.333333333333332,0.0);
p3.add(v24);
Vektor v25=new Vektor(169.99999999999997,33.333333333333336,0.0);
p3.add(v25);
Vektor v26=new Vektor(174.66666666666666,50.0,0.0);
p3.add(v26);
Vektor v27=new Vektor(148.66666666666666,49.333333333333336,0.0);
p3.add(v27);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getDoor1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(100,100,200);
Color cb1=new Color(0,0,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.0,0.6666666666666666,200-0.3333333333333333);
p1.add(v1);
Vektor v2=new Vektor(0.0,199.33333333333334,200-0.3);
p1.add(v2);
Vektor v3=new Vektor(0.0,199.33333333333334,200-199.66666666666666);
p1.add(v3);
Vektor v4=new Vektor(0.0,0.3,200-199.6);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(255,128,128);
Color cb2=new Color(0,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(0.0,10.333333333333332,200-10.333333333333334);
p2.add(v5);
Vektor v6=new Vektor(0.0,190.06666666666666,200-10.3);
p2.add(v6);
Vektor v7=new Vektor(0.0,190.00000000000003,200-190.06666666666666);
p2.add(v7);
Vektor v8=new Vektor(0.0,10.66666666666666,200-190.33333333333334);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(0,0,0);
Color cb3=new Color(0,190,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(0.0,27.333333333333332,200-115.33333333333333);
p3.add(v9);
Vektor v10=new Vektor(0.0,27.333333333333332,200-90.0);
p3.add(v10);
Vektor v11=new Vektor(0.0,63.0,200-90.06666666666666);
p3.add(v11);
Vektor v12=new Vektor(0.0,63.0,200-97.33333333333333);
p3.add(v12);
Vektor v13=new Vektor(0.0,35.6,200-97.33333333333333);
p3.add(v13);
Vektor v14=new Vektor(0.0,35.666666666666664,200-115.33333333333333);
p3.add(v14);
p3.setPaintGroup(pg);
g.add(p3);
Color ca4=new Color(0,100,255);
Color cb4=new Color(0,0,0);
Polygon p4=new Polygon(ca4,cb4);
Vektor v15=new Vektor(0.0,25.0,200-25.0);
p4.add(v15);
Vektor v16=new Vektor(0.0,175.0,200-25.0);
p4.add(v16);
Vektor v17=new Vektor(0.0,175.0,200-75.0);
p4.add(v17);
Vektor v18=new Vektor(0.0,25.0,200-75.0);
p4.add(v18);
p4.setPaintGroup(pg);
g.add(p4);
return g;
    }
    public static Group getDoor2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(100,100,200);
Color cb1=new Color(0,0,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.6666666666666666,0.0,200-0.3333333333333333);
p1.add(v1);
Vektor v2=new Vektor(199.33333333333334,0.0,200-0.3);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,0.0,200-199.66666666666666);
p1.add(v3);
Vektor v4=new Vektor(0.3,0.0,200-199.6);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(255,128,128);
Color cb2=new Color(0,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(10.333333333333332,0.0,200-10.333333333333334);
p2.add(v5);
Vektor v6=new Vektor(190.06666666666666,0.0,200-10.3);
p2.add(v6);
Vektor v7=new Vektor(190.00000000000003,0.0,200-190.06666666666666);
p2.add(v7);
Vektor v8=new Vektor(10.66666666666666,0.0,200-190.33333333333334);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(0,0,0);
Color cb3=new Color(0,190,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(27.333333333333332,0.0,200-115.33333333333333);
p3.add(v9);
Vektor v10=new Vektor(27.333333333333332,0.0,200-90.0);
p3.add(v10);
Vektor v11=new Vektor(63.0,0.0,200-90.06666666666666);
p3.add(v11);
Vektor v12=new Vektor(63.0,0.0,200-97.33333333333333);
p3.add(v12);
Vektor v13=new Vektor(35.6,0.0,200-97.33333333333333);
p3.add(v13);
Vektor v14=new Vektor(35.666666666666664,0.0,200-115.33333333333333);
p3.add(v14);
p3.setPaintGroup(pg);
g.add(p3);
Color ca4=new Color(0,100,255);
Color cb4=new Color(0,0,0);
Polygon p4=new Polygon(ca4,cb4);
Vektor v15=new Vektor(25.0,0.0,200-25.0);
p4.add(v15);
Vektor v16=new Vektor(175.0,0.0,200-25.0);
p4.add(v16);
Vektor v17=new Vektor(175.0,0.0,200-75.0);
p4.add(v17);
Vektor v18=new Vektor(25.0,0.0,200-75.0);
p4.add(v18);
p4.setPaintGroup(pg);
g.add(p4);
return g;
    }
    public static Group getDoor3(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(100,100,200);
Color cb1=new Color(0,0,0);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.6666666666666666,0.3333333333333333,0.0);
p1.add(v1);
Vektor v2=new Vektor(199.33333333333334,0.3,0.0);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,199.66666666666666,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.3,199.6,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(255,128,128);
Color cb2=new Color(0,0,0);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(10.333333333333332,10.333333333333334,0.0);
p2.add(v5);
Vektor v6=new Vektor(190.06666666666666,10.3,0.0);
p2.add(v6);
Vektor v7=new Vektor(190.00000000000003,190.06666666666666,0.0);
p2.add(v7);
Vektor v8=new Vektor(10.66666666666666,190.33333333333334,0.0);
p2.add(v8);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(0,0,0);
Color cb3=new Color(0,190,0);
Polygon p3=new Polygon(ca3,cb3);
Vektor v9=new Vektor(27.333333333333332,115.33333333333333,0.0);
p3.add(v9);
Vektor v10=new Vektor(27.333333333333332,90.0,0.0);
p3.add(v10);
Vektor v11=new Vektor(63.0,90.06666666666666,0.0);
p3.add(v11);
Vektor v12=new Vektor(63.0,97.33333333333333,0.0);
p3.add(v12);
Vektor v13=new Vektor(35.6,97.33333333333333,0.0);
p3.add(v13);
Vektor v14=new Vektor(35.666666666666664,115.33333333333333,0.0);
p3.add(v14);
p3.setPaintGroup(pg);
g.add(p3);
Color ca4=new Color(0,100,255);
Color cb4=new Color(0,0,0);
Polygon p4=new Polygon(ca4,cb4);
Vektor v15=new Vektor(25.0,25.0,0.0);
p4.add(v15);
Vektor v16=new Vektor(175.0,25.0,0.0);
p4.add(v16);
Vektor v17=new Vektor(175.0,75.0,0.0);
p4.add(v17);
Vektor v18=new Vektor(25.0,75.0,0.0);
p4.add(v18);
p4.setPaintGroup(pg);
g.add(p4);
return g;
    }
    public static Group getDetek1(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(20,30,40);
Color cb1=new Color(90,80,70);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.0,0.6666666666666666,0.3333333333333333);
p1.add(v1);
Vektor v2=new Vektor(0.0,199.33333333333334,0.4);
p1.add(v2);
Vektor v3=new Vektor(0.0,199.33333333333334,199.6);
p1.add(v3);
Vektor v4=new Vektor(0.0,0.6666666666666666,199.5);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(200,200,20);
Color cb2=new Color(10,10,10);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(0.0,25.0,160.06666666666666);
p2.add(v5);
Vektor v6=new Vektor(0.0,25.066666666666666,90.0);
p2.add(v6);
Vektor v7=new Vektor(0.0,100.03333333333333,45.06666666666666);
p2.add(v7);
Vektor v8=new Vektor(0.0,175.03333333333333,90.0333333333334);
p2.add(v8);
Vektor v9=new Vektor(0.0,175.03333333333333,160.63333333333335);
p2.add(v9);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(0,0,200);
Color cb3=new Color(0,220,250);
Polygon p3=new Polygon(ca3,cb3);
Vektor v10=new Vektor(0.0,50.03333333333336,145.0);
p3.add(v10);
Vektor v11=new Vektor(0.0,50.0,100.0);
p3.add(v11);
Vektor v12=new Vektor(0.0,150.0333333333334,100.0);
p3.add(v12);
Vektor v13=new Vektor(0.0,150.33333333333334,145.0666666666666);
p3.add(v13);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getDetek2(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(20,30,40);
Color cb1=new Color(90,80,70);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.6666666666666666,0.0,0.3333333333333333);
p1.add(v1);
Vektor v2=new Vektor(199.33333333333334,0.0,0.4);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,0.0,199.6);
p1.add(v3);
Vektor v4=new Vektor(0.6666666666666666,0.0,199.5);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(200,200,20);
Color cb2=new Color(10,10,10);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(25.0,0.0,160.06666666666666);
p2.add(v5);
Vektor v6=new Vektor(25.066666666666666,0.0,90.0);
p2.add(v6);
Vektor v7=new Vektor(100.03333333333333,0.0,45.06666666666666);
p2.add(v7);
Vektor v8=new Vektor(175.03333333333333,0.0,90.0333333333334);
p2.add(v8);
Vektor v9=new Vektor(175.03333333333333,0.0,160.63333333333335);
p2.add(v9);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(0,0,200);
Color cb3=new Color(0,220,250);
Polygon p3=new Polygon(ca3,cb3);
Vektor v10=new Vektor(50.03333333333336,0.0,145.0);
p3.add(v10);
Vektor v11=new Vektor(50.0,0.0,100.0);
p3.add(v11);
Vektor v12=new Vektor(150.0333333333334,0.0,100.0);
p3.add(v12);
Vektor v13=new Vektor(150.33333333333334,0.0,145.0666666666666);
p3.add(v13);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
    public static Group getDetek3(){
Group g=new Group();
PaintGroup pg=new PaintGroup();
Color ca1=new Color(20,30,40);
Color cb1=new Color(90,80,70);
Polygon p1=new Polygon(ca1,cb1);
Vektor v1=new Vektor(0.6666666666666666,0.3333333333333333,0.0);
p1.add(v1);
Vektor v2=new Vektor(199.33333333333334,0.4,0.0);
p1.add(v2);
Vektor v3=new Vektor(199.33333333333334,199.6,0.0);
p1.add(v3);
Vektor v4=new Vektor(0.6666666666666666,199.5,0.0);
p1.add(v4);
p1.setPaintGroup(pg);
g.add(p1);
Color ca2=new Color(200,200,20);
Color cb2=new Color(10,10,10);
Polygon p2=new Polygon(ca2,cb2);
Vektor v5=new Vektor(25.0,160.06666666666666,0.0);
p2.add(v5);
Vektor v6=new Vektor(25.066666666666666,90.0,0.0);
p2.add(v6);
Vektor v7=new Vektor(100.03333333333333,45.06666666666666,0.0);
p2.add(v7);
Vektor v8=new Vektor(175.03333333333333,90.0333333333334,0.0);
p2.add(v8);
Vektor v9=new Vektor(175.03333333333333,160.63333333333335,0.0);
p2.add(v9);
p2.setPaintGroup(pg);
g.add(p2);
Color ca3=new Color(0,0,200);
Color cb3=new Color(0,220,250);
Polygon p3=new Polygon(ca3,cb3);
Vektor v10=new Vektor(50.03333333333336,145.0,0.0);
p3.add(v10);
Vektor v11=new Vektor(50.0,100.0,0.0);
p3.add(v11);
Vektor v12=new Vektor(150.0333333333334,100.0,0.0);
p3.add(v12);
Vektor v13=new Vektor(150.33333333333334,145.0666666666666,0.0);
p3.add(v13);
p3.setPaintGroup(pg);
g.add(p3);
return g;
    }
}
class EngineStrangeWorld extends JPanel{
    Thread t;
    ImageFrameStrangeWorld imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineStrangeWorld(){
        imf=new ImageFrameStrangeWorld();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
//    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
//    }
    public synchronized void paint(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
//        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameStrangeWorld extends JFrame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameStrangeWorld(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
