import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
public class OpenLevelXrace3D extends JApplet implements Runnable,ActionListener,KeyListener{
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    Thread t;
    JButton b;
    boolean startb=false;
    static JApplet app;
    static OpenLevelXrace3D app2;
    JPanel p1;
    XRace3D xr;
    JLabel la;
    KeyboardMapperAppletSwing km=null;
    private static final long serialVersionUID = 2523085370124840871L;
    public void init(){
        app=this;
        app2=this;
        setSize(800,480);
        setLayout(null);
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        b=new JButton("open");
        p1=new JPanel();
        p1.setLayout(null);
        add(p1);
        p1.setBounds(0,40,400,400);
        p1.add(spl);
        p1.add(b);
        la=new JLabel("XRace3D untextured");
        p1.add(la);
        la.setBounds(10,10,300,27);
        spl.setBounds(10,40,380,300);
        b.setBounds(10,350,380,27);
        setVisible(true);
        readLevelList();
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        b.addActionListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        p1.setVisible(false);
        km=new KeyboardMapperAppletSwing(this);
        add(km);
        km.setBounds(0,40,400,400);
        km.setVisible(true);
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        p1.setVisible(true);
        while(true){
            try{
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                        String levstring=lcontent.elementAt(ind);
                        la.setText("Xrace3D: "+levstring);
                        xr=new XRace3D(this,levstring);
                        p1.setVisible(false);
                        add(xr);
                        xr.setBounds(0,40,800,440);
                    }
                }
            }
            catch(Exception e){
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
            if(evt.getSource()==b){
                startb=true;
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(xr!=null){
            xr.process(e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void readLevelList(){
        try{
            InputStream is=OpenLevelXrace3D.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String news="";
            while((news=dis.readLine())!=null){
                lcontent.addElement(news);
            }
            l.setListData(lcontent);
            is.close();
        }
        catch(Exception e){};
    }
}
class XRace3D extends JPanel implements Runnable{
    Thread t;
    double xpos=0;
    double ypos=0;
    int xdrift=0;
    int ydrift=0;
    double xpos2=0;
    double ypos2=0;
    int xdrift2=0;
    int ydrift2=0;
    String name;
    int[][]screen;
    Group[][]groupscreen;
    Group[][]groupscreen2;
    Group player;
    Group player2;
    Group playerb;
    Group player2b;
    int width=0;
    int height=0;
    int width2=0;
    int height2=0;
    int lifes=3;
    int lifes2=3;
    int points=0;
    int treasures=0;
    int points2=0;
    int treasures2=0;
    double xstart=0;
    double ystart=0;
    double xstart2=0;
    double ystart2=0;
    boolean wall=true;
    boolean inverse=false;
    boolean moveplayer=true;
    boolean wall2=true;
    boolean inverse2=false;
    boolean moveplayer2=true;
    double alpha=0;
    double alpha2=0;
    double beta=Math.PI/4;
    double beta2=Math.PI/4;
    Vektor camerapos;
    Vektor camerapos2;
    Vektor cameraposplus;
    Vektor cameraposplus2;
    EngineXrace3D eng;
    EngineXrace3D eng2;
    OpenLevelXrace3D ol;
    boolean endfirst=true;
    boolean endfirst2=true;
    boolean running=true;
    boolean running2=true;
    boolean half=false;
    boolean half2=false;
    double flyalpha=Math.PI/2;
    double flyalpha2=Math.PI/2;
    int speed=0;
    int speed2=0;
    double xplus=0;
    double yplus=0;
    double xplus2=0;
    double yplus2=0;
    int keycodes1=0;
    int keycodes2=0;
    private static final long serialVersionUID = -5072687864914205852L;
    public XRace3D(OpenLevelXrace3D ol,String name){
//        super("Astro Solutions XRace3D");
//        resize(800,440);
        setLayout(null);
        this.ol=ol;
        eng=new EngineXrace3D();
        eng2=new EngineXrace3D();
        eng.setStatus("");
        eng2.setStatus("");
        add(eng);
        add(eng2);
        eng.setBounds(0,40,400,400);
        eng2.setBounds(400,40,400,400);
        setVisible(true);
        this.name=name;
        screen=new int[30][18];
        groupscreen=new Group[30][18];
        groupscreen2=new Group[30][18];
        player=ObjectGenerator.getPlayer(Color.red);
        player2=ObjectGenerator.getPlayer(Color.yellow);
        playerb=ObjectGenerator.getPlayer(Color.red);
        player2b=ObjectGenerator.getPlayer(Color.yellow);
        loadScreen();
        build();
        t=new Thread(this);
        t.start();
    }
    public void setWallOn(){
        wall=true;
    }
    public void setWallOff(){
        wall=false;
    }
    public void loadScreen(){
        try{
            InputStream is=OpenLevelXrace3D.getInputStream(name);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=is.read();
//System.out.println("i: "+i+" j: "+j+" screen: "+screen[i][j]);
                    if(screen[i][j]==3){
                        xpos=i*50;
                        ypos=j*50;
                        xstart=xpos;
                        ystart=ypos;
                        camerapos=new Vektor(xpos+25,ypos+25,100);
                        cameraposplus=new Vektor(-Math.cos(alpha)*100,-Math.sin(alpha)*100,0);
                        player.transform(xpos,ypos,0);
                        eng.add(player);
                        playerb.transform(xpos,ypos,0);
                        eng2.add(playerb);
                    }
                    if(screen[i][j]==4){
                        xpos2=i*50;
                        ypos2=j*50;
                        xstart2=xpos2;
                        ystart2=ypos2;
                        camerapos2=new Vektor(xpos2+25,ypos2+25,100);
                        cameraposplus2=new Vektor(-Math.cos(alpha2)*100,-Math.sin(alpha2)*100,0);
                        player2.transform(xpos2,ypos2,0);
                        eng2.add(player2);
                        player2b.transform(xpos2,ypos2,0);
                        eng.add(player2b);
                    }
                }
            }
        }
        catch(Exception e){
        }
    }
    public void run(){
        int gc=0;
        while(running){
//            try{
//System.out.println("xxx"+Runtime.getRuntime().freeMemory());
                step();
                step2();
                eng.setStatus("Lap: "+treasures);
                eng2.setStatus("Lap: "+treasures2);
                camerapos.transform(xplus,yplus,0);
                camerapos2.transform(xplus2,yplus2,0);
//System.out.println("yyy");
                if(gc>=100){
                    gc=0;
                    System.gc();
                }
                gc=gc+1;
//System.out.println("yyy");
                cameraposplus.x=Math.cos(alpha)*100;
                cameraposplus2.x=Math.cos(alpha2)*100;
                cameraposplus.y=Math.sin(alpha)*100;
                cameraposplus2.y=Math.sin(alpha2)*100;
                double xtrans=camerapos.x+cameraposplus.x;
                double xtrans2=camerapos2.x+cameraposplus2.x;
                double ytrans=camerapos.y+cameraposplus.y;
                double ytrans2=camerapos2.y+cameraposplus2.y;
                double ztrans=camerapos.z+cameraposplus.z;
                double ztrans2=camerapos2.z+cameraposplus2.z;
                double alphab=alpha;
                double alphab2=alpha2;
                double betab=beta;
                double betab2=beta2;
                setWallOn();
//System.out.println("transform");
                eng.transform(-xtrans,-ytrans,-ztrans);
                eng2.transform(-xtrans2,-ytrans2,-ztrans2);
//System.out.println("xtrans: "+xtrans);
//System.out.println("ytrans: "+ytrans);
//System.out.println("ztrans: "+ztrans);
//System.out.println("alphab: "+alphab);
//System.out.println("betab: "+betab);
                alphab=alphab+Math.PI;
                alphab2=alphab2+Math.PI;
                if(alphab>2*Math.PI){
                    alphab=alphab-2*Math.PI;
                }
                if(alphab2>2*Math.PI){
                    alphab2=alphab2-2*Math.PI;
                }
                eng.rotLeft(-alphab);
                eng2.rotLeft(-alphab2);
                eng.rotUp(betab);
                eng2.rotUp(betab2);
//System.out.println("gs: "+groupscreen[0][0].start.start.x);
                eng.setOn();
                eng2.setOn();
                eng.move();
                eng2.move();
                eng.repaint();
                eng2.repaint();
try{
                Thread.sleep(80);
}
catch(Exception e){
}
                eng.setOff();
                eng2.setOff();
                eng.rotUp(-betab);
                eng2.rotUp(-betab2);
                eng.rotLeft(alphab);
                eng2.rotLeft(alphab2);
                eng.transform(xtrans,ytrans,ztrans);
                eng2.transform(xtrans2,ytrans2,ztrans2);
                setWallOff();
                keyPressed(-100);
                keyPressed2(-100);
//            }
//            catch(Exception e){
//                System.out.println("e: "+e);
//                try{
//                    Thread.sleep(10000);
//                }
//                catch(Exception eb){
//                };
//            }
        }
    }
    public static void main(String[]args){
//        new Dynamite3D("TEST.LEV");
        new OpenLevelXrace3D();
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
        if(OpenLevelXrace3D.app2.km!=null&&OpenLevelXrace3D.app2.km.applyb){
            key=OpenLevelXrace3D.app2.km.getKeyCode(key);
        }
//System.out.println("key: "+key);
            if(key==27||key==KeyEvent.VK_ESCAPE){
                setVisible(false);
                running=false;
                OpenLevelXrace3D.app2.p1.setVisible(true);
                OpenLevelXrace3D.app2.la.setText("You used ESC to quit level. ");
            }
            if(key==KeyEvent.VK_DOWN){
                if(moveplayer){
//System.out.println("a");
                    keyPressed(-4);
                }
                else{
//System.out.println("b");
                    if(!inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_UP){
                if(moveplayer){
                    keyPressed(-3);
                }
                else{
                    if(inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_RIGHT){
                if(moveplayer){
                    keyPressed(-1);
                }
                else{
                    alpha=alpha-Math.PI/90;
                    if(alpha<0){
                        alpha=alpha+2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_LEFT){
                if(moveplayer){
                    keyPressed(-2);
                }
                else{
                    alpha=alpha+Math.PI/90;
                    if(alpha>2*Math.PI){
                        alpha=alpha-2*Math.PI;
                    }
                }
            }
            if(key==88){
                if(moveplayer2){
//System.out.println("a");
                    keyPressed2(-4);
                }
                else{
//System.out.println("b");
                    if(!inverse2){
                        beta2=beta2+Math.PI/90;
                        if(beta2>Math.PI/2){
                            beta2=Math.PI/2-Math.PI/90;
                            alpha2=alpha2+Math.PI;
                            if(alpha2>2*Math.PI){
                                alpha2=alpha2-2*Math.PI;
                            }
                            inverse2=true;
                            eng2.setInverseOn();
                        }
                    }
                    else{
                        beta2=beta2-Math.PI/90;
                        if(beta2<-Math.PI/2){
                            beta2=-Math.PI/2+Math.PI/90;
                            alpha2=alpha2+Math.PI;
                            if(alpha2>2*Math.PI){
                                alpha2=alpha2-2*Math.PI;
                            }
                            inverse2=false;
                            eng2.setInverseOff();
                        }
                    }
                }
            }
            if(key==83){
                if(moveplayer2){
                    keyPressed2(-3);
                }
                else{
                    if(inverse2){
                        beta2=beta2+Math.PI/90;
                        if(beta2>Math.PI/2){
                            beta2=Math.PI/2-Math.PI/90;
                            alpha2=alpha2+Math.PI;
                            if(alpha2>2*Math.PI){
                                alpha2=alpha2-2*Math.PI;
                            }
                            inverse2=true;
                            eng2.setInverseOn();
                        }
                    }
                    else{
                        beta2=beta2-Math.PI/90;
                        if(beta2<-Math.PI/2){
                            beta2=-Math.PI/2+Math.PI/90;
                            alpha2=alpha2+Math.PI;
                            if(alpha2>2*Math.PI){
                                alpha2=alpha2-2*Math.PI;
                            }
                            inverse2=false;
                            eng2.setInverseOff();
                        }
                    }
                }
            }
            if(key==67){
                if(moveplayer2){
                    keyPressed2(-1);
                }
                else{
                    alpha2=alpha2-Math.PI/90;
                    if(alpha2<0){
                        alpha2=alpha2+2*Math.PI;
                    }
                }
            }
            if(key==89){
                if(moveplayer2){
                    keyPressed2(-2);
                }
                else{
                    alpha2=alpha2+Math.PI/90;
                    if(alpha2>2*Math.PI){
                        alpha2=alpha2-2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_DELETE){
                if(moveplayer){
                    moveplayer=false;
                }
                else{
                    moveplayer=true;
                }
            }
            if(key==32){
                if(moveplayer2){
                    moveplayer2=false;
                }
                else{
                    moveplayer2=true;
                }
            }
    }
    public void keyPressed(int keycode){
        if(keycode==-100){
            keycode=keycodes1;
            keycodes1=0;
        }
        else{
            keycodes1=keycode;
            return;
        }
        if(keycode==-1){
            flyalpha=flyalpha+Math.PI/90;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(-xpos-25,-ypos-25,25);
            player.rotLeft(Math.PI/90);
            player.transform(xpos+25,ypos+25,-25);
            playerb.transform(-xpos-25,-ypos-25,25);
            playerb.rotLeft(Math.PI/90);
            playerb.transform(xpos+25,ypos+25,-25);
        }
        if(keycode==-2){
            flyalpha=flyalpha-Math.PI/90;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(-xpos-25,-ypos-25,25);
            player.rotLeft(-Math.PI/90);
            player.transform(xpos+25,ypos+25,-25);
            playerb.transform(-xpos-25,-ypos-25,25);
            playerb.rotLeft(-Math.PI/90);
            playerb.transform(xpos+25,ypos+25,-25);
        }
        if(keycode==-3){
            if(speed<=14){
                while(wall){
                    try{
                        Thread.yield();
                    }
                    catch(Exception e){
                    }
                }
                speed=speed+1;
            }
        }
        if(keycode==-4){
            if(speed>=-4){
                while(wall){
                    try{
                        Thread.yield();
                    }
                    catch(Exception e){
                    }
                }
                speed=speed-1;
            }
        }
    }
    public void keyPressed2(int keycode){
        if(keycode==-100){
            keycode=keycodes2;
            keycodes2=0;
        }
        else{
            keycodes2=keycode;
            return;
        }
        if(keycode==-1){
            flyalpha2=flyalpha2+Math.PI/90;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player2.transform(-xpos2-25,-ypos2-25,25);
            player2.rotLeft(Math.PI/90);
            player2.transform(xpos2+25,ypos2+25,-25);
            player2b.transform(-xpos2-25,-ypos2-25,25);
            player2b.rotLeft(Math.PI/90);
            player2b.transform(xpos2+25,ypos2+25,-25);
        }
        if(keycode==-2){
            flyalpha2=flyalpha2-Math.PI/90;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player2.transform(-xpos2-25,-ypos2-25,25);
            player2.rotLeft(-Math.PI/90);
            player2.transform(xpos2+25,ypos2+25,-25);
            player2b.transform(-xpos2-25,-ypos2-25,25);
            player2b.rotLeft(-Math.PI/90);
            player2b.transform(xpos2+25,ypos2+25,-25);
        }
        if(keycode==-3){
            if(speed2<=14){
                while(wall){
                    try{
                        Thread.yield();
                    }
                    catch(Exception e){
                    }
                }
                speed2=speed2+1;
            }
        }
        if(keycode==-4){
            if(speed2>=-4){
                while(wall){
                    try{
                        Thread.yield();
                    }
                    catch(Exception e){
                    }
                }
                speed2=speed2-1;
            }
        }
    }
    public void build(){
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                int x=i;
                int y=j;
                if(x>=0&&y>=0&&x<30&&y<18){
//System.out.println("xp:"+xp+"i:"+i);
                    if(screen[x][y]==1||screen[x][y]==3||screen[x][y]==4||screen[x][y]==5){
                        groupscreen[x][y]=ObjectGenerator.getStreet();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        groupscreen2[x][y]=ObjectGenerator.getStreet();
                        groupscreen2[x][y].transform(i*50,j*50,0);
                        eng2.add(groupscreen2[x][y]);
                    }
                    if(screen[x][y]==2){
                        groupscreen[x][y]=ObjectGenerator.getCube();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        groupscreen2[x][y]=ObjectGenerator.getCube();
                        groupscreen2[x][y].transform(i*50,j*50,0);
                        eng2.add(groupscreen2[x][y]);
                    }
                }
            }
        }
    }
    public void step(){
//System.out.println("hallo2");
        xplus=(Math.cos(flyalpha)*speed*2);
        yplus=(Math.sin(flyalpha)*speed*2);
        player.transform(xplus,yplus,0);
        playerb.transform(xplus,yplus,0);
//        eng.transform(-xplus,-yplus,0);
        xpos=xpos+xplus;
        ypos=ypos+yplus;
        boolean loso=false;
        int xposb=(int)((xpos+25)/50);
        int yposb=(int)((ypos+25)/50);
//System.out.println("a");

//System.out.println("hallo4");
        if(xpos<0||xpos>=1500){
            loso=true;
        }
        else if(ypos<0||ypos>=900){
            loso=true;
        }
        else{
            if(screen[xposb][yposb]==0){
                loso=true;
            }
            if(screen[xposb][yposb]==5){
                half=true;
            }
            if(screen[xposb][yposb]==3||screen[xposb][yposb]==4){
                if(half){
                    half=false;
                    treasures++;
                }
            }
        }
        int xposb2=(int)((xpos+10)/50);
        int yposb2=(int)((ypos+10)/50);
        int xposb3=(int)((xpos+40)/50);
        int yposb3=(int)((ypos+40)/50);
        if(xposb2>=0&&xposb2<30&&yposb2>=0&&yposb2<18){
            if(screen[xposb2][yposb2]==2){
                loso=true;
            }
        }
        if(xposb2>=0&&xposb2<30&&yposb3>=0&&yposb3<18){
            if(screen[xposb2][yposb3]==2){
                loso=true;
            }
        }
        if(xposb3>=0&&xposb3<30&&yposb2>=0&&yposb2<18){
            if(screen[xposb3][yposb2]==2){
                loso=true;
            }
        }
        if(xposb3>=0&&xposb3<30&&yposb3>=0&&yposb3<18){
            if(screen[xposb3][yposb3]==2){
                loso=true;
            }
        }
        if(treasures==3){
            OpenLevelXrace3D.app2.la.setText("Player 1 won!");
            if(endfirst){
                endfirst=false;
                setVisible(false);
                ol.p1.setVisible(true);
                running=false;
            }
        }
        if(loso){
            lifes--;
            if(lifes<=0){
                OpenLevelXrace3D.app2.la.setText("Player 1 lost!");
                if(endfirst){
                    endfirst=false;
                    setVisible(false);
                    ol.p1.setVisible(true);
                    running=false;
                }
            }
            else{
                player.transform(xstart-xpos,ystart-ypos,0);
                playerb.transform(xstart-xpos,ystart-ypos,0);
                xpos=xstart;
                ypos=ystart;
                camerapos=new Vektor(xpos+25,ypos+25,100);
                xdrift=0;
                ydrift=0;
            }
        }
    }
    public void step2(){
//System.out.println("hallo2");
        xplus2=(Math.cos(flyalpha2)*speed2);
        yplus2=(Math.sin(flyalpha2)*speed2);
        player2.transform(xplus2,yplus2,0);
        player2b.transform(xplus2,yplus2,0);
//        eng2.transform(-xplus2,-yplus2,0);
        xpos2=xpos2+xplus2;
        ypos2=ypos2+yplus2;
        boolean loso2=false;
        int xposb2=(int)((xpos2+25)/50);
        int yposb2=(int)((ypos2+25)/50);
//System.out.println("a");

//System.out.println("hallo4");
        if(xpos2<0||xpos2>=1500){
            loso2=true;
        }
        else if(ypos2<0||ypos2>=900){
            loso2=true;
        }
        else{
            if(screen[xposb2][yposb2]==0){
                loso2=true;
            }
            if(screen[xposb2][yposb2]==5){
                half2=true;
            }
            if(screen[xposb2][yposb2]==3||screen[xposb2][yposb2]==4){
                if(half2){
                    half2=false;
                    treasures2++;
                }
            }
        }
        int xposb2a=(int)((xpos2+10)/50);
        int yposb2a=(int)((ypos2+10)/50);
        int xposb3=(int)((xpos2+40)/50);
        int yposb3=(int)((ypos2+40)/50);
        if(xposb2a>=0&&xposb2a<30&&yposb2a>=0&&yposb2a<18){
            if(screen[xposb2a][yposb2a]==2){
                loso2=true;
            }
        }
        if(xposb2a>=0&&xposb2a<30&&yposb3>=0&&yposb3<18){
            if(screen[xposb2a][yposb3]==2){
                loso2=true;
            }
        }
        if(xposb3>=0&&xposb3<30&&yposb2a>=0&&yposb2a<18){
            if(screen[xposb3][yposb2a]==2){
                loso2=true;
            }
        }
        if(xposb3>=0&&xposb3<30&&yposb3>=0&&yposb3<18){
            if(screen[xposb3][yposb3]==2){
                loso2=true;
            }
        }
        if(treasures2==3){
            OpenLevelXrace3D.app2.la.setText("Player 2 won!");
            if(endfirst2){
                endfirst2=false;
                setVisible(false);
                ol.p1.setVisible(true);
                running=false;
            }
        }
        if(loso2){
            lifes2--;
            if(lifes2<=0){
                OpenLevelXrace3D.app2.la.setText("Player 2 lost!");
                if(endfirst2){
                    endfirst2=false;
                    setVisible(false);
                    ol.p1.setVisible(true);
                    running=false;
                }
            }
            else{
                player2.transform(xstart2-xpos2,ystart2-ypos2,0);
                player2b.transform(xstart2-xpos2,ystart2-ypos2,0);
                xpos2=xstart2;
                ypos2=ystart2;
                camerapos2=new Vektor(xpos2+25,ypos2+25,100);
                xdrift2=0;
                ydrift2=0;
            }
        }
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.darkGray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,0);
        Vektor v6=new Vektor(40,10,0);
        Vektor v7=new Vektor(40,40,0);
        Vektor v8=new Vektor(10,40,0);
        Quad q2=new Quad(Color.gray,Color.gray,v5,v6,v7,v8);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getSoftStone(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.yellow,Color.yellow,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,25);
        Vektor v16=new Vektor(5,5,25);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,25);
        Vektor v20=new Vektor(5,45,25);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,25);
        Vektor v24=new Vektor(45,5,25);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getHardStone(){
        Vektor v1=new Vektor(5,5,40);
        Vektor v2=new Vektor(45,5,40);
        Vektor v3=new Vektor(45,45,40);
        Vektor v4=new Vektor(5,45,40);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,40);
        Vektor v6=new Vektor(40,10,40);
        Vektor v7=new Vektor(40,40,40);
        Vektor v8=new Vektor(10,40,40);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,40);
        Vektor v12=new Vektor(5,5,40);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,40);
        Vektor v16=new Vektor(5,5,40);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,40);
        Vektor v20=new Vektor(5,45,40);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,40);
        Vektor v24=new Vektor(45,5,40);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getPlayer(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.green,Color.green,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.blue,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(10,5,10);
        Vektor v14=new Vektor(40,5,10);
        Vektor v15=new Vektor(40,5,20);
        Vektor v16=new Vektor(10,5,20);
        Quad q4=new Quad(Color.green,Color.green,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,5);
        Vektor v18=new Vektor(5,45,5);
        Vektor v19=new Vektor(5,45,25);
        Vektor v20=new Vektor(5,5,25);
        Quad q5=new Quad(Color.blue,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(5,10,10);
        Vektor v22=new Vektor(5,40,10);
        Vektor v23=new Vektor(5,40,20);
        Vektor v24=new Vektor(5,10,20);
        Quad q6=new Quad(Color.green,Color.green,v21,v22,v23,v24);
        Vektor v25=new Vektor(5,45,5);
        Vektor v26=new Vektor(45,45,5);
        Vektor v27=new Vektor(45,45,25);
        Vektor v28=new Vektor(5,45,25);
        Quad q7=new Quad(Color.blue,Color.black,v25,v26,v27,v28);
        Vektor v29=new Vektor(10,45,10);
        Vektor v30=new Vektor(40,45,10);
        Vektor v31=new Vektor(40,45,20);
        Vektor v32=new Vektor(10,45,20);
        Quad q8=new Quad(Color.green,Color.green,v29,v30,v31,v32);
        Vektor v33=new Vektor(45,5,5);
        Vektor v34=new Vektor(45,45,5);
        Vektor v35=new Vektor(45,45,25);
        Vektor v36=new Vektor(45,5,25);
        Quad q9=new Quad(Color.blue,Color.black,v33,v34,v35,v36);
        Vektor v37=new Vektor(45,10,10);
        Vektor v38=new Vektor(45,40,10);
        Vektor v39=new Vektor(45,40,20);
        Vektor v40=new Vektor(45,10,20);
        Quad q10=new Quad(Color.green,Color.green,v37,v38,v39,v40);
        Vektor v41=new Vektor(25,25,37);
        Kugel kug=new Kugel(Color.red,Color.red,v41,12);
        PaintGroup p1=new PaintGroup();
        q1.setPaintGroup(p1);
        q2.setPaintGroup(p1);
        PaintGroup p2=new PaintGroup();
        q3.setPaintGroup(p2);
        q4.setPaintGroup(p2);
        PaintGroup p3=new PaintGroup();
        q5.setPaintGroup(p3);
        q6.setPaintGroup(p3);
        PaintGroup p4=new PaintGroup();
        q7.setPaintGroup(p4);
        q8.setPaintGroup(p4);
        PaintGroup p5=new PaintGroup();
        q9.setPaintGroup(p5);
        q10.setPaintGroup(p5);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        g.add(q8);
        g.add(q9);
        g.add(q10);
        g.add(kug);
        return g;
    }
    public static Group getGegner(){
        Vektor v1=new Vektor(5,5,5);
        Vektor v2=new Vektor(45,5,5);
        Vektor v3=new Vektor(25,25,25);
        Triangle t1=new Triangle(Color.darkGray,Color.black,v1,v2,v3);
        Vektor v4=new Vektor(5,5,5);
        Vektor v5=new Vektor(5,45,5);
        Vektor v6=new Vektor(25,25,25);
        Triangle t2=new Triangle(Color.darkGray,Color.black,v4,v5,v6);
        Vektor v7=new Vektor(5,45,5);
        Vektor v8=new Vektor(45,45,5);
        Vektor v9=new Vektor(25,25,25);
        Triangle t3=new Triangle(Color.darkGray,Color.black,v7,v8,v9);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,45,5);
        Vektor v12=new Vektor(25,25,25);
        Triangle t4=new Triangle(Color.darkGray,Color.black,v10,v11,v12);
        Vektor v13=new Vektor(25,25,37);
        Kugel kug=new Kugel(Color.lightGray,Color.lightGray,v13,12);
        Group g=new Group();
        g.add(t1);
        g.add(t2);
        g.add(t3);
        g.add(t4);
        g.add(kug);
        return g;
    }
    public static Group getBomb(){
        Vektor v1=new Vektor(25,25,25);
        Kugel kug=new Kugel(Color.black,Color.black,v1,25);
        Group g=new Group();
        g.add(kug);
        return g;
    }
    public static Group getExplosion(){
        Vektor v1=new Vektor(0,0,50);
        Vektor v2=new Vektor(50,0,50);
        Vektor v3=new Vektor(50,50,50);
        Vektor v4=new Vektor(0,50,50);
        Quad q1=new Quad(Color.red,Color.red,v1,v2,v3,v4);
        Vektor v5=new Vektor(0,0,0);
        Vektor v6=new Vektor(50,0,0);
        Vektor v7=new Vektor(50,0,50);
        Vektor v8=new Vektor(0,0,50);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(0,0,0);
        Vektor v10=new Vektor(0,50,0);
        Vektor v11=new Vektor(0,50,50);
        Vektor v12=new Vektor(0,0,50);
        Quad q3=new Quad(Color.red,Color.red,v9,v10,v11,v12);
        Vektor v13=new Vektor(0,50,0);
        Vektor v14=new Vektor(50,50,0);
        Vektor v15=new Vektor(50,50,50);
        Vektor v16=new Vektor(0,50,50);
        Quad q4=new Quad(Color.red,Color.red,v13,v14,v15,v16);
        Vektor v17=new Vektor(50,0,0);
        Vektor v18=new Vektor(50,50,0);
        Vektor v19=new Vektor(50,50,50);
        Vektor v20=new Vektor(50,0,50);
        Quad q5=new Quad(Color.red,Color.red,v17,v18,v19,v20);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        return g;
    }
    public static Group getStreet(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,0);
        Vektor v6=new Vektor(40,10,0);
        Vektor v7=new Vektor(40,40,0);
        Vektor v8=new Vektor(10,40,0);
        Quad q2=new Quad(Color.darkGray,Color.black,v5,v6,v7,v8);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getCube(){
        int green1=(int)(Math.random()*256)*256;
        int green2=(int)(Math.random()*256)*256;
        green1=100*256;
        green2=150*256;
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(new Color(green1),Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,0);
        Vektor v6=new Vektor(40,10,0);
        Vektor v7=new Vektor(40,40,0);
        Vektor v8=new Vektor(10,40,0);
        Quad q2=new Quad(new Color(green2),Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(0,0,50);
        Vektor v10=new Vektor(50,0,50);
        Vektor v11=new Vektor(50,50,50);
        Vektor v12=new Vektor(0,50,50);
        Quad q3=new Quad(new Color(green1),Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(10,10,50);
        Vektor v14=new Vektor(40,10,50);
        Vektor v15=new Vektor(40,40,50);
        Vektor v16=new Vektor(10,40,50);
        Quad q4=new Quad(new Color(green2),Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(0,0,0);
        Vektor v18=new Vektor(50,0,0);
        Vektor v19=new Vektor(50,0,50);
        Vektor v20=new Vektor(0,0,50);
        Quad q5=new Quad(new Color(green1),Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(10,0,10);
        Vektor v22=new Vektor(40,0,10);
        Vektor v23=new Vektor(40,0,40);
        Vektor v24=new Vektor(10,0,40);
        Quad q6=new Quad(new Color(green2),Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(0,50,0);
        Vektor v26=new Vektor(50,50,0);
        Vektor v27=new Vektor(50,50,50);
        Vektor v28=new Vektor(0,50,50);
        Quad q7=new Quad(new Color(green1),Color.black,v25,v26,v27,v28);
        Vektor v29=new Vektor(10,50,10);
        Vektor v30=new Vektor(40,50,10);
        Vektor v31=new Vektor(40,50,40);
        Vektor v32=new Vektor(10,50,40);
        Quad q8=new Quad(new Color(green2),Color.black,v29,v30,v31,v32);
        Vektor v33=new Vektor(0,0,0);
        Vektor v34=new Vektor(0,50,0);
        Vektor v35=new Vektor(0,50,50);
        Vektor v36=new Vektor(0,0,50);
        Quad q9=new Quad(new Color(green1),Color.black,v33,v34,v35,v36);
        Vektor v37=new Vektor(0,10,10);
        Vektor v38=new Vektor(0,40,10);
        Vektor v39=new Vektor(0,40,40);
        Vektor v40=new Vektor(0,10,40);
        Quad q10=new Quad(new Color(green2),Color.black,v37,v38,v39,v40);
        Vektor v41=new Vektor(50,0,0);
        Vektor v42=new Vektor(50,50,0);
        Vektor v43=new Vektor(50,50,50);
        Vektor v44=new Vektor(50,0,50);
        Quad q11=new Quad(new Color(green1),Color.black,v41,v42,v43,v44);
        Vektor v45=new Vektor(50,10,10);
        Vektor v46=new Vektor(50,40,10);
        Vektor v47=new Vektor(50,40,40);
        Vektor v48=new Vektor(50,10,40);
        Quad q12=new Quad(new Color(green2),Color.black,v45,v46,v47,v48);
        PaintGroup pg1=new PaintGroup();
        q1.setPaintGroup(pg1);
        q2.setPaintGroup(pg1);
        PaintGroup pg2=new PaintGroup();
        q3.setPaintGroup(pg2);
        q4.setPaintGroup(pg2);
        PaintGroup pg3=new PaintGroup();
        q5.setPaintGroup(pg3);
        q6.setPaintGroup(pg3);
        PaintGroup pg4=new PaintGroup();
        q7.setPaintGroup(pg4);
        q8.setPaintGroup(pg4);
        PaintGroup pg5=new PaintGroup();
        q9.setPaintGroup(pg5);
        q10.setPaintGroup(pg5);
        PaintGroup pg6=new PaintGroup();
        q11.setPaintGroup(pg6);
        q12.setPaintGroup(pg6);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        g.add(q8);
        g.add(q9);
        g.add(q10);
        g.add(q11);
        g.add(q12);
        return g;
    }
    public static Group getPlayer(Color col){
        Vektor v1=new Vektor(10,10,10);
        Vektor v2=new Vektor(40,10,10);
        Vektor v3=new Vektor(40,40,10);
        Vektor v4=new Vektor(10,40,10);
        Quad q1=new Quad(col,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,10);
        Vektor v6=new Vektor(10,10,20);
        Vektor v7=new Vektor(40,10,20);
        Vektor v8=new Vektor(40,10,10);
        Quad q2=new Quad(col,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(10,10,10);
        Vektor v10=new Vektor(10,40,10);
        Vektor v11=new Vektor(10,40,20);
        Vektor v12=new Vektor(10,10,20);
        Quad q3=new Quad(col,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(10,40,10);
        Vektor v14=new Vektor(10,40,20);
        Vektor v15=new Vektor(40,40,20);
        Vektor v16=new Vektor(40,40,10);
        Quad q4=new Quad(col,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(40,10,10);
        Vektor v18=new Vektor(40,40,10);
        Vektor v19=new Vektor(40,40,20);
        Vektor v20=new Vektor(40,10,20);
        Quad q5=new Quad(col,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(10,10,20);
        Vektor v22=new Vektor(40,10,20);
        Vektor v23=new Vektor(40,40,20);
        Vektor v24=new Vektor(10,40,20);
        Quad q6=new Quad(col,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(15,35,20);
        Vektor v26=new Vektor(15,10,35);
        Vektor v27=new Vektor(15,10,20);
        Triangle t7=new Triangle(Color.green,Color.green,v25,v26,v27);
        Vektor v28=new Vektor(35,35,20);
        Vektor v29=new Vektor(35,10,35);
        Vektor v30=new Vektor(35,10,20);
        Triangle t8=new Triangle(Color.green,Color.green,v28,v29,v30);
        Vektor v31=new Vektor(15,35,20);
        Vektor v32=new Vektor(35,35,20);
        Vektor v33=new Vektor(35,10,35);
        Vektor v34=new Vektor(15,10,35);
        Quad q9=new Quad(Color.green,Color.black,v31,v32,v33,v34);
        Vektor v35=new Vektor(35,10,20);
        Vektor v36=new Vektor(15,10,20);
        Vektor v37=new Vektor(15,10,35);
        Vektor v38=new Vektor(35,10,35);
        Quad q10=new Quad(Color.green,Color.black,v35,v36,v37,v38);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(t7);
        g.add(t8);
        g.add(q9);
        g.add(q10);
        return g;
    }
}
class EngineXrace3D extends JPanel{
    Thread t;
    ImageFrameXrace3D imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineXrace3D(){
        imf=new ImageFrameXrace3D();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
//    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
//    }
    public synchronized void paint(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
//        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameXrace3D extends JFrame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameXrace3D(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
class KeyboardMapperAppletSwing extends JPanel implements ActionListener,KeyListener,MouseListener{
    JLabel info;
    ListBox l;
    JButton remove;
    JButton addspecial;
    JButton apply;
    JButton cancel;
    JButton dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    JApplet applet;
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    private static final long serialVersionUID = 5772434866526097156L;
    public KeyboardMapperAppletSwing(JApplet applet){
        setSize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new JLabel("");
        l=new ListBox();
        remove=new JButton("remove");
        addspecial=new JButton("add special key");
        apply=new JButton("apply");
        cancel=new JButton("cancel");
        dontapply=new JButton("don't apply");
        add(info);
        add(l);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.setBounds(10,10,380,27);
        l.setBounds(10,40,380,170);
        remove.setBounds(10,250,80,27);
        addspecial.setBounds(10,280,380,27);
        apply.setBounds(10,310,80,27);
        cancel.setBounds(210,310,80,27);
        dontapply.setBounds(10,340,160,27);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
        remove.addActionListener(this);
        addspecial.addActionListener(this);
        apply.addActionListener(this);
        cancel.addActionListener(this);
        dontapply.addActionListener(this);
        addKeyListener(this);
        addMouseListener(this);
        info.setOpaque(true);
        info.setBackground(Color.white);
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public synchronized void mousePressed(MouseEvent me) {
        requestFocus();
        l.click(me.getX()-10,me.getY()-40);
        l.repaint();
    }
    public synchronized void mouseReleased(MouseEvent e) {
    }
    public synchronized void mouseExited(MouseEvent e) {
    }
    public synchronized void mouseEntered(MouseEvent e) {
    }
    public synchronized void mouseClicked(MouseEvent e) {
    }
    public int getKeyCode(int a){
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(alias[i]==a){
                return key[i];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.reset();
        int n=key.length;
        for(int i=0;i<n;i++){
            l.addElement("special key "+alias[i]+" alias for "+key[i]);
        }
        l.repaint();
    }
    public void loadfirst(){
        try{
            FileInputStream fis=new FileInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
        }
    }
    public void load(String filename){
        try{
            FileInputStream fis=new FileInputStream(filename);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                kmt.addspecial(inp,inp2);
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            int n=alias.length;
            for(int i=0;i<n;i++){
                l.addElement("special key "+alias[i]+" alias for "+key[i]);
            }
            l.repaint();
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public synchronized void keyPressed(KeyEvent e){
        requestFocus();
        int ekey=e.getKeyCode();
        if(kstatus==1){
            aliasx=ekey;
            kstatus=2;
            info.setText("type key");
        }
        else if(kstatus==2){
            int keyx=ekey;
            kstatus=0;
            info.setText("special key added");
            info.setBackground(Color.white);
            kmt.addspecial(""+aliasx,""+keyx);
            l.addElement("special key "+aliasx+" alias for "+keyx);
            l.repaint();
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==remove){
            int ind=l.getSelectedIndex();
            if(ind!=-1){
                l.removeElementAt(ind);
                kmt.remove(ind);
                l.repaint();
            }
        }
        if(evt.getSource()==addspecial){
            info.setText("type alias");
            kstatus=1;
            info.setBackground(Color.yellow);
            requestFocus();
        }
        if(evt.getSource()==apply){
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            applyb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==cancel){
            restorekmt();
            cancelb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==dontapply){
            applyb=false;
            info.setText("KeyboardMapper isn't applied");
        }
    }
}
class KeyMapperTable{
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new int[0];
        key=new int[0];
        special=new boolean[0];
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        int[]aliasb=new int[n+1];
        int[]keyb=new int[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        try{
            aliasb[n]=new Integer(a).intValue();
            keyb[n]=new Integer(b).intValue();
        }
        catch(Exception exc){
        }
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            int[]aliasb=new int[n-1];
            int[]keyb=new int[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
class ListBox extends JPanel{
    String[]thestrings=new String[0];
    GetImgKeyboardMapper gikm;
    Image img;
    int uppest=0;
    int n=0;
    int ind=-1;
    private static final long serialVersionUID = -457533304480165971L;
    public ListBox(){
        setLayout(null);
        gikm=new GetImgKeyboardMapper();
        img=gikm.img;
        repaint();
    }
    public synchronized void reset(){
        thestrings=new String[0];
        n=0;
        uppest=0;
        ind=-1;
    }
    public synchronized void setListData(String[]str){
        thestrings=str;
        n=thestrings.length;
    }
    public synchronized void addElement(String s){
        String[]thestrings2=new String[n+1];
        for(int i=0;i<n;i++){
            thestrings2[i]=thestrings[i];
        }
        thestrings2[n]=s;
        n=n+1;
        thestrings=thestrings2;
        uppest=n-8;
        if(uppest<0){
            uppest=0;
        }
    }
    public synchronized void removeElementAt(int ind2){
        int n=thestrings.length;
        if(n>0){
            if(ind==ind2){
                ind=-1;
            }
            else if(ind>ind2){
                ind=ind-1;
            }
            String[]thestrings2=new String[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind2){
                }
                else{
                    thestrings2[ib]=thestrings[i];
                    ib=ib+1;
                }
            }
            thestrings=thestrings2;
            this.n=n-1;
            if(uppest+8>=n){
                uppest=uppest-1;
                if(uppest<0){
                    uppest=0;
                }
            }
        }
    }
    public synchronized int getSelectedIndex(){
        return ind;
    }
    public synchronized void click(int x,int y){
        if(x>=10&&x<370&&y>=5&&y<5+16){
            uppest=uppest-1;
            if(uppest<0){
                uppest=0;
            }
        }
        if(x>=10&&x<370&&y>=5+9*16&&y<5+9*16+16){
            uppest=uppest+1;
            if(uppest+8>n){
                uppest=uppest-1;
            }
        }
        if(x>=10&&x<370&&y>=5+16&&y<5+8*16+16){
            int ind2=(y-5-16)/16+uppest;
            if(ind2>=0&&ind2<n){
                ind=ind2;
            }
        }
    }
    public synchronized void paint(Graphics g){
        Graphics h=img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,380,170);
        h.setColor(Color.black);
        for(int i=0;i<10;i++){
            h.setColor(Color.black);
            if(ind==uppest+i-1&&ind!=-1&&i!=0&&i!=9){
                h.setColor(Color.green);
            }
            h.drawRect(10,5+i*16,360,15);
        }
        h.setColor(Color.black);
        if(uppest==0){
            h.setColor(Color.red);
        }
        h.drawString("UP",12,5+14);
        h.setColor(Color.black);
        if(uppest+8>=n){
            h.setColor(Color.red);
        }
        h.drawString("DOWN",12,5+9*16+14);
        h.setColor(Color.black);
        for(int i=0;i<8;i++){
            h.setColor(Color.black);
            if(ind==uppest+i&&ind!=-1){
                h.setColor(Color.green);
            }
            int theindex=uppest+i;
            if(theindex<n){
                h.drawString(thestrings[theindex],12,5+16+i*16+14);
            }
        }
        g.drawImage(img,0,0,this);
    }
}
class GetImgKeyboardMapper extends JFrame{
    Image img;
    private static final long serialVersionUID = -8478639040178665797L;
    public GetImgKeyboardMapper(){
        pack();
        img=createImage(380,170);
    }
}
