import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.awt.event.*;
import javax.swing.*;
public class XspaceWorld extends JApplet implements Runnable,KeyListener,MouseListener{
    Thread t;
    XCanvasXspaceWorld xc;
    Image node;
    Image tunnellr;
    Image tunnelou;
    Image endlab;
    Image solar;
    Image cannon;
    Image komet;
    Image komet2;
    Image komet3;
    Image komet4;
    Image komet5;
    Image gegner;
    Image gegner2;
    Image gegner3;
    Image gegner4;
    Image gegner5;
    boolean selected=false;
    boolean cancel=false;
    int xm=0;
    int ym=0;
    int xmp=0;
    int ymp=0;
    MediaTracker tracker;
    static JApplet app;
    private static final long serialVersionUID = 4830849767778078834L;
    public void init(){
        app=this;
        setSize(640,520);
        setLayout(null);
        xc=new XCanvasXspaceWorld(this);
        add(xc);
        xc.setBounds(0,40,640,480);
        setVisible(true);
        node=getImage("node.gif");
        tunnelou=getImage("tunnelou.gif");
        tunnellr=getImage("tunnellr.gif");
        endlab=getImage("endlab.gif");
        solar=getImage("solar.gif");
        cannon=getImage("cannon.gif");
        komet=getImage("komet.gif");
        komet2=getImage("komet2.gif");
        komet3=getImage("komet3.gif");
        komet4=getImage("komet4.gif");
        komet5=getImage("komet5.gif");
        gegner=getImage("gegner.gif");
        gegner2=getImage("gegner2.gif");
        gegner3=getImage("gegner3.gif");
        gegner4=getImage("gegner4.gif");
        gegner5=getImage("gegner5.gif");
        tracker=new MediaTracker(this);
        tracker.addImage(node,0);
        tracker.addImage(tunnelou,0);
        tracker.addImage(tunnellr,0);
        tracker.addImage(endlab,0);
        tracker.addImage(solar,0);
        tracker.addImage(cannon,0);
        tracker.addImage(komet,0);
        tracker.addImage(komet2,0);
        tracker.addImage(komet3,0);
        tracker.addImage(komet4,0);
        tracker.addImage(komet5,0);
        tracker.addImage(gegner,0);
        tracker.addImage(gegner2,0);
        tracker.addImage(gegner3,0);
        tracker.addImage(gegner4,0);
        tracker.addImage(gegner5,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception me){
        }
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        addMouseListener(this);
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(100);
                if(xc!=null){
                    xc.painted=false;
                    xc.repaint();
                    while(!xc.painted){
                        Thread.yield();
                    }
                }
                if(cancel){
                    cancel=false;
                    selected=false;
                    xm=0;
                    ym=0;
                    xmp=0;
                    ymp=0;
                    remove(xc);
                    xc=new XCanvasXspaceWorld(this);
                    add(xc);
                    xc.setBounds(0,40,640,480);
                }
            }
            catch(Exception exc){
            }
        }
    }
    public static void main(String[]args){
        new XspaceWorld();
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(xc!=null){
            xc.process(this,e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void mousePressed(MouseEvent me) {
        requestFocus();
        if(xc!=null){
            xc.mprocess(this,me);
        }
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==27||key==KeyEvent.VK_ESCAPE){
                cancel=true;
            }
            if(key==KeyEvent.VK_LEFT){
                xc.xd--;
            }
            if(key==KeyEvent.VK_RIGHT){
                xc.xd++;
            }
            if(key==KeyEvent.VK_UP){
                xc.yd--;
            }
            if(key==KeyEvent.VK_DOWN){
                xc.yd++;
            }
    }
    public void mprocess(MouseEvent me){
            if(!selected){
                xm=me.getX()-20;
                ym=me.getY()-60;
                xmp=xm/20;
                ymp=ym/20;
                if(xmp>=0&&ymp>=0&&xmp<30&&ymp<22){
                    if(xc.values[xmp][ymp]==6){
                        selected=true;
                    }
                }
            }
            else{
                int xmb=me.getX()-20;
                int ymb=me.getY()-60;
                xc.shoot(xmp,ymp,xmb,ymb);
                selected=false;
            }
    }
}
class XCanvasXspaceWorld extends JPanel{
    XspaceWorld xw;
    boolean painted=true;
    Image img;
    Graphics h;
    int sizex=512;
    int sizey=512;
    int[]starsx=new int[2048];
    int[]starsy=new int[2048];
    SList slist;
    int xpos=sizex/2-15;
    int ypos=sizey/2-11;
    int[][]values=new int[30][22];
    Kugel[]kugel=new Kugel[256];
    int xd=0;
    int yd=0;
    int xmp=0;
    int ymp=0;
    int xmb=0;
    int ymb=0;
    double x1,y1,x2,y2;
    boolean shoot=false;
    int gegners,komets;
    int modules=1;
    int counter=0;
    int loso=0;
    private static final long serialVersionUID = 4869004261139188948L;
    public XCanvasXspaceWorld(XspaceWorld xw){
        this.xw=xw;
        ImFrameXspaceWorld im=new ImFrameXspaceWorld();
        img=im.img;
        h=img.getGraphics();
        values[15][11]=1;
        slist=new SList();
        createworld();
    }
    public synchronized void process(XspaceWorld xw,KeyEvent e){
        xw.process(e);
    }
    public synchronized void mprocess(XspaceWorld xw,MouseEvent me){
        xw.mprocess(me);
    }
    public void shoot(int xmp,int ymp,int xmb,int ymb){
        this.xmp=xmp;
        this.ymp=ymp;
        this.xmb=xmb;
        this.ymb=ymb;
        shoot=true;
    }
    public void addKugel(double xpos,double ypos,double xdrift,double ydrift,boolean yours){
        int k=0;
        while(k<256&&kugel[k]!=null){
            k++;
        }
        if(k==256){
            k=(int)(Math.random()*256);
        }
        kugel[k]=new Kugel(xpos,ypos,xdrift,ydrift,yours);
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        if(painted){
            return;
        }
        h.setColor(Color.black);
        h.fillRect(0,0,800,600);
        h.setColor(Color.darkGray);
        h.fillRect(80,60,640,20);
        h.fillRect(80,60+460,640,20);
        h.fillRect(80,60,20,540);
        h.fillRect(700,60,20,540);
        h.setColor(Color.white);
        counter=(counter+1)%1;
        if(counter==0){
            xpos=xpos+xd;
            ypos=ypos+yd;
            x1=x1+xd*20;
            y1=y1+yd*20;
        }
        if(xpos<-800){
            loso=5;
        }
        if(ypos<-800){
            loso=5;
        }
        if(xpos>sizex*20+800){
            loso=5;
        }
        if(ypos>sizey*20+800){
            loso=5;
        }
        if(shoot){
            shoot=false;
            x1=xmp*20+10+xpos*20;
            y1=ymp*20+10+ypos*20;
            x2=xmb-xmp*20;
            y2=ymb-ymp*20;
            double entf=Math.sqrt(x2*x2+y2*y2);
            x2=x2/entf*15;
            y2=y2/entf*15;
            addKugel(x1,y1,x2,y2,true);
        }
        for(int i=0;i<2048;i++){
            if(starsx[i]>=xpos*20&&starsx[i]<xpos*20+30*20){
                if(starsy[i]>=ypos*20&&starsy[i]<ypos*20+30*20){
                    h.drawRect(starsx[i]-xpos*20+20+80,starsy[i]-ypos*20+20+60,1,1);
                }
            }
        }
        for(int i=0;i<256;i++){
            if(kugel[i]!=null){
                kugel[i].xpos=kugel[i].xpos+kugel[i].xdrift;
                kugel[i].ypos=kugel[i].ypos+kugel[i].ydrift;
                kugel[i].age--;
                if(kugel[i].age<0){
                    kugel[i]=null;
                }
            }
        }
        for(int j=0;j<256;j++){
            if(kugel[j]!=null&&!kugel[j].yours){
                int xp=(int)(kugel[j].xpos)/20-xpos;
                int yp=(int)(kugel[j].ypos)/20-ypos;
                for(int i1=0;i1<30;i1++){
                    for(int i2=0;i2<22;i2++){
                        if(values[i1][i2]!=0&&xp==i1&&yp==i2){
                            loso=2;
                            kugel[j]=null;
                        }
                    }
                }
            }
        }
        for(int i1=0;i1<30;i1++){
            for(int i2=0;i2<22;i2++){
                if(values[i1][i2]==1){
                    h.drawImage(xw.node,i1*20+20+80,i2*20+20+60,this);
                }
                if(values[i1][i2]==2){
                    h.drawImage(xw.tunnellr,i1*20+20+80,i2*20+20+60,this);
                }
                if(values[i1][i2]==3){
                    h.drawImage(xw.tunnelou,i1*20+20+80,i2*20+20+60,this);
                }
                if(values[i1][i2]==4){
                    h.drawImage(xw.endlab,i1*20+20+80,i2*20+20+60,this);
                }
                if(values[i1][i2]==5){
                    h.drawImage(xw.solar,i1*20+20+80,i2*20+20+60,this);
                }
                if(values[i1][i2]==6){
                    h.drawImage(xw.cannon,i1*20+20+80,i2*20+20+60,this);
                }
            }
        }
        SpaceObject so=slist.start;
        while(so!=null){
            if(!so.inactive){
                if(so.type<=10){
                    if(so.x>=xpos&&so.y>=ypos&&so.x<xpos+30&&so.y<ypos+22){
                        if(so.type==1){
                            h.drawImage(xw.node,(so.x-xpos+1)*20+80,(so.y-ypos+1)*20+60,this);
                        }
                        else if(so.type==2){
                            h.drawImage(xw.tunnellr,(so.x-xpos+1)*20+80,(so.y-ypos+1)*20+60,this);
                        }
                        else if(so.type==3){
                            h.drawImage(xw.tunnelou,(so.x-xpos+1)*20+80,(so.y-ypos+1)*20+60,this);
                        }
                        else if(so.type==4){
                            h.drawImage(xw.endlab,(so.x-xpos+1)*20+80,(so.y-ypos+1)*20+60,this);
                        }
                        else if(so.type==5){
                            h.drawImage(xw.solar,(so.x-xpos+1)*20+80,(so.y-ypos+1)*20+60,this);
                        }
                        else if(so.type==6){
                            h.drawImage(xw.cannon,(so.x-xpos+1)*20+80,(so.y-ypos+1)*20+60,this);
                        }
                        int vtx=so.x-xpos;
                        int vty=so.y-ypos;
                        if(values[vtx][vty]!=0){
                            loso=1;
                        }
                        else{
                            if(vtx-1>=0&&((values[vtx-1][vty]==1&&so.type!=3)||(values[vtx-1][vty]==2&&so.type!=3))){
                                values[vtx][vty]=so.type;
                                so.inactive=true;
                                modules++;
                            }
                            if(vtx+1<30&&((values[vtx+1][vty]==1&&so.type!=3)||(values[vtx+1][vty]==2&&so.type!=3))){
                                values[vtx][vty]=so.type;
                                so.inactive=true;
                                modules++;
                            }
                            if(vty-1>=0&&((values[vtx][vty-1]==1&&so.type!=2)||(values[vtx][vty-1]==3&&so.type!=2))){
                                values[vtx][vty]=so.type;
                                so.inactive=true;
                                modules++;
                            }
                            if(vty+1<22&&((values[vtx][vty+1]==1&&so.type!=2)||(values[vtx][vty+1]==3&&so.type!=2))){
                                values[vtx][vty]=so.type;
                                so.inactive=true;
                                modules++;
                            }
                        }
                    }
                }
                else if(so.type<=20){
                    if(!so.inactive&&so.xpos>=xpos*20&&so.ypos>=ypos*20&&so.xpos<xpos*20+30*20&&so.ypos<ypos*20+22*20){
                        int vtx=(int)(so.xpos/20)-xpos;
                        int vty=(int)(so.ypos/20)-ypos;
                        if(values[vtx][vty]!=0){
                            loso=3;
                            so.inactive=true;
                        }
                        if(so.type==11){
                            h.drawImage(xw.gegner,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==12){
                            h.drawImage(xw.gegner2,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==13){
                            h.drawImage(xw.gegner3,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==14){
                            h.drawImage(xw.gegner4,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==15){
                            h.drawImage(xw.gegner5,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(Math.random()*10<1){
                            addKugel(so.xpos+10,so.ypos+10,so.xdrift*2,so.ydrift*2,false);
                        }
                    }
                    if(!so.inactive){
                        so.xpos=so.xpos+so.xdrift;
                        so.ypos=so.ypos+so.ydrift;
                        if(so.xpos<0){
                            so.xdrift=-so.xdrift;
                        }
                        if(so.ypos<0){
                            so.ydrift=-so.ydrift;
                        }
                        if(so.xpos>sizex*20){
                            so.xdrift=-so.xdrift;
                        }
                        if(so.ypos>sizey*20){
                            so.ydrift=-so.ydrift;
                        }
                        for(int i=0;i<256;i++){
                            if(kugel[i]!=null&&kugel[i].yours){
                                if(kugel[i].xpos>=so.xpos&&kugel[i].ypos>=so.ypos&&kugel[i].xpos<so.xpos+20&&kugel[i].ypos<so.ypos+20){
                                    so.inactive=true;
                                    gegners++;
                                    kugel[i]=null;
                                }
                            }
                        }
                    }
                }
                else if(so.type<=30){
                    if(!so.inactive&&so.xpos>=xpos*20&&so.ypos>=ypos*20&&so.xpos<xpos*20+30*20&&so.ypos<ypos*20+22*20){
                        int vtx=(int)(so.xpos/20)-xpos;
                        int vty=(int)(so.ypos/20)-ypos;
                        if(values[vtx][vty]!=0){
                            loso=4;
                            so.inactive=true;
                        }
                        if(so.type==21){
                            h.drawImage(xw.komet,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==22){
                            h.drawImage(xw.komet2,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==23){
                            h.drawImage(xw.komet3,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==24){
                            h.drawImage(xw.komet4,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                        if(so.type==25){
                            h.drawImage(xw.komet5,(int)(so.xpos-xpos*20+80+20),(int)(so.ypos-ypos*20+60+20),this);
                        }
                    }
                    if(!so.inactive){
                        so.xpos=so.xpos+so.xdrift;
                        so.ypos=so.ypos+so.ydrift;
                        if(so.xpos<0){
                            so.xdrift=-so.xdrift;
                        }
                        if(so.ypos<0){
                            so.ydrift=-so.ydrift;
                        }
                        if(so.xpos>sizex*20){
                            so.xdrift=-so.xdrift;
                        }
                        if(so.ypos>sizey*20){
                            so.ydrift=-so.ydrift;
                        }
                        for(int i=0;i<256;i++){
                            if(kugel[i]!=null&&kugel[i].yours){
                                if(kugel[i].xpos>=so.xpos&&kugel[i].ypos>=so.ypos&&kugel[i].xpos<so.xpos+20&&kugel[i].ypos<so.ypos+20){
                                    so.inactive=true;
                                    komets++;
                                    kugel[i]=null;
                                }
                            }
                        }
                    }
                }
            }
            so=so.next;
        }
        h.setColor(Color.black);
        h.drawLine((int)(x1+20+80-xpos*20),(int)(y1+20+60-ypos*20),(int)(x1+x2+20+80-xpos*20),(int)(y1+y2+20+60-ypos*20));
        h.setColor(Color.white);
        for(int i=0;i<256;i++){
            if(kugel[i]!=null&&kugel[i].xpos>=xpos*20&&kugel[i].ypos>=ypos*20&&kugel[i].xpos<xpos*20+30*20&&kugel[i].ypos<ypos*20+22*20){
                h.fillOval((int)kugel[i].xpos-2-xpos*20+20+80,(int)kugel[i].ypos-2-ypos*20+20+60,4,4);
            }
        }
        if(loso==0){
            h.drawString("Module: "+modules+" Gegner: "+gegners+" Kometen: "+komets,100,100);
            if(loso==0&&modules>=101&&gegners>=100&&komets>=100){
                h.drawString("Gewonnen! Alles erledigt!",100,130);
            }
        }
        else{
            if(loso==5){
                h.drawString("Verloren: Verlassen des Raumsektors!",100,100);
            }
            if(loso==2){
                h.drawString("Verloren: Gegnerischer Treffer!",100,100);
            }
            if(loso==1){
                h.drawString("Verloren: Crash mit Modul!",100,100);
            }
            if(loso==3){
                h.drawString("Verloren: Crash mit Gegner!",100,100);
            }
            if(loso==4){
                h.drawString("Verloren: Crash mit Komet!",100,100);
            }
        }
        g.drawImage(img,-80,-60,this);
//        paint(g);
        painted=true;
    }
    public void createworld(){
        for(int i=0;i<2048;i++){
            starsx[i]=(int)(Math.random()*sizex*20);
            starsy[i]=(int)(Math.random()*sizey*20);
        }
        for(int i=0;i<100;i++){
            int stype=((int)(Math.random()*6))+1;
            int xp=(int)(Math.random()*sizex);
            int yp=(int)(Math.random()*sizey);
            SpaceObject so=new SpaceObject();
            so.type=stype;
            so.x=xp;
            so.y=yp;
            slist.add(so);
        }
        for(int i=0;i<100;i++){
            int ktype=((int)(Math.random()*5))+11;
            double kx=Math.random()*sizex*20;
            double ky=Math.random()*sizey*20;
            double alpha=Math.random()*2*Math.PI;
            double xdrift=Math.cos(alpha)*5;
            double ydrift=Math.sin(alpha)*5;
            SpaceObject so=new SpaceObject();
            so.type=ktype;
            so.xpos=kx;
            so.ypos=ky;
            so.xdrift=xdrift;
            so.ydrift=ydrift;
            slist.add(so);
        }
        for(int i=0;i<100;i++){
            int ktype=((int)(Math.random()*5))+21;
            double kx=Math.random()*sizex*20;
            double ky=Math.random()*sizey*20;
            double alpha=Math.random()*2*Math.PI;
            double xdrift=Math.cos(alpha)*3;
            double ydrift=Math.sin(alpha)*3;
            SpaceObject so=new SpaceObject();
            so.type=ktype;
            so.xpos=kx;
            so.ypos=ky;
            so.xdrift=xdrift;
            so.ydrift=ydrift;
            slist.add(so);
        }
    }
}
class ImFrameXspaceWorld extends JFrame{
    Image img;
    private static final long serialVersionUID = 2857758996227759247L;
    public ImFrameXspaceWorld(){
        pack();
        img=createImage(800,600);
    }
}
class SList{
    SpaceObject start=null;
    SpaceObject end=null;
    public SList(){
    }
    public void add(SpaceObject so){
        if(end==null){
            start=so;
            end=so;
        }
        else{
            end.next=so;
            end=end.next;
        }
    }
}
class SpaceObject{
    int type;
    boolean inactive=false;
    int x;
    int y;
    double xpos;
    double ypos;
    double xdrift;
    double ydrift;
    SpaceObject next;
    public SpaceObject(){
    }
}
class Kugel{
    boolean yours;
    double xpos;
    double ypos;
    double xdrift;
    double ydrift;
    int age;
    public Kugel(double xpos,double ypos,double xdrift,double ydrift,boolean yours){
        this.xpos=xpos;
        this.ypos=ypos;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.yours=yours;
        this.age=50;
    }
}
